<?php

class wpmlShortcodeHelper extends wpMailPlugin {

	var $name = 'Shortcode';

	function wpmlShortcodeHelper() {
		return true;
	}
	
	function raw($atts = array(), $content = null) {
		return do_shortcode($content);
	}
	
	function subscriberscount($atts = array(), $content = null) {
		global $wpdb, $Subscriber;
		$subscriberscount = 0;
		
		$query = "SELECT COUNT(`id`) FROM `" . $wpdb -> prefix . $Subscriber -> table . "`";
		if ($count = $wpdb -> get_var($query)) {
			$subscriberscount = $count;
		}
		
		return $subscriberscount;
	}
	
	function post_thumbnail($atts = array(), $content = null) {	
		global $post;
		$output = "";
		$thepost = (empty($atts['post_id'])) ? $post : get_post($atts['post_id']);
		$atts['post_id'] = $thepost -> ID;
	
		$defaults = array(
			'post_id'			=>	false,
			'size'				=>	"thumbnail",
			'alt'				=>	$thepost -> post_title,
			'link'				=>	$thepost -> guid,
			'title'				=>	$thepost -> post_title,
		);
		
		extract(shortcode_atts($defaults, $atts));
		
		if (function_exists('has_post_thumbnail') && has_post_thumbnail($thepost -> ID)) {
			$output .= (!empty($link)) ? '<a href="' . $link . '" title="' . esc_attr($title) . '">' : '';
			$output .= get_the_post_thumbnail($thepost -> ID, $size, array('title' => $title, 'alt' => $alt));
			$output .= (!empty($link)) ? '</a>' : '';
		}
		
		wp_reset_query();
		return $output;
	}
	
	function post_permalink($atts = array(), $content = null) {
		global $post;
		$output = "";
		$post_id = (empty($atts['post_id'])) ? $post -> ID : $atts['post_id'];
		
		if ($permalink = get_permalink($post_id)) {
			$output .= $permalink;
		}
				
		wp_reset_query();
		return $output;
	}
	
	function posts_single($atts = array(), $content = null) {
		global $post;
		$atts['post_id'] = (empty($atts['post_id'])) ? $post -> ID : $atts['post_id'];
			
		$output = "";
		$defaults = array(
			'post_id'			=> 	false,
			'showdate'			=>	"Y",
			'language'			=>	false,
			'eftype'			=>	"excerpt",
		);
			
		extract(shortcode_atts($defaults, $atts));
		
		$arguments = array(
			'post_id'			=>	$post_id,
			'showdate'			=>	$showdate,
			'language'			=>	$language,
		);
		
		if (!empty($post_id)) {
			if ($post = get_post($post_id)) {
				
				if ($this -> is_plugin_active('qtranslate')) {
					$post = qtrans_use($language, $post, false);
				}
				
				$output = $this -> render('posts', array('posts' => array($post), 'arguments' => $arguments, 'eftype' => $eftype), false, 'default');	
			}
		}
		
		wp_reset_query();
		return $output;
	}
	
	function posts_multiple($atts = array(), $content = null) {
		$output = "";
		
		$defaults = array(
			'numberposts' 			=> 	10, 
			'showdate'				=>	"Y",
			'orderby' 				=> 	"post_date", 
			'order' 				=> 	"DESC", 
			'category' 				=> 	null,
			'language'				=>	false,
			'post_type'				=>	"post",
			'eftype'				=>	"excerpt",
		);
		
		$arguments = shortcode_atts($defaults, $atts);
		if (empty($arguments['category'])) { $arguments['category'] = false; }
		
		if (!empty($arguments['post_type'])) {
			if (($new_post_types = @explode(",", $arguments['post_type'])) !== false) {
				$arguments['post_type'] = $new_post_types;
			}
		}
							   
		if ($posts = get_posts($arguments)) {
			if ($this -> is_plugin_active('qtranslate')) {
				foreach ($posts as $pkey => $post) {
					$posts[$pkey] = qtrans_use($arguments['language'], $post, false);
				}
			}
			
			$output = $this -> render('posts', array('posts' => $posts, 'arguments' => $arguments, 'eftype' => $arguments['eftype']), false, 'default');	
		}
		
		wp_reset_query();
		return $output;
	}
	
	function datestring($atts = array(), $content = null) {	
		$defaults = array('format' => "%d/%m/%Y");
		extract(shortcode_atts($defaults, $atts));
		
		//$output = date($format, time());
		$output = strftime($format, time());
		return $output;
	}
	
	function template($atts = array(), $content = null) {
		global $wpdb, $Template;
	
		$defaults = array('id' => false);
		extract(shortcode_atts($defaults, $atts));
		
		if (!empty($id)) {
			$templatequery = "SELECT * FROM " . $wpdb -> prefix . $Template -> table . " WHERE id = '" . $id . "' LIMIT 1";
		
			if ($template = $wpdb -> get_row($templatequery)) {
				$output = wpautop($template -> content);
			}
		}
		
		return $output;
	}
	
	function history($atts = array(), $content = null) {
		global $wpdb, $Db, $History, $HistoriesList;
	
		$defaults = array('number' => false, 'order' => "DESC", 'orderby' => "modified", 'list_id' => false, 'index' => true);
		extract(shortcode_atts($defaults, $atts));
		
		$listscondition = "";
		$l = 1;
		
		if (!empty($list_id)) {
			if ($mailinglists = explode(",", $list_id)) {
				$listscondition = " (";
				
				foreach ($mailinglists as $mailinglist_id) {
					$listscondition .= "" . $wpdb -> prefix . $HistoriesList -> table . ".list_id = '" . $mailinglist_id . "'";
					
					if (count($mailinglists) > $l) {
						$listscondition .= " OR ";	
					}
					
					$l++;
				}
				
				$listscondition .= ")";
			}
		} else {
			$listscondition = " 1 = 1";
		}
		
		$query = "SELECT DISTINCT " . $wpdb -> prefix . $HistoriesList -> table . ".history_id, " .
		$wpdb -> prefix . $History -> table . ".id, " .
		$wpdb -> prefix . $History -> table . ".message, " .
		$wpdb -> prefix . $History -> table . ".modified, " . 
		$wpdb -> prefix . $HistoriesList -> table . ".history_id, " . $wpdb -> prefix . $History -> table . ".subject FROM `" . $wpdb -> prefix . $HistoriesList -> table . "` LEFT JOIN `" . 
		$wpdb -> prefix . $History -> table . "` ON " . 
		$wpdb -> prefix . $HistoriesList -> table . ".history_id = " . $wpdb -> prefix . $History -> table . ".id" .
		" WHERE" . $listscondition . " AND " . $wpdb -> prefix . $History -> table . ".sent > '0'" .
		" ORDER BY " . $wpdb -> prefix . $History -> table . "." . $orderby . " " . $order . "";
		if (!empty($number)) { $query .= " LIMIT " . $number . ""; }	
		
		if ($emails = $wpdb -> get_results($query)) {
			$content = $this -> render('history', array('emails' => $emails, 'history_index' => $index), false, 'default');
			$content = do_shortcode($content);
			return $content;
		}
		
		return $content;
	}
	
	function meta($atts = array(), $content = null) {
		$defaults = array('post_id' => false);
		extract(shortcode_atts($defaults, $atts));
		
		if (!empty($post_id)) {
			global $post_ID;
			$oldpostid = $post_ID;
			$post_ID = $post_id;
			
			ob_start();
			the_meta();
			$content = ob_get_clean();
			
			$post_ID = $oldpostid;
		}
	
		return $content;
	}
	
	function subscribe($atts = array(), $content = null) {
		if (is_feed()) {
			return;	
		}
		
		$defaults = array('type' => "select", 'id' => false);
		extract(shortcode_atts($defaults, $atts));
		
		$wpoptinid = (empty($_GET[$this -> pre . 'formid'])) ? (time() * rand(1,999)) : $_GET[$this -> pre . 'formid'];
		$options = $this -> get_option('embed');
		
		if ($this -> is_plugin_active('qtranslate')) {
			global $q_config;
			
			foreach ($options as $okey => $oval) {
				if (!empty($options[$okey]) && is_array($options[$okey])) {
					$options[$okey] = $options[$okey][$q_config['language']];	
				}
			}
			
			$options['language'] = $q_config['language'];
		}
		
		switch ($type) {
			case 'list'			:
				$listid = $id;
				break;
			case 'multiple'		:
			case 'checkboxes'	:
				$listid = "checkboxes";
				if (!empty($id) && ($lists = @explode(",", $id)) !== false) { $options['lists'] = $lists; $options['listsstring'] = $id; };
                break;
			case 'language'		:
				$listid = "language";
				break;
			default				:
				$listid = "select";
				if (!empty($id) && ($lists = @explode(",", $id)) !== false) { $options['lists'] = $lists; $options['listsstring'] = $id; };
				break;
		}
		
		$subscriber = false;
		$errors = false;
		
		if ($options['ajax'] == "N") {
			$subscriber = $this -> init_class($Subscriber -> model, $_POST);
			$errors = $this -> post_errors;
		}
		
		$options['embed'] = true;
		$options['list'] = $listid;
		
		ob_start();
		
		?>
		
		<div class="<?php echo $this -> pre; ?>widget <?php echo $this -> pre; ?>" id="<?php echo $this -> pre; ?>widget-<?php echo $wpoptinid; ?>">		
		<?php $this -> render('widget-front', array('options' => $options, 'wpoptinid' => $wpoptinid, 'subscriber' => $this -> init_class($Subscriber -> model, $_POST), 'errors' => $this -> Subscriber -> error), true, 'default'); ?>
		</div>
		
		<?php
		
		$content = ob_get_clean();	
		return $content;
	}
	
	/* The Mailer theme shortcodes */
	function themailer_address($atts = array(), $content = null) {
		return nl2br(stripslashes($this -> get_option('themailer_address')));
	}
	
	function themailer_facebookurl($atts = array(), $content = null) {
		return $this -> get_option('themailer_facebook');
	}
	
	function themailer_twitterurl($atts = array(), $content = null) {
		return $this -> get_option('themailer_twitter');
	}
	
	function themailer_rssurl($atts = array(), $content = null) {
		return $this -> get_option('themailer_rss');
	}
	
	/* Pro News theme shortcodes */
	function pronews_address($atts = array(), $content = null) {
		return nl2br(stripslashes($this -> get_option('pronews_address')));
	}
	
	function pronews_facebookurl($atts = array(), $content = null) {
		return $this -> get_option('pronews_facebook');
	}
	
	function pronews_twitterurl($atts = array(), $content = null) {
		return $this -> get_option('pronews_twitter');
	}
	
	function pronews_rssurl($atts = array(), $content = null) {
		return $this -> get_option('pronews_rss');
	}
	
	/* Lagoon theme shortcodes */
	function lagoon_address($atts = array(), $content = null) {
		return nl2br(stripslashes($this -> get_option('lagoon_address')));
	}
	
	function lagoon_facebookurl($atts = array(), $content = null) {
		return $this -> get_option('lagoon_facebook');
	}
	
	function lagoon_twitterurl($atts = array(), $content = null) {
		return $this -> get_option('lagoon_twitter');
	}
	
	function lagoon_rssurl($atts = array(), $content = null) {
		return $this -> get_option('lagoon_rss');
	}
}

?>