<?php

class wpmlHistory extends wpMailPlugin {

	var $id;
	var $subject;
	var $message;
	var $list_id;
	var $theme_id = 0;
	var $group;
	var $attachment;
	var $attachmentfile;
	var $error = array();
	var $model = 'History';
	var $controller = 'history';
	var $table_name = 'wpmlhistory';
	
	var $table_fields = array(
		'id'				=> 	"INT(11) NOT NULL AUTO_INCREMENT",
		'subject'			=>	"VARCHAR(150) NOT NULL DEFAULT ''",
		'message'			=>	"LONGTEXT NOT NULL",
		'mailinglists'		=>	"TEXT NOT NULL",
		'groups'			=>	"TEXT NOT NULL",
		'theme_id'			=>	"INT(11) NOT NULL DEFAULT '0'",
		'conditions'		=>	"TEXT NOT NULL",
		'sent'				=>	"INT(11) NOT NULL DEFAULT '0'",
		'post_id'			=>	"INT(11) NOT NULL DEFAULT '0'",
		'user_id'			=>	"INT(11) NOT NULL DEFAULT '0'",
		'created'			=>	"DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00'",
		'modified'			=>	"DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00'",
		'key'				=>	"PRIMARY KEY (`id`)",
	);
	
	var $tv_fields = array(
		'id'				=> 	array("INT(11)", "NOT NULL AUTO_INCREMENT"),
		'subject'			=>	array("VARCHAR(150)", "NOT NULL DEFAULT ''"),
		'message'			=>	array("LONGTEXT", "NOT NULL"),
		'mailinglists'		=>	array("TEXT", "NOT NULL"),
		'groups'			=>	array("TEXT", "NOT NULL"),
		'theme_id'			=>	array("INT(11)", "NOT NULL DEFAULT '0'"),
		'conditions'		=>	array("TEXT", "NOT NULL"),
		'sent'				=>	array("INT(11)", "NOT NULL DEFAULT '0'"),
		'post_id'			=>	array("INT(11)", "NOT NULL DEFAULT '0'"),
		'user_id'			=>	array("INT(11)", "NOT NULL DEFAULT '0'"),
		'created'			=>	array("DATETIME", "NOT NULL DEFAULT '0000-00-00 00:00:00'"),
		'modified'			=>	array("DATETIME", "NOT NULL DEFAULT '0000-00-00 00:00:00'"),
		'key'				=>	"PRIMARY KEY (`id`)",					   
	);
	
	function wpmlHistory($data = array()) {
		global $Db, $HistoriesList, $Mailinglist, $HistoriesAttachment;
	
		$this -> table = $this -> pre . $this -> controller;	
	
		if (!empty($data)) {
			foreach ($data as $key => $val) {
				$this -> {$key} = stripslashes_deep($val);
				
				switch ($key) {
					case 'groups'			:
						$this -> groups = maybe_unserialize($val);
						break;	
				}
			}
			
			/* Attachments */
			$this -> attachments = array();
			$Db -> model = $HistoriesAttachment -> model;
			if ($attachments = $Db -> find_all(array('history_id' => $this -> id))) {
				foreach ($attachments as $attachment) {
					$this -> attachments[] = array(
						'id'					=>	$attachment -> id,
						'title'					=>	$attachment -> title,
						'filename'				=>	$attachment -> filename,
					);	
				}
			}
			
			/* Mailing Lists */
			$this -> mailinglists = false;
			$Db -> model = $HistoriesList -> model;
			
			if ($historieslists = $Db -> find_all(array('history_id' => $this -> id))) {			
				foreach ($historieslists as $hl) {
					$Db -> model = $Mailinglist -> model;
				
					if ($list = $Db -> find(array('id' => $hl -> list_id))) {
						$this -> mailinglists[] = $hl -> list_id;
					}
				}
			}
		}
		
		$Db -> model = $this -> model;
		return true;
	}
	
	/**
	 * Counts the number of history emails archived.
	 * @return INT the number of history emails
	 *
	 */
	function count() {
		global $wpdb;
		
		if ($count = $wpdb -> get_var("SELECT COUNT(`id`) FROM `" . $wpdb -> prefix . "" . $this -> table_name . "`")) {
			return $count;
		} else {
			return 0;
		}
	}
	
	/**
	 * Saves a history record.
	 * Used for both INSERT and UPDATE queries
	 * @param ARRAY. An array of posted data
	 * @param BOOLEAN. Determines whether $data should be validated or not
	 *
	 */
	function save($data = array(), $validate = true) {
		global $wpdb, $Html, $Db, $HistoriesList;
		
		$errors = false;
		
		$defaults = array(
			'theme_id'			=>		0,
			'attachment'		=>		"N",
			'attachmentfile'	=>		"",
			'sent'				=>		0,
			'created' 			=> 		$Html -> gen_date(), 
			'modified' 			=> 		$Html -> gen_date()
		);
		
		$data = (empty($data[$this -> model])) ? $data : $data[$this -> model];
		//$r = wp_parse_args($defaults, $data);
		$r = wp_parse_args($data, $defaults);
		$this -> data = (array) $this -> data;
		$this -> data[$this -> model] = $this -> array_to_object($r);		
		extract($r, EXTR_SKIP);
	
		//check if validation is necessary
		if ($validate == true) {
			if (empty($subject)) { $this -> errors['subject'] = __('No subject specified', $this -> name); }
			if (empty($message)) { $this -> errors['message'] = __('No message specified', $this -> name); }
			if (empty($mailinglists) || !is_array($mailinglists)) { $this -> errors['mailinglists'] = __('No mailing lists specified', $this -> name); }
		}
		
		//ensure that there are no errors.
		if (empty($this -> errors)) {		
			//check if an ID was passed.
			if (!empty($id)) {
				$query = "UPDATE `" . $wpdb -> prefix . "" . $this -> table_name . "` SET";
				$c = 1;
				unset($this -> table_fields['key']);
				unset($this -> table_fields['created']);
				
				foreach (array_keys($this -> table_fields) as $field) {				
					switch ($field) {
						case 'user_id'			:
							global $user_ID;
							$user_id = $user_ID;
							break;
						case 'mailinglists'		:
							if (!empty($mailinglists) && is_array($mailinglists)) {
								$mailinglists = serialize($mailinglists);
							}
							break;
						case 'modified'			:
							${$field} = $Html -> gen_date();
							break;
					}
				
					$query .= " `" . $field . "` = '" . $wpdb -> escape(${$field}) . "'";
					
					if ($c < count($this -> table_fields)) {
						$query .= ", ";
					}
					
					$c++;
				}
				
				$query .= " WHERE `id` = '" . $id . "'";
			} else {
				$query1 = "INSERT INTO `" . $wpdb -> prefix . "" . $this -> table_name . "` (";
				$query2 = "";
				$c = 1;
				
				unset($this -> table_fields['key']);
				unset($this -> table_fields['id']);
				
				foreach (array_keys($this -> table_fields) as $field) {				
					switch ($field) {
						case 'mailinglists'		:
							if (!empty($mailinglists) && is_array($mailinglists)) {
								$mailinglists = serialize($mailinglists);
							}
							break;
						case 'user_id'			:
							global $user_ID;
							$user_id = $user_ID;
							break;
					}
				
					$query1 .= "`" . $field . "`";
					$query2 .= "'" . $wpdb -> escape(${$field}) . "'";
					
					if ($c < count($this -> table_fields)) {
						$query1 .= ", ";
						$query2 .= ", ";
					}
					
					$c++;
				}
				
				$query1 .= ") VALUES (";
				$query = $query1 . $query2 . ")";
			}
						
			//execute the INSERT or UPDATE query
			if ($wpdb -> query($query)) {
				//the query was successful
				$this -> insertid = (empty($id)) ? $wpdb -> insert_id : $id;
				
				/* attachments */
				if (!empty($newattachments)) {
					global $Db, $HistoriesAttachment;
					
					foreach ($newattachments as $akey => $newattachment) {
						$newattachment['history_id'] = $this -> insertid;						
						$Db -> model = $HistoriesAttachment -> model;
						$Db -> save($newattachment, true);
					}
				}
				
				/* mailing lists */
				$mailinglists = @unserialize($mailinglists);
				if (!empty($mailinglists) && is_array($mailinglists)) {
					$Db -> model = $HistoriesList -> model;
					$Db -> delete_all(array('history_id' => $this -> insertid));
							
					foreach ($mailinglists as $list_id) {
						$Db -> model = $HistoriesList -> model;
						
						if (!$Db -> find(array('history_id' => $this -> insertid, 'list_id' => $list_id))) {
							$hl_data = array(
								'HistoriesList'			=>	array(
									'history_id'			=>	$this -> insertid,
									'list_id'				=>	$list_id,
								)
							);
							
							$Db -> save($hl_data, true);
						}
					}
				}
				
				return true;
			}
		}
		
		return false;
	}
	
	/**
	 * Retrieves a single history record by ID.
	 * @param INT. The ID of the record to fetch
	 * @param BOOLEAN/OBJ.
	 *
	 */
	function get($history_id = '', $assign = true) {
		global $wpdb;
		
		if (!empty($history_id)) {
			if ($history = $wpdb -> get_row("SELECT * FROM `" . $wpdb -> prefix . "" . $this -> table_name . "` WHERE `id` = '" . $history_id . "' LIMIT 1")) {
				$history = $this -> init_class($this -> model, $history);
				
				if ($assign == true) {
					$this -> data[$this -> model] = $history;
				}
				
				return $history;
			}
		}
		
		return false;
	}
	
	/**
	 * Retrieves the very first history email ever created.
	 * Simply orders records by "created" date in an ascending manner.
	 * @return OBJ an object with the history email's values.
	 *
	 */
	function get_first($assign = true) {
		global $wpdb;
		
		if ($email = $wpdb -> get_row("SELECT * FROM `" . $wpdb -> prefix . "" . $this -> table_name . "` ORDER BY `created` ASC LIMIT 1")) {
			if (!empty($email)) {
				$history = $this -> init_class($this -> model, $email);
				
				if ($assign == true) {
					$this -> data[$this -> model] = $history;
				}
				
				return $history;
			}
		}
		
		return false;
	}
	
	function get_latest($assign = true) {
		global $wpdb;
		
		if ($email = $wpdb -> get_row("SELECT * FROM `" . $wpdb -> prefix . "" . $this -> table_name . "` ORDER BY `created` DESC LIMIT 1")) {
			if (!empty($email)) {
				$history = $this -> init_class($this -> model, $email);
				
				if ($assign == true) {
					$this -> data[$this -> model] = $history;
				}
				
				return $history;
			}
		}
	}
	
	/**
	 * Retrieve all history emails in a paginated manner.
	 * Checks for $_GET['wpmlpage'] to control pagination
	 * @return $data ARRAY an array with history Objects.
	 *
	 */
	function get_all_paginated($conditions = array(), $searchterm = null, $sub = 'newsletters-history', $perpage = 15, $order = array('modified', "DESC")) {
		global $wpdb;
		
		$paginate = new wpMailPaginate($wpdb -> prefix . "" . $this -> table_name . "", "*", $sub, $sub);
		$paginate -> per_page = $perpage;
		$paginate -> where = (empty($conditions)) ? false : $conditions;
		$paginate -> searchterm = (empty($searchterm)) ? false : $searchterm;
		$paginate -> order = $order;
		$histories = $paginate -> start_paging($_GET[$this -> pre . 'page']);
		
		$data = array();
		$data['Pagination'] = $paginate;
		
		if (!empty($histories)) {
			foreach ($histories as $email) {
				$data[$this -> model][] = $this -> init_class($this -> model, $email);
			}
		}
		
		return $data;
	}
	
	/**
	 * Deletes a single history record by ID.
	 * @param INT. The ID of the record to remove
	 * @return BOOLEAN
	 *
	 */
	function delete($id = '') {
		global $wpdb;
	
		if (!empty($id)) {
			if ($wpdb -> query("DELETE FROM `" . $wpdb -> prefix . "" . $this -> table_name . "` WHERE `id` = '" . $id . "' LIMIT 1")) {
				return true;
			}
		}
		
		return false;
	}
	
	/**
	 * Removes multiple history email records.
	 * Makes use of the History::delete() method to delete records.
	 * @param $data ARRAY an array of history ID values.
	 * @return BOOLEAN either true or false depending on whether the operation was successful or not.
	 *
	 */
	function delete_array($data = array()) {
		global $wpdb;
		
		if (!empty($data)) {
			foreach ($data as $history_id) {
				$this -> delete($history_id);
			}
			
			return true;
		}
		
		return false;
	}
	
	function truncate() {
		global $wpdb;
		
		$query = "TRUNCATE TABLE `" . $wpdb -> prefix . "" . $this -> table . "`";
		
		if ($wpdb -> query($query)) {
			return true;
		}
		
		return false;
	}
	
	function select() {
		global $Db;
		$historyselect = array();
		$Db -> model = $this -> model;
		
		if ($histories = $Db -> find_all(false, false, array('modified', "DESC"))) {
			foreach ($histories as $history) {
				$historyselect[$history -> id] = $history -> id . ' - ' . $history -> subject . ' (' . date("Y-m-d", strtotime($history -> modified)) . ')';
			}
		}
		
		return $historyselect;
	}
}

?>