<?php

class wpmlMailinglist extends wpMailPlugin {

	var $name = 'mailinglist';
	var $controller = 'mailinglists';
	var $model = 'Mailinglist';	
	var $table_name = 'wpmlmailinglists';
	
	var $fields = array(
		'id'			=>	"INT(11) NOT NULL AUTO_INCREMENT",
		'title'			=>	"VARCHAR(100) NOT NULL DEFAULT ''",
		'privatelist'	=>	"ENUM('Y','N') NOT NULL DEFAULT 'N'",
		'paid'			=>	"ENUM('Y','N') NOT NULL DEFAULT 'N'",
		'price'			=>	"FLOAT NOT NULL DEFAULT '0.00'",
		'tcoproduct'	=>	"INT(11) NOT NULL DEFAULT '0'",
		'interval'		=>	"ENUM('daily', 'weekly', 'monthly', '2months', '3months', 'biannually', '9months', 'yearly', 'once') NOT NULL DEFAULT 'monthly'",
		'group_id'		=>	"INT(11) NOT NULL DEFAULT '0'",
		'adminemail'	=>	"VARCHAR(100) NOT NULL DEFAULT ''",
		'created'		=>	"DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00'",
		'modified'		=>	"DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00'",
		'key'			=>	"PRIMARY KEY (`id`)",
	);
	
	var $tv_fields = array(
		'id'			=>	array("INT(11)", "NOT NULL AUTO_INCREMENT"),
		'title'			=>	array("VARCHAR(100)", "NOT NULL DEFAULT ''"),
		'privatelist'	=>	array("ENUM('Y','N')", "NOT NULL DEFAULT 'N'"),
		'paid'			=>	array("ENUM('Y','N')", "NOT NULL DEFAULT 'N'"),
		'price'			=>	array("FLOAT", "NOT NULL DEFAULT '0.00'"),
		'tcoproduct'	=>	array("INT(11)", "NOT NULL DEFAULT '0'"),
		'interval'		=>	array("ENUM('daily', 'weekly', 'monthly', '2months', '3months', 'biannually', '9months', 'yearly', 'once')", "NOT NULL DEFAULT 'monthly'"),
		'group_id'		=> 	array("INT(11)", "NOT NULL DEFAULT '0'"),
		'adminemail'	=>	array("VARCHAR(100)", "NOT NULL DEFAULT ''"),
		'created'		=>	array("DATETIME", "NOT NULL DEFAULT '0000-00-00 00:00:00'"),
		'modified'		=>	array("DATETIME", "NOT NULL DEFAULT '0000-00-00 00:00:00'"),
		'key'			=>	"PRIMARY KEY (`id`)",					   
	);
	
	var $id = 0;
	var $title;
	var $privatelist = "N";
	var $paid = "N";
	var $price = "0.00";
	var $tcoproduct = 0;
	var $interval = "daily";
	var $created = "0000-00-00 00:00:00";
	var $modified = "0000-00-00 00:00:00";
	
	function wpmlMailinglist($data = array()) {
		global $wpdb, $Db, $FieldsList, $wpmlGroup;
	
		$this -> table = $this -> pre . $this -> controller;	
	
		if (!empty($data)) {
			foreach ($data as $key => $val) {
				$this -> {$key} = stripslashes_deep($val);
				
				switch ($key) {
					case 'group_id'			:
						if (!empty($val)) {
							$Db -> model = $wpmlGroup -> model;
							$this -> group = $Db -> find(array('id' => $val));	
						}
						break;	
				}
			}

            $this -> cfields = array();
			if ($fieldslists = $FieldsList -> find_all(array('list_id' => $this -> id))) {
                $f = 0;

				foreach ($fieldslists as $fl) {
				    $this -> fields[$f] = $fl -> field_id;
                    $f++;
				}
			}
		}
		
		if ($this -> get_option('defaultlistcreated') == "N") {
			$list_data = array('title' => __('Default List', $this -> plugin_name), 'privatelist' => "N");
			
			if (!$wpdb -> get_var("SELECT `id` FROM `" . $wpdb -> prefix . $this -> table . "` WHERE `title` = 'Default List'")) {
				if ($this -> save($list_data)) {
					$this -> update_option('defaultlistcreated', "Y");
				}
			}
		}
		
		$Db -> model = $this -> model;
		return;
	}
	
	/**
	 * Counts all the mailinglist records.
	 * @return INT the number of mailing list records.
	 *
	 */
	function count($conditions = array()) {
		global $wpdb;
		$query = "SELECT COUNT(`id`) FROM `" . $wpdb -> prefix . "" . $this -> table_name . "`";
		
		if (!empty($conditions)) {
			$query .= " WHERE";
			$c = 1;
			
			foreach ($conditions as $ckey => $cval) {
				$query .= " `" . $ckey . "` = '" . $cval . "'";
				
				if (count($conditions) > $c) {
					$query .= " AND";
				}
				
				$c++;
			}
		}
		
		if ($count = $wpdb -> get_var($query)) {
			return $count;
		}
		
		return 0;
	}
	
	function get($mailinglist_id = null, $assign = true) {
		global $wpdb;
		
		if (!empty($mailinglist_id)) {
			if ($list = $wpdb -> get_row("SELECT * FROM `" . $wpdb -> prefix . "" . $this -> table_name . "` WHERE `id` = '" . $mailinglist_id . "' LIMIT 1")) {
				$data = $this -> init_class($this -> model, $list);
				
				if ($assign == true) {
					$this -> data = array($this -> model => $data);				
				}
					
				return $data;
			}
		}
		
		return false;
	}
	
	function get_by_subscriber_id($subscriber_id = null) {
		global $wpdb;
		
		if (!empty($subscriber_id)) {
			if ($subscriber = $this -> Subscriber -> get($subscriber_id)) {
				if ($mailinglist = $this -> get($subscriber -> list_id)) {
					return $this -> init_class('wpmlMailinglist', $mailinglist);
				}
			}
		}
		
		return false;
	}
	
	function select($privatelists = false, $ids = null) {
		global $wpdb, $Html;
		
		$privatecond = ($privatelists == true) ? "WHERE 1 = 1" : "WHERE `privatelist` = 'N'";
		
		if (!empty($ids) && is_array($ids)) {
			$p = 1;
			$privatecond .= " AND (";
		
			foreach ($ids as $id) {
				$privatecond .= "id = '" . $id . "'";
				if ($p < count($ids)) { $privatecond .= " OR "; }
				$p++;
			}
			
			$privatecond .= ")";
		}
		
        $query = "SELECT `id`, `title`, `paid`, `price`, `interval` FROM `" . $wpdb -> prefix . "" . $this -> table_name . "` " . $privatecond . " ORDER BY `title` ASC";

		if ($lists = $wpdb -> get_results($query)) {
			if (!empty($lists)) {			
				$listselect = array();
				$this -> intervals = $this -> get_option('intervals');
				
				foreach ($lists as $list) {
					$paid = ($list -> paid == "Y") ? ' (' . __('Paid', $this -> name) . ': ' . $Html -> currency() . '' . number_format($list -> price, 2, '.', '') . ' ' . $this -> intervals[$list -> interval] . ')' : '';
					$listselect[$list -> id] = $list -> title . $paid;
				}
				
				return $listselect;
			}
		}
		
		return false;
	}
	
	/**
	 * Checks whether or not a list exists.
	 * Simply executes a query and checks for an ID value.
	 * @param INT the ID of the mailing list record to check for.
	 * @return BOOLEAN either true or false is returned
	 *
	 */
	function list_exists($list_id = null) {
		global $wpdb;
	
		if (!empty($list_id)) {
			if ($list = $wpdb -> get_row("SELECT * FROM `" . $wpdb -> prefix . "" . $this -> table_name . "` WHERE `id` = '" . $list_id . "'")) {
				new Mailinglist($list);
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	function get_title_by_id($id = null) {
		global $wpdb;
	
		if (!empty($id)) {
			if ($title = $wpdb -> get_var("SELECT `title` FROM `" . $wpdb -> prefix . "" . $this -> table_name . "` WHERE `id` = '" . $id . "' LIMIT 1")) {
				return $title;
			}
		}
		
		return false;
	}
	
	function get_all($fields = '*', $privatelists = false) {
		global $wpdb;
		
		$privatecond = ($privatelists == true) ? "" : "WHERE `privatelist` = 'N'";
		
		if ($lists = $wpdb -> get_results("SELECT " . $fields . " FROM `" . $wpdb -> prefix . "" . $this -> table_name . "` " . $privatecond . " ORDER BY `title` ASC")) {
			if (!empty($lists)) {
				$data = array();
			
				foreach ($lists as $list) {
					$data[] = $this -> init_class('wpmlMailinglist', $list);
				}
				
				return $data;
			}
		}
		
		return false;
	}
	
	function get_all_paginated($conditions = array(), $searchterm = null, $sub = 'newsletters-lists', $perpage = 15, $order = array('modified', "DESC")) {
		global $wpdb;
		
		$paginate = new wpMailPaginate($wpdb -> prefix . "" . $this -> table_name, "*", $sub);
		$paginate -> per_page = $perpage;
		$paginate -> searchterm = (empty($searchterm)) ? false : $searchterm;
		$paginate -> where = (empty($conditions)) ? false : $conditions;
		$paginate -> order = $order;
		$lists = $paginate -> start_paging($_GET[$this -> pre . 'page']);
		
		$data = array();
		$data['Pagination'] = $paginate;
		
		if (!empty($lists)) {
			foreach ($lists as $list) {
				$data['Mailinglist'][] = $this -> init_class('wpmlMailinglist', $list);
			}
		}
		
		return $data;
	}
	
	function save($data = array(), $validate = true) {
		global $wpdb, $FieldsList;
		
		$defaults = array(
			'group_id'		=>	0,
			'paid' 			=>	 "N"
		);
		
		$data = (empty($data[$this -> model])) ? $data : $data[$this -> model];
		$r = wp_parse_args($data, $defaults);
		$this -> data = array();
		$this -> data[$this -> model] = (object) $r;
		extract($r, EXTR_SKIP);
	
		if (!empty($data)) {
			if ($validate == true) {
				if (empty($title)) { $this -> errors['title'] = __('Please fill in a title', $this -> plugin_name); }
				if (empty($privatelist)) { $this -> errors['privatelist'] = __('Please select private status', $this -> plugin_name); }
				
				if (empty($paid)) {
					$this -> errors['paid'] = __('Please select a paid status', $this -> plugin_name);
				} else {
					if ($paid == "Y") {
						if ($this -> get_option('paymentmethod') == "2co") {
							if (empty($tcoproduct)) { $this -> errors['tcoproduct'] = __('Please fill in a valid 2Checkout product ID', $this -> plugin_name); }
						}
						
						if (empty($interval)) { $this -> errors['interval'] = __('Please select a subscription interval', $this -> plugin_name); }
						if (empty($price)) { $this -> errors['price'] = __('Please fill in a subscription price', $this -> plugin_name); }
					}
				}
			}
			
			if (empty($this -> errors)) {
				$created = $modified = $this -> gen_date();
			
				$query = (!empty($id)) ?
				"UPDATE `" . $wpdb -> prefix . "" . $this -> table_name . "` SET `title` = '" . $title . "', `group_id` = '" . $group_id . "', `adminemail` = '" . $adminemail . "', `privatelist` = '" . $privatelist . "', `paid` = '" . $paid . "', `tcoproduct` = '" . $tcoproduct . "', `price` = '" . $price . "', `interval` = '" . $interval . "', `modified` = '" . $modified . "' WHERE `id` = '" . $id . "' LIMIT 1" :
				"INSERT INTO `" . $wpdb -> prefix . "" . $this -> table_name . "` (`title`, `group_id`, `adminemail`, `privatelist`, `paid`, `tcoproduct`, `price`, `interval`, `created`, `modified`) VALUES ('" . $title . "', '" . $group_id . "', '" . $adminemail . "', '" . $privatelist . "', '" . $paid . "', '" . $tcoproduct . "', '" . $price . "', '" . $interval . "', '" . $created . "', '" . $modified . "');";
				
				if ($wpdb -> query($query)) {
					$this -> insertid = (empty($id)) ? $wpdb -> insert_id : $id;
					
					if (!empty($fields)) {
						$FieldsList -> delete_all(array('list_id' => $this -> insertid));
					
						foreach ($fields as $field_id) {
							$fl_data = array('field_id' => $field_id, 'list_id' => $this -> insertid);						
							$FieldsList -> save($fl_data, true);
						}
					}
					
					return true;
				}
			}
		}
		
		return false;
	}
	
	function gen_expiration_date($subscriber_id = null, $list_id = null) {
		global $wpdb, $Subscriber, $SubscribersList;
		
		if (!empty($subscriber_id) && !empty($list_id)) {
			if ($subscriberslist = $SubscribersList -> find(array('subscriber_id' => $subscriber_id, 'list_id' => $list_id))) {
				if ($mailinglist = $this -> get($list_id, false)) {
					if ($subscriberslist -> paid == "Y" || !empty($subscriberslist -> paid_date)) {
						switch ($mailinglist -> interval) {
							case 'daily'					:
								$intervalstring = "-1 day";
								break;
							case 'weekly'					:
								$intervalstring = "-1 week";
								break;
							case 'monthly'					:
								$intervalstring = "-1 month";
								break;
							case '2months'					:
								$intervalstring = "-2 months";
								break;
							case '3months'					:
								$intervalstring = "-3 months";
								break;
							case 'biannually'				:
								$intervalstring = "-6 months";
								break;
							case '9months'					:
								$intervalstring = "-9 months";
								break;
							case 'yearly'					:
								$intervalstring = "-1 year";
								break;
							case 'once'						:
							default							:
								$intervalstring = "-99 years";
								break;
						}
					
						$paiddate = strtotime($subscriberslist -> paid_date);
						$expiry = time() - strtotime($intervalstring);
						$expiration = $paiddate + $expiry;
						$expiration = $this -> gen_date("Y-m-d H:i:s", $expiration);
						
						return $expiration;
					}
				}
			}
		}
		
		return false;
	}
	
	function save_field($field = null, $value = null, $id = null) {
		global $wpdb;
	
		if (!empty($field) && !empty($value)) {
			$list_id = (empty($id)) ? $this -> id : $id;
			$query = "UPDATE `" . $wpdb -> prefix . "" . $this -> table_name . "` SET `" . $field . "` = '" . $value . "' WHERE `id` = '" . $list_id . "'";
			
			if ($wpdb -> query($query)) {
				return true;
			}
		}
		
		return false;
	}
	
	function delete($mailinglist_id = null) {
		global $wpdb, $Db, $SubscribersList, $FieldsList, $HistoriesList;
	
		if (!empty($mailinglist_id)) {
			if ($wpdb -> query("DELETE FROM `" . $wpdb -> prefix . "" . $this -> table_name . "` WHERE `id` = '" . $mailinglist_id . "' LIMIT 1")) {
				$SubscribersList -> delete_all(array('list_id' => $mailinglist_id));				
				$FieldsList -> delete_all(array('list_id' => $mailinglist_id));	
				
				$Db -> model = $HistoriesList -> model;
				$Db -> delete_all(array('list_id' => $mailinglist_id));
				
				return true;
			}
		}
		
		return false;
	}
	
	function delete_array($lists = array()) {
		global $wpdb, $SubscribersList;
		
		if (!empty($lists)) {		
			foreach ($lists as $list) {
				$this -> delete($list);
			}
			
			return true;
		}
		
		return false;
	}
}

?>