<!-- WordPress Related Settings -->

<table class="form-table">
	<tbody>
		<tr>
			<th><label for="tinymcebtnY"><?php _e('TinyMCE Editor Button', $this -> plugin_name); ?></label></th>
			<td>
				<label><input <?php echo ($this -> get_option('tinymcebtn') == "Y") ? 'checked="checked"' : ''; ?> type="radio" name="tinymcebtn" value="Y" id="tinymcebtnY" /> <?php _e('Show', $this -> plugin_name); ?></label>
				<label><input <?php echo ($this -> get_option('tinymcebtn') == "N") ? 'checked="checked"' : ''; ?> type="radio" name="tinymcebtn" value="N" id="tinymcebtnN" /> <?php _e('Hide', $this -> plugin_name); ?></label>
				<span class="howto"><?php _e('Would you like to show or hide the plugin button in the TinyMCE editor?', $this -> plugin_name); ?></span>
			</td>
		</tr>
		<tr>
			<th><label for="sendasnewsletterbox_Y"><?php _e('"Send as Newsletter" box on posts/pages', $this -> plugin_name); ?></label></th>
			<td>
				<label><input <?php echo ($this -> get_option('sendasnewsletterbox') == "Y") ? 'checked="checked"' : ''; ?> type="radio" name="sendasnewsletterbox" value="Y" id="sendasnewsletterbox_Y" /> <?php _e('Show', $this -> plugin_name); ?></label>
				<label><input <?php echo ($this -> get_option('sendasnewsletterbox') == "N") ? 'checked="checked"' : ''; ?> type="radio" name="sendasnewsletterbox" value="N" id="sendasnewsletterbox_N" /> <?php _e('Hide', $this -> plugin_name); ?></label>
				<span class="howto"><?php _e('Should the "Send as Newsletter" box show on post/page editing screens?', $this -> plugin_name); ?></span>
			</td>
		</tr>
		<tr>
			<th><label for="subscriberegister_N"><?php _e('Register New Subscribers as Users', $this -> plugin_name); ?></label></th>
			<td>
				<label><input <?php echo ($this -> get_option('subscriberegister') == "Y") ? 'checked="checked"' : ''; ?> type="radio" name="subscriberegister" value="Y" id="subscriberegister_Y" /> <?php _e('Yes', $this -> plugin_name); ?></label>
				<label><input <?php echo ($this -> get_option('subscriberegister') == "N") ? 'checked="checked"' : ''; ?> type="radio" name="subscriberegister" value="N" id="subscriberegister_N" /> <?php _e('No', $this -> plugin_name); ?></label>
				<span class="howto"><?php _e('Would you like to register all new subscribers as users?', $this -> plugin_name); ?></span>
			</td>
		</tr>
	</tbody>
</table>

<?php

global $user_ID, $wp_roles;
$roles = $this -> get_option('wproles');
$permissions = $this -> get_option('permissions');
$user = $this -> userdata($user_ID);
$cu = wp_get_current_user();

?>

<?php if (!empty($cu -> roles) && in_array('administrator', $cu -> roles)) : ?>
    <table class="form-table">
        <tbody>
            <tr>
                <th><label for="changepermissions_Y"><?php _e('Change Permissions', $this -> plugin_name); ?></label></th>
                <td>
                    <label><input <?php echo ($this -> get_option('changepermissions') == "Y") ? 'checked="checked"' : ''; ?> onclick="jQuery('#permissions_div').show();" type="radio" name="changepermissions" value="Y" id="changepermissions_Y" /> <?php _e('Yes', $this -> plugin_name); ?></label>
                    <label><input <?php echo (!$this -> get_option('changepermissions') || $this -> get_option('changepermissions') == "N") ? 'checked="checked"' : ''; ?> onclick="jQuery('#permissions_div').hide();" type="radio" name="changepermissions" value="N" id="changepermissions_N" /> <?php _e('No', $this -> plugin_name); ?></label>
                    <span class="howto"><?php _e('Give specific roles access to specific sections of the plugin.', $this -> plugin_name); ?></span>
                </td>
            </tr>
        </tbody>
    </table>
    
    <div id="permissions_div" class="scroll-list" style="display:<?php echo (!$this -> get_option('changepermissions') || $this -> get_option('changepermissions') == "N") ? 'none' : 'block'; ?>;">    
        <table class="form-table">
            <tbody>
                <?php foreach ($this -> sections as $section_key => $section_menu) : ?>
                    <tr>
                        <th><label for="perm_<?php echo $section_key; ?>"><?php echo $Html -> section_name($section_key); ?></label></th>
                        <td>
                        	<?php foreach ($wp_roles -> role_names as $role_key => $role_name) : ?>
                        		<label><input <?php echo (!empty($permissions[$section_key]) && in_array($role_key, $permissions[$section_key])) ? 'checked="checked"' : ''; ?> type="checkbox" name="permissions[<?php echo $section_key; ?>][]" value="<?php echo esc_attr(stripslashes($role_key)); ?>" id="<?php echo $section_key; ?>_<?php echo $role_key; ?>" /> <?php echo esc_attr(stripslashes($role_name)); ?></label>
                        	<?php endforeach; ?>
                        	<?php if ($section_key == "send") : ?>
                        		<span class="howto"><?php _e("The 'Send as Newsletter' box on the post/page editing screen is controlled by this as well.", $this -> plugin_name); ?></span>
                        	<?php endif; ?>
                        </td>
                    </tr>
                <?php endforeach; ?>
            </tbody>
        </table>
    </div>
<?php endif; ?>