<?php

/*
Plugin Name: Newsletters
Plugin URI: http://tribulant.com/plugins/view/1/wordpress-newsletter-plugin
Version: 3.9.4
Description: This newsletter software allows users to subscribe to mutliple mailing lists on your WordPress website. Send newsletters manually or from posts, manage newsletter templates, view a complete history with tracking, import/export subscribers, accept paid subscriptions and much more.
Author: Tribulant Software
Author URI: http://tribulant.com
*/

if (!defined('DS')) { define("DS", DIRECTORY_SEPARATOR); }
if (!defined('WP_MEMORY_LIMIT')) { define('WP_MEMORY_LIMIT', "256M"); }

//include the wpMailPlugin class file
require_once(dirname(__FILE__) . DS . 'includes' . DS . 'checkinit.php');
require_once(dirname(__FILE__) . DS . 'includes' . DS . 'constants.php');
require_once(dirname(__FILE__) . DS . 'wp-mailinglist-plugin.php');

if (!class_exists('wpMail')) {
	class wpMail extends wpMailPlugin {
		
		var $url;
		var $plugin_file;
		
		function tinymce() {
			if (!current_user_can('edit_posts') && !current_user_can('edit_pages')) return;
	
			// Add TinyMCE buttons when using rich editor
			if (get_user_option('rich_editing') == 'true' &&
				$this -> get_option('tinymcebtn') == "Y") {
				add_filter('mce_buttons', array($this, 'mcebutton'));
				add_filter('mce_buttons_3', array($this, 'mcebutton3'));
				add_filter('mce_external_plugins', array($this, 'mceplugin'));
			}
		}
		
		function mcebutton($buttons) {	
			array_push($buttons, "Newsletters");		
			return $buttons;
		}
		
		function mcebutton3($buttons) {
			//Viper's Video Quicktags compatibility
			if (!empty($_GET['page']) && ($_GET['page'] == $this -> sections -> send || $_GET['page'] == $this -> sections -> templates_save)) {
				if (!empty($buttons)) {
					foreach ($buttons as $bkey => $bval) {
						if (preg_match("/\v\v\q(.*)?/si", $bval, $match)) {
							unset($buttons[$bkey]);
						}
					}
				}
			}
			
			return $buttons;
		}
	
		function mceplugin($plugins) {
			$url = $this -> url() . '/js/tinymce/editor_plugin.js';
			$plugins['Newsletters'] = $url;
			
			//Viper's Video Quicktags compatibility
			if (!empty($_GET['page']) && ($_GET['page'] == $this -> sections -> send || $_GET['page'] == $this -> sections -> templates_save)) {
				if (isset($plugins['vipersvideoquicktags'])) {
					unset($plugins['vipersvideoquicktags']);
				}
			}
			
			return $plugins;
		}	
	
		function my_change_mce_settings( $init_array ) {
		    $init_array['disk_cache'] = false; // disable caching
		    $init_array['compress'] = false; // disable gzip compression
		    $init_array['old_cache_max'] = 3; // keep 3 different TinyMCE configurations cached (when switching between several configurations regularly)
		}
	
		function mceupdate($ver) {
			$ver += 3;
		  	return $ver;
		}
		
		function phpmailer_init($phpmailer) {	
			global $fromwpml;
			
			if (!empty($fromwpml) && $fromwpml == true) {
				global $orig_message, $wpml_message, $wpml_textmessage, $wpmlhistory_id;
				
				if ($this -> get_option('multimime') == "Y") {
					if (!empty($wpml_textmessage)) {
						require_once $this -> plugin_base() . DS . 'vendors' . DS . 'class.html2text.php';
						$htmlToText = new Html2Text($wpml_textmessage, 40);
	    				$altbody = $htmlToText -> convert();
						$phpmailer -> AltBody = $altbody;
					}
				}
				
				/* Embedded Images */
				if ($this -> get_option('embedimages') == "Y") {					
					if ($this -> is_plugin_active('embedimages')) {				
						if ($ei = $this -> extension_vendor('embedimages')) {					
							$phpmailer -> Body = $ei -> embed_images($phpmailer -> Body, $phpmailer, $wpmlhistory_id);
						}		
					}
				}
				
				$phpmailer -> Sender = $this -> get_option('bounceemail');
				$phpmailer -> From = $this -> get_option('smtpfrom');
				$phpmailer -> CharSet = get_bloginfo('charset');
			}
			
			return $phpmailer;
		}
		
		//update existing subscriber's email
		function profile_update($user_id = null) {
			global $wpdb, $Db, $Subscriber;
			
			if (!empty($user_id)) {			
				if ($newuserdata = $this -> userdata($user_id)) {
					$Db -> model = $Subscriber -> model;
					
					if ($subscriber = $Db -> find(array('user_id' => $user_id))) {
						$Db -> model = $Subscriber -> model;
						$Db -> save_field('email', $newuserdata -> user_email, array('id' => $subscriber -> id));
					}
				}
			}
			
			return true;
		}
		
		function register_form() {
			if ($this -> get_option('registercheckbox') == "Y") :
				?>
				
				<p class="newsletter">
	            	<label><input tabindex="21" <?php echo $check = ($this -> get_option('checkboxon') == "Y" || $_POST[$this -> pre . 'subscribe'] == "Y") ? 'checked="checked"' : ''; ?> type="checkbox" name="<?php echo $this -> pre; ?>subscribe" value="Y" /> <?php echo $this -> get_option('registerformlabel'); ?></label>
	            </p>
				
				<?php
			endif;
		}
		
		function comment_form($post_id = null) {		
			if ($this -> get_option('commentformcheckbox') == "Y") {
				?>
	            
	            <p class="newsletter">
	            	<label><input style="width:auto;" <?php echo ($this -> get_option('commentformautocheck') == "Y") ? 'checked="checked"' : ''; ?> id="newsletter<?php echo $post_id; ?>" type="checkbox" name="newsletter" value="1" /> <?php echo $this -> get_option('commentformlabel'); ?></label>
	            </p>
	            
	            <?php	
			}
		}
		
		function comment_post($comment_id = null, $comment = null) {	
		
			if ($status = wp_get_comment_status($comment_id)) {		
				if ($status == false || $status == "spam") {
					return;
				}
			}
			
			if ($this -> get_option('commentformcheckbox') == "Y") {
				if (!empty($_POST['newsletter']) && $_POST['newsletter'] == 1) {
					if (!empty($comment_id)) {
						if ($comment = get_comment($comment_id)) {
							global $Mailinglist, $Subscriber, $SubscribersList;
							
							$data = array(
								'email' 			=> 	$comment -> comment_author_email,
								'mailinglists'		=>	array($this -> get_option('commentformlist')),
								'fromregistration'	=>	false,
								'justsubscribe'		=>	true,
								'active'			=>	(($this -> get_option('requireactivate') == "Y") ? "N" : "Y"),
							);
				
							if ($Subscriber -> save($data, true)) {
								$subscriber = $Subscriber -> get($Subscriber -> insertid, false);
								
								if (!empty($data['mailinglists']) && is_array($data['mailinglists'])) {							
									foreach ($data['mailinglists'] as $list_id) {								
										$isactive = $SubscribersList -> field('active', array('subscriber_id' => $subscriber -> id, 'list_id' => $list_id));
										$subscriber -> mailinglist_id = $list_id;
									
										if (empty($isactive) || $isactive == "N") {									
											$mailinglist = $Mailinglist -> get($list_id, false);
											
											if ($this -> get_option('requireactivate') == "Y" || $mailinglist -> paid == "Y") {											
												$subject = $this -> et_subject('confirm', $subscriber);
												$fullbody = $this -> et_message('confirm', $subscriber);
												$message = $this -> render_email(false, array('subscriber' => $subscriber, 'mailinglist' => $mailinglist), false, $this -> htmltf($subscriber -> format), true, $this -> default_theme_id(), false, $fullbody);
												$this -> execute_mail($subscriber, $subject, $message, false, false, false, false);
											}
										}
									}
								}
								
								$this -> admin_subscription_notification($subscriber);
							}	
						}
					}
				}
			}
		}
		
		function admin_notices() {
			if (is_admin()) {
				$this -> check_uploaddir();
			
				if (!$this -> ci_serial_valid()) {
					$message = __('Please fill in a serial key for the Newsletter plugin to continue use.', $this -> plugin_name);
					$message .= ' <a id="' . $this -> pre . 'submitseriallink" href="" title="Newsletter plugin - Serial Key">' . __('Submit Serial Key', $this -> plugin_name) . '</a>';
					$this -> render_error($message);
					
					?>
		            
		            <script type="text/javascript">
					jQuery(document).ready(function(e) {
		                jQuery('#<?php echo $this -> pre; ?>submitseriallink').click(function() {					
							jQuery.colorbox({href:ajaxurl + "?action=<?php echo $this -> pre; ?>serialkey"});
							return false;
						});
		            });
					</script>
		            
		            <?php
				}
				
				global $queue_count;
				if (!empty($queue_count)) {
					if ($this -> get_option('scheduling') == "N") {
						$this -> render_message(__('There are ' . $queue_count . ' emails in the queue, please turn on email scheduling under Newsletters > Configuration to process them!', $this -> plugin_name));
					}
				}
				
				if (!empty($_GET[$this -> pre . 'updated'])) {
					$this -> render_message(stripslashes(urldecode($_GET[$this -> pre . 'message'])));
				}
				
				if (!empty($_GET[$this -> pre . 'error'])) {
					$this -> render_error(stripslashes(urldecode($_GET[$this -> pre . 'message'])));
				}
				
				$folder = ABSPATH . 'wp-content' . DS . 'uploads';
				if (file_exists($folder)) {
					if (is_writable($folder)) {
						//all good
					} else {
						$this -> render_error(__('Folder named "wp-content/uploads/" is not writable', $this -> plugin_name));
					}
				} else {
					$this -> render_error(__('Folder named "wp-content/uploads/" does not exist', $this -> plugin_name));
				}
			}
		}
		
		function feed_newsletters() {
			$this -> debugging(false);
			global $Db, $History;
			header("Content-Type: application/xml");
			$data = '<?xml version="1.0" encoding="UTF-8"?>';		
			$Db -> model = $History -> model;
			$emails = $Db -> find_all(array('sent' => "> 0"), false, array('modified', "DESC"));
			$data .= $this -> render('feed-newsletters', array('emails' => $emails), false, 'default');
			echo $data;
		}
		
		function init() {	
			global $Db, $Email, $History, $Mailinglist, $wpmlOrder, $Subscriber, $SubscribersList;
			
			$this -> init_textdomain();
		
			$wpmlmethod = (empty($_POST[$this -> pre . 'method'])) ? null : $_POST[$this -> pre . 'method'];
			$method = (empty($_GET[$this -> pre . 'method'])) ? $wpmlmethod : $_GET[$this -> pre . 'method'];
		
			if (!empty($method)) {
				switch ($method) {
					case 'docron'			:
						if (!empty($_GET['auth'])) {
							if ($this -> get_option('servercronstring') == $_GET['auth']) {
								$this -> cron_hook();	
							} else {
								_e('Authentication string does not match.', $this -> plugin_name);	
							}
						} else {
							_e('No authentication string was specified.', $this -> plugin_name);	
						}
							
						exit();
						break;
					case 'defaultthemes'	:
						if (current_user_can('edit_plugins')) {
							$this -> initialize_default_themes();
							echo __('Stock themes have been added', $this -> plugin_name);
						} else {
							echo __('Please login as administrator for stock themes to be loaded', $this -> plugin_name);	
						}
						
						exit();
						break;
					case 'themebyname'		:
						if (!empty($_GET['name'])) {
							ob_start();
							include $this -> plugin_base() . DS . 'includes' . DS . 'themes' . DS . $_GET['name'] . DS . 'index.html';
							$content = ob_get_clean();				
							echo $content;
							exit();
						}
						break;
					case 'themepreview'		:				
						if (!empty($_GET['id'])) {
							global $Db, $Theme;
							$Db -> model = $Theme -> model;
							$subject = __('Newsletter Theme Preview', $this -> plugin_name);
							$history_id = "123";
							
							if ($theme = $Db -> find(array('id' => $_GET['id']))) {
								header('Content-Type: text/html');
								echo do_shortcode(stripslashes($theme -> content));
							}
						}
					
						exit();
						break;
					case 'preview'			:
						$this -> render_email('preview', false, true, $this -> htmltf($subscriber -> format), true, $this -> default_theme_id());
						exit();
						break;
					case 'track'			:					
						$Db -> model = $Email -> model;
						$Db -> save_field('read', "Y", array('eunique' => $_GET['id']));
						
						header("Content-Type: image/jpeg");
						$image = imagecreate(1, 1);
						imagejpeg($image);
						imagedestroy($image);
						exit();
						
						break;
					case 'offsite'			:				
						$options = $this -> get_option('embed');
						
						if ($this -> is_plugin_active('qtranslate')) {
							global $q_config;
							
							foreach ($options as $okey => $oval) {
								if (!empty($options[$okey]) && is_array($options[$okey])) {
									$options[$okey] = $options[$okey][$q_config['language']];	
								}
							}
							
							$options['language'] = $q_config['language'];
						}
					
						?>
						
						<html>
							<head>
								<meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
								<title><?php echo urldecode($_GET['title']); ?></title>
	                            
	                            <?php
	                            
								wp_enqueue_script('jquery');
								wp_enqueue_script($this -> plugin_name, plugins_url() . '/' . $this -> plugin_name . '/js/' . $this -> plugin_name . '.js', array('jquery'), '1.0', false);	
								wp_enqueue_script('jquery-ui-tabs');
								wp_enqueue_script('jquery-ui-button', plugins_url() . '/' . $this -> plugin_name . '/js/jquery-ui-button.js', array('jquery'));
								wp_enqueue_script('jquery-watermark', plugins_url() . '/' . $this -> plugin_name . '/js/jquery.watermark.js', array('jquery'), '1.0', true);
								
								wp_enqueue_style($this -> plugin_name, plugins_url() . '/' . $this -> plugin_name . '/views/' . $this -> get_option('theme_folder') . '/css/style.css', false, $this -> version, "all");
								
								?>
	                            
	                            <?php wp_head(); ?>
							</head>
							<body>
								<div class="<?php echo $this -> pre; ?> <?php echo $this -> pre; ?>widget">
									<?php
															
									$options['ajax'] = "N";
									$options['offsite'] = true;
									$wpoptinid = time();
								
									if (!empty($_GET['offsiteinit']) && $_GET['offsiteinit'] == 1) {
										$subscriber -> list_id = $_POST['list_id'][0] = $options['list'] = $_GET['list'];
										$subscriber -> email = $_POST['email'] = $_GET['email'];
										$Subscriber -> errors = array();
									} else {			
										$subscriber -> list_id = $options['list'] = $_GET['list'];
														
										if (!empty($_POST)) {
											$wpoptinid = $_POST['number'];								
											$subscriber -> list_id = $options['list'] = $_POST['list_id'][0];
											$subscriber -> email = $_POST['email'];
											
											if ($Subscriber -> optin($_POST)) {
												$_POST['success'] = 1;
											}
										}						
									}
									
									$this -> render('widget-front', array('options' => $options, 'wpoptinid' => $wpoptinid, 'subscriber' => $subscriber));
									
									?>
								</div>
	                            
	                            <?php wp_footer(); ?>
							</body>
						</html>
						
						<?php
						
						exit();
						break;
					case 'optin'			:
						global $Subscriber, $Html;
					
						if (!empty($_POST)) {
							if (!$Subscriber -> optin($_POST)) {
								$this -> post_errors = $Subscriber -> errors;
							} else {			
								if ($this -> get_option('subscriberedirect') == "Y") {							
									$this -> redirect($this -> get_option('subscriberedirecturl'));
								} else {
									$url = $Html -> retainquery($this -> pre . 'method=optin&' . $this -> pre . 'formid=' . $_GET[$this -> pre . 'formid'] . '&success=1#wpmlwidget-' . $_GET[$this -> pre . 'formid'], $_SERVER['REQUEST_URI']);
									$this -> redirect($url);
								}
							}
						}
						break;
					case 'unsubscribe'		:
						global $Html;
					
						$querystring = 'method=unsubscribe&' . $this -> pre . 'subscriber_id=' . $_GET[$this -> pre . 'subscriber_id'] . '&' . $this -> pre . 'subscriber_email=' . $_GET[$this -> pre . 'subscriber_email'] . '&' . $this -> pre . 'mailinglist_id=' . $_GET[$this -> pre . 'mailinglist_id'] . '&authkey=' . $_GET['authkey'];
						$url = $Html -> retainquery($querystring, $this -> get_managementpost(true));
						$this -> redirect($url);
						exit();
						break;
					case 'manage'			:
						//redirect to the new management section
						$this -> redirect($this -> get_managementpost(true));
						
						exit();
						die();
						break;				
					case 'activate'			:
						global $Html, $Mailinglist;
					
						if (!empty($_GET[$this -> pre . 'subscriber_email']) && !empty($_GET[$this -> pre . 'subscriber_id']) && !empty($_GET[$this -> pre . 'mailinglist_id'])) {
							if ($subscriberslist = $SubscribersList -> find(array('subscriber_id' => $_GET[$this -> pre . 'subscriber_id'], 'list_id' => $_GET[$this -> pre . 'mailinglist_id']))) {
								global $wpdb, $Db, $Subscriber, $Auth;
								
								$subscriber = $Subscriber -> get($_GET[$this -> pre . 'subscriber_id'], false);
								$Auth -> set_emailcookie($subscriber -> email);
								$subscriberauth = $Auth -> gen_subscriberauth();
								$Db -> model = $Subscriber -> model;
								$Db -> save_field('cookieauth', $subscriberauth, array('id' => $subscriber -> id));
								$Auth -> set_cookie($subscriberauth);
								
								if (true || $subscriberslist -> active != "Y") {							
									if (empty($subscriberslist -> authkey) || (!empty($subscriberslist -> authkey) && $_GET['authkey'] == $subscriberslist -> authkey)) {							
										$mailinglist = $Mailinglist -> get($_GET[$this -> pre . 'mailinglist_id'], false);
									
										if ($mailinglist -> paid == "N" || empty($mailinglist -> paid)) {
											if ($SubscribersList -> save_field('active', "Y", array('subscriber_id' => $_GET[$this -> pre . 'subscriber_id'], 'list_id' => $_GET[$this -> pre . 'mailinglist_id']))) {
												$message = __('Subscription has been activated', $this -> plugin_name);
												
												$subscriber = $Subscriber -> get($_GET[$this -> pre . 'subscriber_id'], false);
												$subscriber -> mailinglist_id = $mailinglist -> id;
												
												//log the IP address of the subscriber
												$Db -> model = $Subscriber -> model;
												$Db -> save_field('ip_address', $_SERVER['REMOTE_ADDR'], array('id' => $subscriber -> id));
											} else {
												$message = __('Subscription could not be activated', $this -> plugin_name);
											}
										} else {						
											if ($this -> get_option('paymentmethod') == "2co") {
												$checkoutdata = array(
													'sid'					=>	$this -> get_option('tcovendorid'),
													'quantity'				=>	1,
													'product_id'			=>	$mailinglist -> tcoproduct,
													'id_type'				=>	2,
													'return_url'			=>	rtrim(get_bloginfo('home'), '/') . '/index.php?' . $this -> pre . 'method=twocheckout',
													'x_receipt_link_url'	=>	rtrim(get_bloginfo('home'), '/') . '/index.php?' . $this -> pre . 'method=twocheckout',
													$this -> pre . 'method'	=>	'twocheckout',
													'subscriber_id'			=>	$_GET[$this -> pre . 'subscriber_id'],
													'subscriber_email'		=>	$_GET[$this -> pre . 'subscriber_email'],
													'mailinglist_id'		=>	$_GET[$this -> pre . 'mailinglist_id'],
													'fixed'					=>	'Y',
													'demo'					=>	$this -> get_option('tcodemo'),
												);
												
												$this -> render('twocheckout-form', array('checkoutdata' => $checkoutdata));
											} else {
												$pp_return = ($this -> get_option('paypalsubscriptions') == "Y" && $mailinglist -> interval != "once") ?
												rtrim(get_bloginfo('home'), '/') . '/index.php?' . $this -> pre . 'method=ppsuccess_subscr' :
												rtrim(get_bloginfo('home'), '/') . '/index.php?' . $this -> pre . 'method=ppsuccess_once';
											
												$checkoutdata = array(
													'charset'							=>	get_option('blog_charset'),
													'return'							=>	$pp_return,
													'rm'								=>	2,
													'notify_url'						=>	rtrim(get_bloginfo('home'), '/') . '/index.php?' . $this -> pre . 'method=paypal',
													'cbt'								=>	__('Click here to complete your order', $this -> plugin_name),
													'currency_code'						=>	$this -> get_option('currency'),
													'business'							=>	$this -> get_option('paypalemail'),
													'item_name'							=>	$mailinglist -> title,
													'item_number'						=>	$mailinglist -> id,
													'custom'							=>	urlencode(serialize(array(
														'subscriber_id'		=>	$_GET[$this -> pre . 'subscriber_id'],
														'mailinglist_id'	=>	$_GET[$this -> pre . 'mailinglist_id']
													))),
													'no_shipping'						=>	1,
													'no_note'							=>	1,
												);
												
												if ($this -> get_option('paypalsubscriptions') == "Y" && $mailinglist -> interval != "once") {
													$checkoutdata['cmd'] = "_xclick-subscriptions";
													$checkoutdata['a3'] = number_format($mailinglist -> price, 2, '.', '');
													$checkoutdata['p3'] = $Html -> getpptd($mailinglist -> interval);
													$checkoutdata['t3'] = $Html -> getppt($mailinglist -> interval);
													$checkoutdata['src'] = 1;
													$checkoutdata['sra'] = 1;
												} else {
													$checkoutdata['cmd'] = "_xclick";
													$checkoutdata['amount'] = $mailinglist -> price;
													$checkoutdata['quantity'] = 1;
												}
												
												$this -> render('paypal-form', array('checkoutdata' => $checkoutdata));
												exit();
											}
										}
									} else {
										$message = __('Authorization has failed', $this -> plugin_name);
									}
								} else {
									$message = __('Subscription is already active', $this -> plugin_name);
								}
							} else {
								$message = __('Subscription cannot be read', $this -> plugin_name);
							}
						} else {
							$message = __('Subscription is invalid', $this -> plugin_name);
						}
						
						if ($this -> get_option('customactivateredirect') == "Y") {
							$activateredirecturl = $this -> get_option('activateredirecturl');
						} else {
							//$activateredirecturl = '?' . $this -> pre . 'method=manage&email=' . $_GET[$this -> pre . 'subscriber_email'] . '';
							$activateredirecturl = $this -> get_managementpost(true);
						}
						
						?>
						
						<script type="text/javascript">
						<?php if (!empty($message)) : ?>
							alert('<?php echo $message; ?>');
						<?php endif; ?>
						
						window.location = '<?php echo $activateredirecturl; ?>';
						</script>
						
						<?php
						//exit();
						break;
					case 'paypal'			:
						global $Html;
						
						// read the post from PayPal system and add 'cmd'
						$req = 'cmd=_notify-validate';
						
						foreach ($_POST as $pkey => $pval) {
							$pval = urlencode(stripslashes($pval));
							$req .= "&" . $pkey . "=" . $pval . "";
						}
					
						$custom = unserialize(urldecode($_POST['custom']));
						//unset($_POST['custom']);
						//unset($_POST['memo']);
						
						$ppurl = ($this -> get_option('paypalsandbox') == "Y") ? 'sandbox.paypal.com' : 'www.paypal.com';
						
						// post back to PayPal system to validate
						$header = '';
						$header .= "POST /cgi-bin/webscr HTTP/1.0\r\n";
						$header .= "Host: " . $ppurl . "\r\n";
						$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
						$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
											
						$fp = fsockopen($ppurl, 80, $errno, $errstr, 30);
						
						// assign posted variables to local variables
						$item_name = $_POST['item_name'];
						$item_number = $_POST['item_number'];
						$payment_status = $_POST['payment_status'];
						$payment_amount = $_POST['mc_gross'];
						$payment_currency = $_POST['mc_currency'];
						$txn_id = $_POST['txn_id'];
						$txn_type = $_POST['txn_type'];
						$receiver_email = $_POST['receiver_email'];
						$payer_email = $_POST['payer_email'];
						
						if (!$fp) {
							$message = __('An HTTP error has occurred. PayPal cannot be contacted.', $this -> plugin_name);
						} else {
							fputs($fp, $header . $req);
							
							ob_start();
							
							while (!feof($fp)) {
								$res = fgets($fp, 1024);
								
								echo $res . '<br/>';
								
								$doupdate = false;
								if (strcmp($res, "VERIFIED") == 0) {	
									// || (!empty($_POST['test_ipn']) && strcmp($res, "INVALID") == 0)
														
									switch ($payment_status) {
										case 'Failed'				:
											$message = __('The payment has failed. Please try again', $this -> plugin_name);
											break;
										case 'Denied'				:
											$message = __('The payment has been denied. This payment could already be pending', $this -> plugin_name);
											break;
										default						:
											if (!empty($custom['subscriber_id']) && !empty($custom['mailinglist_id'])) {
												switch ($txn_type) {
													case 'subscr_payment'		:
														if ($payment_status == "Pending") {
															$message = __('Thank you for your PayPal subscription. Your payment is currently pending. Please wait for the merchant to accept it', $this -> plugin_name);	
														} elseif ($payment_status == "Completed") {
															$doupdate = true;
														}
														break;
													case 'subscr_cancel'		:
														$sl_conditions = array('subscriber_id' => $custom['subscriber_id'], 'list_id' => $custom['mailinglist_id']);
														$SubscribersList -> save_field('active', "N", $sl_conditions);
														$message = __('PayPal subscription has been cancelled', $this -> plugin_name);
														break;
													default						:												
														if ($payment_status == "Completed" || ($_POST['test_ipn'] && $payment_status == "Pending")) {													
															$doupdate = true;
														}
														break;
												}
											}
											break;
									}
								} elseif (strcmp($res, "INVALID") == 0) {
									//why on earth?
									$message = __('PayPal has marked the transaction as invalid', $this -> plugin_name);
								}
							}
							
							//everything is fine, lets continue
							if ($doupdate == true) {
								$subscriber = $Subscriber -> get($custom['subscriber_id'], false);
								$mailinglist = $Mailinglist -> get($custom['mailinglist_id'], false);
								$subscriber -> mailinglist_id = $mailinglist -> id;
	
								if ($payment_amount == $mailinglist -> price) {								
									$sl_conditions = array('subscriber_id' => $custom['subscriber_id'], 'list_id' => $custom['mailinglist_id']);
									
									$subscriberslist = $SubscribersList -> find($sl_conditions);
									$SubscribersList -> save_field('active', "Y", $sl_conditions);
									$SubscribersList -> save_field('paid', "Y", $sl_conditions);
									$SubscribersList -> save_field('paid_date', $Html -> gen_date(), $sl_conditions);
									$SubscribersList -> save_field('modified', $Html -> gen_date(), $sl_conditions);
									
									if ($this -> get_option('paypalsubscriptions') == "Y") {
										$SubscribersList -> save_field('ppsubscription', "Y", $sl_conditions);
									}
									
									$orderdata = array(
										'list_id'				=>	$custom['mailinglist_id'],
										'subscriber_id'			=>	$custom['subscriber_id'],
										'completed'				=>	'Y',
										'amount'				=>	$mailinglist -> price,
										'product_id'			=>	$subscriberslist -> rel_id,
										'order_number'			=>	$subscriberslist -> rel_id,
										'pmethod'				=>	'pp',
									);
									
									if ($wpmlOrder -> save($orderdata, true)) {									
										if ($this -> get_option('adminordernotify') == "Y") {
											$to = null;
											$to -> email = $this -> get_option('adminemail');
											$subject = $this -> et_subject('order', $subscriber);
											$fullbody = $this -> et_message('order', $subscriber);
											$message = $this -> render_email(false, array('subscriber' => $subscriber, 'mailinglist' => $mailinglist), false, $this -> htmltf($subscriber -> format), true, $this -> default_theme_id(), false, $fullbody);
											$this -> execute_mail($to, $subject, $message, $attachment = false, $history_id = false, false, false);
										}
									}
									
									$message = __('Payment received and subscription activated', $this -> plugin_name);
								} else {
									$message = __('Payment amount and mailing list price does not match up', $this -> plugin_name);
								}
							}
						
							fclose($fp);
						}
						
						if (!empty($message)) {						
							?>
							
							<script type="text/javascript">
							alert('<?php echo $message; ?>');
							window.location = '<?php echo $this -> get_managementpost(true); ?>';
							</script>
							
							<?php
							
							exit();
						}
						break;
					case 'ppsuccess_subscr'	:
						$subscriber = $Subscriber -> get($custom['subscriber_id'], false);
					
						?>
							
						<script type="text/javascript">
						//jQuery(document).ready(function() {
							alert('<?php _e('Thank you for your PayPal subscription payment. Your newsletter subscription has been activated and will remain active for as long as your PayPal recurring payment is processed.', $this -> plugin_name); ?>');
							window.location = '<?php echo $this -> get_managementpost(true); ?>';
						//});
						</script>
						
						<?php
						break;
					case 'ppsuccess_once'	:
						$subscriber = $Subscriber -> get($custom['subscriber_id'], false);
					
						?>
							
						<script type="text/javascript">
						//jQuery(document).ready(function() {
							alert('<?php _e('Thank you for your PayPal payment. Your subscription has been activated and you will be notified when it expires in order to renew it.', $this -> plugin_name); ?>');
							window.location = '<?php echo $this -> get_managementpost(true); ?>';
						//});
						</script>
						
						<?php				
						break;
					case 'twocheckout'		:				
						if (!empty($_POST['order_number'])) {
							if ($_POST['credit_card_processed'] == "Y") {
								$vendorid = $this -> get_option('tcovendorid');
								$secret = $this -> get_option('tcosecret');
								$total = $_POST['total'];
							
								if ($_POST['demo'] == "Y" && $this -> get_option('tcodemo') == "Y") {
									$ordernumber = 1;
								} else {
									$ordernumber = $_POST['order_number'];
								}
								
								$mykey = $secret . $vendorid . $ordernumber . $total;
								$mykey = strtoupper(md5($mykey));
								
								if ($mykey === $_POST['key']) {								
									$subscriberid = $_POST['subscriber_id'];
									$subscriber = $Subscriber -> get($subscriberid, false);
									$mailinglist = $Mailinglist -> get($_POST['mailinglist_id'], false);
									$subscriber -> mailinglist_id = $mailinglist -> id;
									
									$sl_conditions = array('subscriber_id' => $subscriber -> id, 'list_id' => $mailinglist -> id);
									$SubscribersList -> save_field('active', "Y", $sl_conditions);
									$SubscribersList -> save_field('paid', "Y", $sl_conditions);
									$SubscribersList -> save_field('paid_date', $this -> gen_date(), $sl_conditions);
									
									$orderdata = array(
										'list_id'				=>	$_POST['mailinglist_id'],
										'subscriber_id'			=>	$subscriberid,
										'completed'				=>	'Y',
										'amount'				=>	$_POST['total'],
										'product_id'			=>	$mailinglist -> tcoproduct,
										'order_number'			=>	$ordernumber,
										'pmethod'				=>	'2co',
									);
									
									if ($wpmlOrder -> save($orderdata, true)) {
										if ($this -> get_option('adminordernotify') == "Y") {
											$to -> email = $this -> get_option('adminemail');
											$subject = $this -> et_subject('order', $subscriber);
											$fullbody = $this -> et_message('order', $subscriber);
											$message = $this -> render_email(false, array('subscriber' => $subscriber, 'mailinglist' => $mailinglist), false, $this -> htmltf($subscriber -> format), true, $this -> default_theme_id(), false, $fullbody);
											$this -> execute_mail($to, $subject, $message, $attachment = false, $history_id = false, false, false);
										}
									}
									
									$message = __('Payment received and subscription activated', $this -> plugin_name);
								} else {
									$message = __('Hash encryption failed! Please contact us', $this -> plugin_name);
								}
							} else {
								$message = __('Credit card could not be processed', $this -> plugin_name);
							}
						}
						
						?>
	
						<?php if (!empty($message)) : ?>					
							<script type="text/javascript">
							//jQuery(document).ready(function() {
								alert('<?php echo $message; ?>');
								window.location = '<?php echo $this -> get_managementpost(true); ?>';
							//});
							</script>
						<?php endif; ?>
						
						<?php
						break;
					case 'bounce'			:				
						$this -> bounce($_GET['em']);									
						break;
					case 'newsletter'		:
						global $Db, $History, $Subscriber;
					
						if (!empty($_GET['id'])) {
							$Db -> model = $History -> model;
						
							if ($email = $Db -> find(array('id' => $_GET['id']))) {
								
								$Db -> model = $Subscriber -> model;
								$subscriber = $Db -> find(array('id' => $_GET['subscriber_id']));
								$subscriber -> mailinglist_id = $_GET['mailinglist_id'];
								$message = $this -> render('newsletter', array('email' => $email, 'subscriber' => $subscriber), false, 'default');
								$content = $this -> render_email('send', array('message' => $message, 'subject' => $email -> subject, 'subscriber' => $subscriber, 'history_id' => $_GET['id']), false, true, true, $email -> theme_id);
								$output = "";
								ob_start();
								echo do_shortcode(stripslashes($content));
								$output = ob_get_clean();
								echo $this -> process_set_variables($subscriber, $output, $email -> id);
								exit();
							} else {
								$message = __('Newsletter cannot be read', $this -> plugin_name);
							}
						} else {
							$message = __('No newsletter was specified', $this -> plugin_name);
						}
						
						if (!empty($message)) {
							?>
							
							<script type="text/javascript">
							alert('<?php echo $message; ?>');
							</script>
							
							<?php
							
							$this -> redirect(get_bloginfo('home'));
						}
						break;
				}
			}
		}
		
		/**
		 * Action hook executes this after all plugins have loaded
		 *
		 */
		function plugins_loaded() {
			if (function_exists('register_sidebar_widget')) {
				register_sidebar_widget(__('Newsletter', $this -> plugin_name), array(&$this, 'widget_front'));
				register_widget_control(__('Newsletter', $this -> plugin_name), array(&$this, 'widget_control'), 300, 625);
			}
		}
		
		function wp_head() {
			$this -> render('head');
		}
		
		function wp_footer() {
			$this -> render('footer');
		}
		
		function delete_user($user_id = null) {	
			global $Db, $Subscriber;
		
			if (!empty($user_id)) {
				$Db -> model = $Subscriber -> model;
			
				if ($subscriber = $Db -> find(array('user_id' => $user_id))) {
					if (!empty($subscriber)) {
						$Subscriber -> delete($subscriber -> id);
					}
				}
			}
		}
		
		function user_register($user_id = null) {
			global $Db, $Mailinglist, $Subscriber, $SubscribersList;
		
			if (!empty($user_id)) {		
				if ($userdata = $this -> userdata($user_id)) {	
					if ($this -> get_option('importusers') == "Y") {
						if ($importuserslists = $this -> get_option('importuserslists')) {
							$subscriber = array(
								'email'				=>	$userdata -> user_email,
								'registered'		=>	"Y",
								'username'			=>	$userdata -> user_login,
								'mailinglists'		=>	$importuserslists,
								'fromregistration'	=>	true,
								'justsubscribe'		=>	true,
								'user_id'			=>	$user_id,
								'active'			=>	"Y",
							);
							
							$Subscriber -> save($subscriber, true);
							
							/* Send First/Latest */
							$subscriber_id = $Subscriber -> insertid;
							$subscriber = $Subscriber -> get($subscriber_id, false);
						}
					}
						
					if (!empty($_POST[$this -> pre . 'subscribe']) && $_POST[$this -> pre . 'subscribe'] == "Y") {
						if ($this -> get_option('autosubscribelist') != "") {									
							$data = array(
								'email' 			=> 	$userdata -> user_email,
								'registered'		=>	'Y',
								'username'			=>	$userdata -> user_login,
								'mailinglists'		=>	array($this -> get_option('autosubscribelist')),
								'fromregistration'	=>	true,
								'justsubscribe'		=>	true,
								'user_id'			=>	$user_id,
								'active'			=>	(($this -> get_option('requireactivate') == "Y") ? "N" : "Y"),
							);
				
							if ($Subscriber -> save($data, true)) {
								$subscriber = $Subscriber -> get($Subscriber -> insertid, false);
								
								if (!empty($data['mailinglists']) && is_array($data['mailinglists'])) {							
									foreach ($data['mailinglists'] as $list_id) {								
										$isactive = $SubscribersList -> field('active', array('subscriber_id' => $subscriber -> id, 'list_id' => $list_id));
										$subscriber -> mailinglist_id = $list_id;
									
										if (empty($isactive) || $isactive == "N") {									
											$mailinglist = $Mailinglist -> get($list_id, false);
											
											if ($this -> get_option('requireactivate') == "Y" || $mailinglist -> paid == "Y") {
												$subject = $this -> et_subject('confirm');
												$fullbody = $this -> et_message('confirm', $subscriber);
												$message = $this -> render_email(false, array('subscriber' => $subscriber, 'mailinglist' => $mailinglist), false, $this -> htmltf($subscriber -> format), true, $this -> default_theme_id(), false, $fullbody);
												$this -> execute_mail($subscriber, $subject, $message, false, false, false, false);
											}
										}
									}
								}
								
								$this -> admin_subscription_notification($subscriber);
							}
						}
					}
				}
			}
			
			return true;
		}
		
		function do_meta_boxes($type = 'post') {
			global $Metabox;
			
			$post_types = $this -> get_custom_post_types();
			
			if (!empty($type)) {
				if ($type == "post" || $type == "page" || (!empty($post_types) && array_key_exists($type, $post_types))) {		
					if (current_user_can('newsletters_send') && $this -> get_option('sendasnewsletterbox') == "Y") {
						add_meta_box($this -> pre . 'div', __('Send as Newsletter', $this -> plugin_name), array($Metabox, 'write_advanced'), $type, 'normal', 'high');							
					}
				}
			}
			
			return;
		}
		
		function latestposts_hook() {
			global $wpdb, $post, $user_ID, $Db, $Latestpost, $Template, $Html, $History, $Mailinglist, $Queue, $Subscriber, $SubscribersList;
			
			if ($this -> get_option('latestposts') == "Y") {		
				$exclude = array();
				if ($latestposts_exclude = $this -> get_option('latestposts_exclude')) {
					if (($exclude = @explode(",", $latestposts_exclude)) !== false) {
						//exclude array exists…
						foreach ($exclude as $exkey => $exval) {
							$exclude[$exkey] = trim($exval);
						}
					}
				}
						
				$post_criteria = array(
					'numberposts'			=>	$this -> get_option('latestposts_number'),
					'category'				=>	implode(",", $this -> get_option('latestposts_categories')),
					'orderby'				=>	"post_date",
					'order'					=>	"ASC",
					'exclude'				=>	$exclude,
					'post_type'				=>	"post",
					'post_status'			=>	"publish",
				);
				
				$latestposts_takefrom = $this -> get_option('latestposts_takefrom');
				if (!empty($latestposts_takefrom) && $latestposts_takefrom == "posttypes") {
					$post_criteria['category'] = 0;
					$post_criteria['post_type'] = $this -> get_option('latestposts_posttypes');
				}
				
				$latestpostsquery = "SELECT id, post_id FROM " . $wpdb -> prefix . $Latestpost -> table . "";
				if ($latestposts = $wpdb -> get_results($latestpostsquery)) {
					foreach ($latestposts as $latestpost) {
						if (!empty($post_criteria['exclude'])) {
							$post_criteria['exclude'][] = $latestpost -> post_id;
						} else {
							$post_criteria['exclude'][] = $latestpost -> post_id;
						}
					}
				}
				
				$olderthanquery = "SELECT ID FROM " . $wpdb -> posts . " WHERE post_date < '" . date("Y-m-d H:i:s", strtotime($this -> get_option('latestposts_olderthan'))) . "'";
				if ($olderthan = $wpdb -> get_results($olderthanquery)) {
					foreach ($olderthan as $olderthanpost) {
						$post_criteria['exclude'][] = $olderthanpost -> ID;
					}
				}
				
				$Db -> model = $Latestpost -> model;
				$verylatestpost = $Db -> find(false, false, array('created', "DESC"));
				$vl_post = get_post($verylatestpost -> post_id);
				
				if ($posts = get_posts($post_criteria)) {			
					if (!empty($vl_post)) {
						foreach ($posts as $pid => $post) {
							if (strtotime($post -> post_date) < strtotime($vl_post -> post_date)) {
								unset($posts[$pid]);
							}
						}
					}
					
					if (!empty($posts)) {
						/* qTranslate */
						if ($this -> is_plugin_active('qtranslate')) {
							$latestposts_language = $this -> get_option('latestposts_language');
							
							foreach ($posts as $pkey => $post) {
								$posts[$pkey] = qtrans_use($latestposts_language, $post, false);	
							}
						}
						
						$subject = $this -> get_option('latestposts_subject');
						$content = $this -> render('latestposts', array('posts' => $posts), false, 'default');
						$attachment = false;
						$post_id = false;
						
						$history_data = array(
							'subject'			=>	$subject,
							'message'			=>	$content,
							'theme_id'			=>	$this -> get_option('latestposts_theme'),
							'mailinglists'		=>	serialize($this -> get_option('latestposts_lists')),
							'attachment'		=>	"N",
							'attachmentfile'	=>	false,
						);
							
						$Db -> model = $History -> model;
						$history_data['sent'] = 1;
						$History -> save($history_data, false);
						$history_id = $History -> insertid;
						
						$sentmailscount = 0; //number of emails sent
						$q_queries = array();
						
						if ($mailinglists = $this -> get_option('latestposts_lists')) {
							$mailinglistscondition = "(";
							$m = 1;
							
							foreach ($mailinglists as $mailinglist_id) {
								$mailinglistscondition .= "list_id = '" . $mailinglist_id . "'";
								if ($m < count($mailinglists)) { $mailinglistscondition .= " OR "; }
								$m++;	
							}
							
							$query = "SELECT DISTINCT " . $wpdb -> prefix . $Subscriber -> table . ".id, "
							. $wpdb -> prefix . $Subscriber -> table . ".email FROM " 
							. $wpdb -> prefix . $Subscriber -> table . " LEFT JOIN "
							. $wpdb -> prefix . $SubscribersList -> table . " ON "
							. $wpdb -> prefix . $Subscriber -> table . ".id = " . $wpdb -> prefix . $SubscribersList -> table . ".subscriber_id WHERE "
							. $mailinglistscondition . ") AND " . $wpdb -> prefix . $SubscribersList -> table . ".active = 'Y'";
							
							if ($subscribers = $wpdb -> get_results($query)) {
								foreach ($subscribers as $subscriber) {
									$this -> remove_server_limits();
									$subscriber -> mailinglist_id = $mailinglists[0];
												
									if ($this -> get_option('scheduling') == "Y") {
										$q_queries[] = $Queue -> save($subscriber, $subject, $content, $attachment, $post_id, $history_id, true, $this -> get_option('latestposts_theme'));
										$sentmailscount++;
									} else {
										$eunique = md5($subscriber -> id . $subscriber -> mailinglist_id . $history_id . date("YmdH", time()));
										$message = $this -> render_email('send', array('message' => $content, 'subject' => $subject, 'subscriber' => $subscriber, 'history_id' => $history_id, 'post_id' => $post_id, 'eunique' => $eunique), false, $this -> htmltf($subscriber -> format), true, $this -> get_option('latestposts_theme'));
										$this -> execute_mail($subscriber, $subject, $message, $attachment, $history_id, $eunique);
										$sentmailscount++;
									}
								}
								
								if (!empty($q_queries)) {									
									foreach ($q_queries as $q_query) {
										if (!empty($q_query)) {
											$wpdb -> query($q_query);
										}
									}
								}	
							}
						}
						
						if (!empty($sentmailscount)) {
							foreach ($posts as $post) {
								$Db -> model = $Latestpost -> model;
								$Db -> save(array('post_id' => $post -> ID), true);
							}
						}
					}
				}
			}
			
			echo $sentmailscount . ' ' . __('emails were sent/queued.', $this -> plugin_name);		
			return;
		}
		
		function importusers_hook() {
			global $wpdb, $Db, $Mailinglist, $Subscriber, $Field;
			$Db -> model = $Mailinglist -> model;
			$importcount = 0;
			$importuserslists = $this -> get_option('importuserslists');
			
			if (!empty($importuserslists)) {			
				$query = "SELECT " . $wpdb -> users . ".ID, " . $wpdb -> users . ".user_email, " . $wpdb -> users . ".user_login FROM " 
				. $wpdb -> users . " LEFT JOIN " . $wpdb -> prefix . $Subscriber -> table . " ON " 
				. $wpdb -> prefix . $Subscriber -> table . ".email = " . $wpdb -> users . ".user_email WHERE " 
				. $wpdb -> prefix . $Subscriber -> table . ".email IS NULL";
				
				if ($users = $wpdb -> get_results($query)) {
					$importusersrequireactivate = $this -> get_option('importusersrequireactivate');
				
					foreach ($users as $user) {
						$Db -> model = $Subscriber -> model;
						
						$subscriber = array(
							'id'				=>	false,
							'email'				=>	$user -> user_email,
							'mailinglists'		=>	$importuserslists,
							'registered'		=>	"Y",
							'username'			=>	$user -> user_login,
							'fromregistration'	=>	true,
							'justsubscribe'		=>	true,
							'active'			=>	((empty($importusersrequireactivate) || $importusersrequireactivate == "Y") ? "N" : "Y"),
							'user_id'			=>	$user -> ID,
						);
						
						$fieldsquery = "SELECT `id`, `slug` FROM `" . $wpdb -> prefix . $Field -> table . "` WHERE `slug` != 'email'";
						if ($fields = $wpdb -> get_results($fieldsquery)) {
							$importusersfields = $this -> get_option('importusersfields');
							$importusersfieldspre = $this -> get_option('importusersfieldspre');
							
							foreach ($fields as $field) {
								if (!empty($importusersfieldspre[$field -> id]) && $usermeta = get_user_meta($user -> ID, $importusersfieldspre[$field -> id], true)) {
									$subscriber[$field -> slug] = $usermeta;
								} elseif (!empty($importusersfields[$field -> id]) && $usermeta = get_user_meta($user -> ID, $importusersfields[$field -> id], true)) {
									$subscriber[$field -> slug] = $usermeta;
								}
							}
						}
						
						if ($Subscriber -> save($subscriber, true)) {
							$importcount++;	
						}
					}
				}
			}
			
			echo $importcount . ' ' . __('users were imported as subscribers.', $this -> plugin_name);
		}
		
		function autoresponders_hook() {
			//update scheduling
			$this -> autoresponder_scheduling();
			$addedtoqueue = 0;
			
			/* Do the Autoresponders */
			global $wpdb, $Db, $Queue, $Html, $History, $HistoriesAttachment, $Subscriber, $SubscribersList, $Autoresponder, $Autoresponderemail;
			
			$query = "SELECT ae.id, sl.list_id, sl.subscriber_id, 
			ae.autoresponder_id FROM " . $wpdb -> prefix . $Autoresponderemail -> table . " ae LEFT JOIN 
			" . $wpdb -> prefix . $SubscribersList -> table . " sl ON ae.subscriber_id = sl.subscriber_id AND ae.list_id = sl.list_id 
			WHERE sl.active = 'Y' AND ae.status = 'unsent' 
			AND ae.senddate <= '" . date("Y-m-d H:i:s", time()) . "';";
			
			if ($autoresponderemails = $wpdb -> get_results($query)) {					
				foreach ($autoresponderemails as $ae) {				
					/* The History Email */
					$query = "SELECT " . $wpdb -> prefix . $History -> table . ".id, " 
					. $wpdb -> prefix . $History -> table . ".subject, " 
					. $wpdb -> prefix . $History -> table . ".message, " 
					. $wpdb -> prefix . $History -> table . ".theme_id FROM " 
					. $wpdb -> prefix . $History -> table . " LEFT JOIN " 
					. $wpdb -> prefix . $Autoresponder -> table . " ON " . $wpdb -> prefix . $History -> table . ".id = " . $wpdb -> prefix . $Autoresponder -> table . ".history_id WHERE " 
					. $wpdb -> prefix . $Autoresponder -> table . ".id = '" . $ae -> autoresponder_id . "' LIMIT 1;";
					
					$history = $wpdb -> get_row($query);
					$history -> attachments = array();
					
					/* Attachments */
					$attachmentsquery = "SELECT id, title, filename FROM " . $wpdb -> prefix . $HistoriesAttachment -> table . " WHERE history_id = '" . $history -> id . "'";
					if ($attachments =  $wpdb -> get_results($attachmentsquery)) {
						foreach ($attachments as $attachment) {
							$history -> attachments[] = array(
								'id'					=>	$attachment -> id,
								'title'					=>	$attachment -> title,
								'filename'				=>	$attachment -> filename,
							);	
						}
					}
					
					/* The Subscriber */
					$Db -> model = $Subscriber -> model;
					$subscriber = $Db -> find(array('id' => $ae -> subscriber_id), false, false, true, false);
					$subscriber -> mailinglist_id = $ae -> list_id;
					
					/* The Message */
					$eunique = $Html -> eunique($subscriber, $history -> id);
					
					/* Queue the email */
					if ($Queue -> save($subscriber, $history -> subject, $history -> message, $history -> attachments, false, $history -> id, false, $history -> theme_id)) {
						$addedtoqueue++;
						$Db -> model = $Autoresponderemail -> model;
						$Db -> save_field('status', "sent", array('id' => $ae -> id));
					}
				}
			}
			
			echo $addedtoqueue . ' ' . __('emails added to the email queue.', $this -> plugin_name);
		}
	
	    function pop_hook() {
			//update scheduling
	        $this -> pop_scheduling();
	
	        if ($this -> get_option('bouncemethod') == "pop") {
	            $this -> bounce(false, "pop");
	        }
	
	        return;
	    }
		
		function cron_hook() {
			global $wpdb, $Db, $Email, $History, $Subscriber, $SubscribersList, $Queue;
			$emailssent = 0;
		
			//update scheduling
			$this -> scheduling();
			$this -> autoresponders_hook();
		
			//ensure that scheduling has been turned on
			if ($this -> get_option('scheduling') == "Y") {
				$emailsperinterval = $this -> get_option('emailsperinterval');
				
				$emailsquery = "SELECT * FROM " . $wpdb -> prefix . $Queue -> table . " WHERE `senddate` < '" . date("Y-m-d H:i:s", time()) . "' LIMIT " . $emailsperinterval . "";
				
				//retrieve all the queue emails for this execution
				if ($emails = $wpdb -> get_results($emailsquery)) {
				//if ($emails = $Queue -> find_all(false, false, false, $emailsperinterval)) {				
					//send an email notification to the administrator if specified
					if ($this -> get_option('schedulenotify') == "Y" && $this -> get_option('scheduling') == "Y") {
						$subscriber_id = $Subscriber -> admin_subscriber_id($_POST['mailinglists']);
						$subscriber = $Subscriber -> get($subscriber_id, false);
						$subject = $this -> et_subject('schedule', $subscriber);
						$fullbody = $this -> et_message('schedule', $subscriber);	
						$message = $this -> render_email(false, array('subscriber' => $subscriber, 'mailinglist' => $mailinglist), false, $this -> htmltf($subscriber -> format), true, $this -> default_theme_id(), false, $fullbody);
						$this -> execute_mail($subscriber, $subject, $message, false, false, false, false);
					}
					
					$subscriber = false;
					$subscriberids = array();
					$subscriberemails = array();
					$emailssent = 0;
				
					foreach ($emails as $email) {
						$this -> remove_server_limits();
						
						$historyquery = "SELECT `post_id` FROM `" . $wpdb -> prefix . $History -> table . "` WHERE `id` = '" . $email -> history_id . "'";
						if ($history_post_id = $wpdb -> get_var($historyquery)) {
							if ($getpost = get_post($history_post_id)) {
								global $post;
								$post = $getpost;
							}
						}
						
						if ($subscriber = $Subscriber -> get($email -> subscriber_id, false)) {
							$subscriber -> mailinglist_id = $email -> mailinglist_id;
							$subscriber -> mailinglists = $email -> mailinglists;
							$eunique = md5($subscriber -> id . $subscriber -> mailinglist_id . $email -> history_id . date("YmdH", time()));
							
							if (empty($subscriberids) || (!empty($subscriberids) && !in_array($subscriber -> id, $subscriberids))) {
								$subscriberids[] = $subscriber -> id;
								
								if ((empty($subscriberemails[$email -> history_id])) || (!empty($subscriberemails[$email -> history_id]) && !in_array($subscriber -> email, $subscriberemails[$email -> history_id]))) {						
									$subscriberemails[$email -> history_id][] = $subscriber -> email;
									
									$Db -> model = $Email -> model;
									$message = $this -> render_email('send', array('message' => $email -> message, 'subject' => $email -> subject, 'subscriber' => $subscriber, 'history_id' => $email -> history_id, 'post_id' => $email -> post_id, 'eunique' => $eunique), false, $this -> htmltf($subscriber -> format), true, $email -> theme_id);
									
									if ($this -> execute_mail($subscriber, $email -> subject, $message, $email -> attachments, $email -> history_id, $eunique)) {								
										$Queue -> delete($email -> id);
										$emailssent++;
									}
								}
							}
						} else {
							$Queue -> delete($email -> id);
						}
						
						$subscriber = array();
					}
				}
			}
				
			//update the "lastcron" setting
			$this -> update_option('lastcron', time());
			echo $emailssent . " " . __('emails have been sent out', $this -> plugin_name);
		}
		
		function the_editor($html = null) {
			/* Check qTranslate Support */
			if (is_admin()) {
				if ($this -> is_plugin_active('qtranslate')) {
					if ($this -> is_plugin_screen()) {
						remove_filter('the_editor', 'qtrans_modifyRichEditor');	
					}
				}
			}
			
			return $html;
		}
		
		function cron_schedules($schedules = array()) {
			$schedules['2minutes']		= array('interval' => 120, 'display' => __('Every 2 Minutes', $this -> plugin_name));
			$schedules['5minutes']		= array('interval' => 300, 'display' => __('Every 5 Minutes', $this -> plugin_name));
	       	$schedules['10minutes']		= array('interval' => 600, 'display' => __('Every 10 Minutes', $this -> plugin_name));
	       	$schedules['20minutes'] 	= array('interval' => 1200, 'display' => __('Every 20 Minutes', $this -> plugin_name));
	       	$schedules['30minutes'] 	= array('interval' => 1800, 'display' => __('Every 30 Minutes', $this -> plugin_name));
	       	$schedules['40minutes'] 	= array('interval' => 2400, 'display' => __('Every 40 Minutes', $this -> plugin_name));
	       	$schedules['50minutes'] 	= array('interval' => 3000, 'display' => __('Every 50 minutes', $this -> plugin_name));
			$schedules['weekly']		= array('interval' => 604800, 'display' => __('Once Weekly', $this -> plugin_name));
			$schedules['monthly']		= array('interval' => 2664000, 'display' => __('Once Monthly', $this -> plugin_name));
	    	
	    	return $schedules;
		}
		
		function screen_settings($current, $screen) {			
			if (!empty($_GET['page']) && $_GET['page'] == $this -> sections -> subscribers) {
				global $Db, $Field;
				$Db -> model = $Field -> model;
				$conditions['1'] = "1 AND `slug` != 'email'";
				$fields = $Db -> find_all($conditions, false, array('title', "ASC"));
			
				$current .= $this -> render('subscribers' . DS . 'screen-options', array('fields' => $fields), false, 'admin');
			}
			
			return $current;
		}
		
		function plugin_action_links($actions = null, $plugin_file = null, $plugin_data = null, $context = null) {
			$this_plugin = plugin_basename(__FILE__);
			
			if (!empty($plugin_file) && $plugin_file == $this_plugin) {
				$actions[] = '<a href="" onclick="jQuery.colorbox({href:ajaxurl + \'?action=' . $this -> pre . 'serialkey\'}); return false;" id="' . $this -> pre . 'submitseriallink" title="' . __('Serial Key', $this -> plugin_name) . '">' . __('Serial Key', $this -> plugin_name) . '</a>';	
			}
			
			return $actions;
		}
		
		function init_textdomain() {
			$locale = get_locale();
			if (!empty($locale)) { 
				if ($locale == "ja" || $locale == "ja_JP") { setlocale(LC_ALL, "ja_JP.UTF8"); }
			} else { setlocale(LC_ALL, "en_US"); }
				
			if (function_exists('load_plugin_textdomain')) {
				load_plugin_textdomain($this -> plugin_name, $this -> plugin_name . DS . 'languages', dirname(plugin_basename(__FILE__)) . DS . 'languages');
			}	
		}
		
		function gzip_compression() {	
			if ($this -> get_option('gzip') == "Y") {
				ob_start('ob_gzhandler');
			}
		}
		
		function save_post($post_id = null, $post = null) {	
			global $wpdb, $Db, $Html, $Post, $Mailinglist, $History, $Queue, $Subscriber, $SubscribersList;
			
			if (empty($post)) {
				$post = get_post($post_id);
			}
		
			if (!empty($post_id) && !empty($post)) {
				switch ($post -> post_status) {
					/* Future scheduled post */
					case 'future'					:						
						if (!empty($_POST[$this -> pre . 'mailinglists'])) {					
							update_post_meta($post_id, $this -> pre . 'mailinglists', $_POST[$this -> pre . 'mailinglists']);
							if (!empty($_POST[$this -> pre . 'theme_id'])) { update_post_meta($post_id, $this -> pre . 'theme_id', $_POST[$this -> pre . 'theme_id']); }
							if (!empty($_POST[$this -> pre . 'qtranslate_language'])) { update_post_meta($post_id, $this -> pre . 'qtranslate_language', $_POST[$this -> pre . 'qtranslate_language']); }
							if (!empty($_POST[$this -> pre . 'sendonpublishef'])) { update_post_meta($post_id, $this -> pre . 'sendonpublishef', $_POST[$this -> pre . 'sendonpublishef']); }
						}
						break;
					/* Post being published */
					case 'publish'					:
						/* Is this post being published immediately? */
						if (!empty($_POST[$this -> pre . 'mailinglists'])) {
							$mailinglists = $_POST[$this -> pre . 'mailinglists'];
							$theme_id = $_POST[$this -> pre . 'theme_id'];
							$qtranslate_language = $_POST[$this -> pre . 'qtranslate_language'];
							$sendonpublishef = $_POST[$this -> pre . 'sendonpublishef'];
						} else {
							/* This looks like a future scheduled post coming through… */
							$mailinglists = get_post_meta($post_id, $this -> pre . 'mailinglists', true);
							$theme_id = get_post_meta($post_id, $this -> pre . 'theme_id', true);
							$qtranslate_language = get_post_meta($post_id, $this -> pre . 'qtranslate_language', true);
							$sendonpublishef = get_post_meta($post_id, $this -> pre . 'sendonpublishef', true);
							
							delete_post_meta($post_id, $this -> pre . 'mailinglists');
							delete_post_meta($post_id, $this -> pre . 'theme_id');
							delete_post_meta($post_id, $this -> pre . 'qtranslate_language');
							delete_post_meta($post_id, $this -> pre . 'sendonpublishef');
						}
				
						if (!empty($mailinglists)) {		
							if (!empty($post_id)) {			
								if ($post = get_post($post_id)) {
									//prepare global post data
									setup_postdata($post);
									
									/* qTranslate stuff */		
									if ($this -> is_plugin_active('qtranslate')) {
										global $q_config;
										if (!empty($q_config['enabled_languages'])) {
											if (!empty($qtranslate_language)) {
												$titles = qtrans_split($post -> post_title);
												$contents = qtrans_split($post -> post_content);
												
												if (!empty($titles[$qtranslate_language])) { $post -> post_title = $titles[$qtranslate_language]; }
												if (!empty($contents[$qtranslate_language])) { $post -> post_content = $contents[$qtranslate_language]; }
											}
										}
									}
														
									//Full post or Excerpt?
									if (!empty($sendonpublishef) && $sendonpublishef == "fp") {
										$post_content = $post -> post_content;
									} elseif (empty($sendonpublishef) || $sendonpublishef == "ep") {
										$post_content = "";
									
										if (function_exists('has_post_thumbnail')) {
											if (has_post_thumbnail($post -> ID)) {
												$post_content .= '<a href="' . get_permalink($post -> ID) . '">' . get_the_post_thumbnail($post -> ID, "thumbnail", array('align' => "left", 'hspace' => "15px", 'class' => $this -> pre . "post_thumbnail")) . '</a>';	
											}
										}
										
										$post_content .= get_the_excerpt();
										$post_content .= ' [<a href="' . get_permalink($post -> ID) . '" title="' . $post -> post_title . '">' . __('read more', $this -> plugin_name) . '</a>]';
										$post_content .= '<hr style="clear:both; display:block; height:1px; width:100%;" />';
									}
									
									if ($this -> get_option('sendonpublishunsubscribe') == "Y") {
										$post_content .= "\n\n";
										$post_content .= "[wpmlunsubscribe]";
									}
									
									if ($this -> get_option('subscriptions') == "Y") {
										$SubscribersList -> check_expirations();
									}
									
									$subject = $post -> post_title;
									
									if (!empty($mailinglists)) {
										//save the History record
										$history_data = array(
											'subject'			=>	$subject,
											'message'			=>	$post_content,
											'theme_id'			=>	$theme_id,
											'mailinglists'		=>	serialize($mailinglists),
											'attachment'		=>	"N",
											'sent'				=>	1,
											'post_id'			=>	$post_id,
											'attachmentfile'	=>	false
										);
										
										$History -> save($history_data, false);
										$history_id = $History -> insertid;
										
										$subscriberids = array();
										$subscriberemails = array();
										
										if (!empty($mailinglists)) {									
											//update scheduling
											$this -> scheduling(true);
											$mailinglistscondition = "(";
											$m = 1;
											
											foreach ($mailinglists as $mailinglist_id) {
												$mailinglistscondition .= "list_id = '" . $mailinglist_id . "'";
												if ($m < count($mailinglists)) { $mailinglistscondition .= " OR "; }
												$m++;	
											}
											
											$query = "SELECT DISTINCT " . $wpdb -> prefix . $Subscriber -> table . ".id, "
											. $wpdb -> prefix . $Subscriber -> table . ".email FROM " 
											. $wpdb -> prefix . $Subscriber -> table . " LEFT JOIN "
											. $wpdb -> prefix . $SubscribersList -> table . " ON "
											. $wpdb -> prefix . $Subscriber -> table . ".id = " . $wpdb -> prefix . $SubscribersList -> table . ".subscriber_id WHERE "
											. $mailinglistscondition . ") AND " . $wpdb -> prefix . $SubscribersList -> table . ".active = 'Y'";
											
											$q_queries = array();
											$attachment = false;
											
											if ($subscribers = $wpdb -> get_results($query)) {
												$q_queries = array();
													
												foreach ($subscribers as $subscriber) {
													$this -> remove_server_limits();
													$subscriber -> mailinglist_id = $_POST[$this -> pre . 'mailinglists'][0];								
													$subject = $post -> post_title;
													$eunique = md5($subscriber -> id . $subscriber -> mailinglist_id . $history_id . date("YmdH", time()));
												
													if ($this -> get_option('scheduling') == "Y") {
														$q_queries[] = $Queue -> save($subscriber, $subject, $post_content, $attachment, $post_id, $history_id, true, $theme_id);
													} else {
														$message = $this -> render_email('send', array('message' => $post_content, 'subject' => $subject, 'subscriber' => $subscriber, 'history_id' => $history_id, 'post_id' => $post_id, 'eunique' => $eunique), false, $this -> htmltf($subscriber -> format), true, $theme_id);
														$this -> execute_mail($subscriber, $subject, $message, $attachment, $history_id, $eunique);
													}
												}
												
												if (!empty($q_queries)) {													
													foreach ($q_queries as $q_query) {
														if (!empty($q_query)) {
															$wpdb -> query($q_query);	
														}
													}
												}
											}
										}
										
										if (!$Post -> get_by_post_id($post -> ID)) {
											$post_data = array('post_id' => $post -> ID, 'sent' => "Y");
											$Post -> save($post_data, false);
										}
									}
								}
							}
						}
						break;
				}
			}
		}
		
		function admin() {	
			if ($this -> has_update()) {
				$update = $this -> vendor('update');
				$update_info = $update -> get_version_info(true);
				$this -> render('update', array('update_info' => $update_info), true, 'admin');
			}
		
			switch ($_GET['method']) {
				case 'wizard_install'			:
					$this -> render('wizard' . DS . 'install', false, true, 'admin');
					break;
				default							:
					$this -> admin_index();
					break;
			}
		}
		
		function admin_menu() {
			global $Queue, $queue_count;
			$queue_count = ($Queue -> count()) ? $Queue -> count() : '';
			$queue_count_icon = '<span class="update-plugins count-1"><span class="update-count">' . $queue_count . '</span></span>';
			$update_icon = ($this -> has_update()) ? '<span class="update-plugins count-1"><span class="update-count">1</span></span>' : '';
			
			$this -> check_roles();
		
			add_menu_page(__('Newsletters', $this -> plugin_name), __('Newsletters', $this -> plugin_name) . $update_icon, 'newsletters_welcome', $this -> sections -> welcome, array($this, 'admin'), $this -> url() . '/images/icon.png');
			$this -> menus['newsletters'] = add_submenu_page($this -> sections -> welcome, __('Overview', $this -> plugin_name), __('Overview', $this -> plugin_name), 'newsletters_welcome', $this -> sections -> welcome, array($this, 'admin'));
			$this -> menus['newsletters-settings'] = add_submenu_page($this -> sections -> welcome, __('General Configuration', $this -> plugin_name), __('Configuration', $this -> plugin_name), 'newsletters_settings', $this -> sections -> settings, array($this, 'admin_config'));
			$this -> menus['newsletters-settings-subscribers'] = add_submenu_page("newsletters_page_" . $this -> sections -> settings, __('Subscribers Configuration', $this -> plugin_name), __('Subscribers', $this -> plugin_name), 'newsletters_settings_subscribers', $this -> sections -> settings_subscribers, array($this, 'admin_settings_subscribers'));
			$this -> menus['newsletters-settings-templates'] = add_submenu_page("newsletters_page_" . $this -> sections -> settings, __('Email Templates Configuration', $this -> plugin_name), __('Email Templates', $this -> plugin_name), 'newsletters_settings_templates', $this -> sections -> settings_templates, array($this, 'admin_settings_templates'));
			$this -> menus['newsletters-settings-system'] = add_submenu_page("newsletters_page_" . $this -> sections -> settings, __('System Configuration', $this -> plugin_name), __('System', $this -> plugin_name), 'newsletters_settings_system', $this -> sections -> settings_system, array($this, 'admin_settings_system'));
			$this -> menus['newsletters-settings-tasks'] = add_submenu_page("newsletters_page_" . $this -> sections -> settings, __('Scheduled Tasks', $this -> plugin_name), __('Scheduled Tasks', $this -> plugin_name), 'newsletters_settings_tasks', $this -> sections -> settings_tasks, array($this, 'admin_settings_tasks'));
			$this -> menus['newsletters-send'] = add_submenu_page($this -> sections -> welcome, __('Create Newsletter', $this -> plugin_name), __('Create Newsletter', $this -> plugin_name), 'newsletters_send', $this -> sections -> send, array($this, 'admin_send'));
			$this -> menus['newsletters-autoresponders'] = add_submenu_page($this -> sections -> welcome, __('Autoresponders', $this -> plugin_name), __('Autoresponders', $this -> plugin_name), 'newsletters_autoresponders', $this -> sections -> autoresponders, array($this, 'admin_autoresponders'));
			$this -> menus['newsletters-autoresponderemails'] = add_submenu_page("newsletters_page_" . $this -> sections -> autoresponders, __('Autoresponder Emails', $this -> plugin_name), __('Autoresponder Emails', $this -> plugin_name), 'newsletters_autoresponderemails', $this -> sections -> autoresponderemails, array($this, 'admin_autoresponderemails'));
			$this -> menus['newsletters-lists'] = add_submenu_page($this -> sections -> welcome, __('Mailing Lists', $this -> plugin_name), __('Mailing Lists', $this -> plugin_name), 'newsletters_lists', $this -> sections -> lists, array($this, 'admin_mailinglists'));
			$this -> menus['newsletters-groups'] = add_submenu_page($this -> sections -> welcome, __('Groups', $thsi -> plugin_name), __('Groups', $this -> plugin_name), 'newsletters_groups', $this -> sections -> groups, array($this, 'admin_groups'));
			$this -> menus['newsletters-subscribers'] = add_submenu_page($this -> sections -> welcome, __('Subscribers', $this -> plugin_name), __('Subscribers', $this -> plugin_name), 'newsletters_subscribers', $this -> sections -> subscribers, array($this, 'admin_subscribers'));
			$this -> menus['newsletters-fields'] = add_submenu_page($this -> sections -> welcome, __('Custom Fields', $this -> plugin_name), __('Custom Fields', $this -> plugin_name), 'newsletters_fields', $this -> sections -> fields, array($this, 'admin_fields'));
			$this -> menus['newsletters-import'] = add_submenu_page($this -> sections -> welcome, __('Import/Export Subscribers', $this -> plugin_name), __('Import/Export', $this -> plugin_name), 'newsletters_importexport', $this -> sections -> importexport, array($this, 'admin_importexport'));
			$this -> menus['newsletters-themes'] = add_submenu_page($this -> sections -> welcome, __('Themes', $this -> plugin_name), __('Themes', $this -> plugin_name), 'newsletters_themes', $this -> sections -> themes, array($this, 'admin_themes')); 
			$this -> menus['newsletters-templates'] = add_submenu_page($this -> sections -> welcome, __('Email Templates', $this -> plugin_name), __('Email Templates', $this -> plugin_name), 'newsletters_templates', $this -> sections -> templates, array($this, 'admin_templates'));
			$this -> menus['newsletters-templates-save'] = add_submenu_page($this -> menus['newsletters-templates'], __('Save a Template', $this -> plugin_name), __('Save a Template', $this -> plugin_name), 'newsletters_templates_save', $this -> sections -> templates_save, array($this, 'admin_templates'));
			$this -> menus['newsletters-queue'] = add_submenu_page($this -> sections -> welcome, __('Email Queue', $this -> plugin_name), __('Email Queue', $this -> plugin_name) . ((!empty($queue_count)) ? $queue_count_icon : ''), 'newsletters_queue', $this -> sections -> queue, array($this, 'admin_mailqueue'));
			$this -> menus['newsletters-history'] = add_submenu_page($this -> sections -> welcome, __('History/Draft Emails', $this -> plugin_name), __('History/Draft Emails', $this -> plugin_name), 'newsletters_history', $this -> sections -> history, array($this, 'admin_history'));
			$this -> menus['newsletters-orders'] = add_submenu_page($this -> sections -> welcome, __('Subscription Orders', $this -> plugin_name), __('Subscription Orders', $this -> plugin_name), 'newsletters_orders', $this -> sections -> orders, array($this, 'admin_orders'));
			$this -> menus['newsletters-extensions'] = add_submenu_page($this -> sections -> welcome, __('Extensions', $this -> plugin_name), __('Extensions', $this -> plugin_name), 'newsletters_extensions', $this -> sections -> extensions, array($this, 'admin_extensions'));
			$this -> menus['newsletters-settings-updates'] = add_submenu_page($this -> sections -> welcome, __('Updates', $this -> plugin_name), __('Updates', $this -> plugin_name), 'newsletters_settings_updates', $this -> sections -> settings_updates, array($this, 'admin_settings_updates'));
			$this -> menus['newsletters-extensions-settings'] = add_submenu_page($this -> menus['newsletters-extensions'], __('Extensions Settings', $this -> plugin_name), __('Extensions Settings', $this -> plugin_name), 'newsletters_extensions_settings', $this -> sections -> extensions_settings, array($this, 'admin_extensions_settings'));
			
			if (WPML_SHOW_SUPPORT) {
				$this -> menus['newsletters-support'] = add_submenu_page($this -> sections -> welcome, __('Support &amp; Help', $this -> plugin_name), __('Support &amp; Help', $this -> plugin_name), 'newsletters_support', $this -> sections -> support, array($this, 'admin_help'));
			}
			
			add_action('admin_head-' . $this -> menus['newsletters'], array($this, 'admin_head_welcome'));
			add_action('admin_head-' . $this -> menus['newsletters-send'], array($this, 'admin_head_send'));
			add_action('admin_head-' . $this -> menus['newsletters-templates-save'], array($this, 'admin_head_templates_save'));
			add_action('admin_head-' . $this -> menus['newsletters-settings'], array($this, 'admin_head_settings'));
			add_action('admin_head-' . $this -> menus['newsletters-settings-system'], array($this, 'admin_head_settings_system'));
			add_action('admin_head-' . $this -> menus['newsletters-settings-templates'], array($this, 'admin_head_settings_templates'));
			add_action('admin_head-' . $this -> menus['newsletters-settings-subscribers'], array($this, 'admin_head_settings_subscribers'));
			add_action('admin_head-' . $this -> menus['newsletters-extensions-settings'], array($this, 'admin_head_settings_extensions_settings'));
		}
		
		function admin_head() {	
			$this -> render('head', false, true, 'admin');
		}
		
		function admin_head_welcome() {
			global $Metabox;
			
			add_meta_box('subscribersdiv', __('Total Subscribers', $this -> plugin_name), array($Metabox, 'welcome_subscribers'), "newsletters_page_" . $this -> sections -> welcome, 'side', 'core');
			add_meta_box('listsdiv', __('Total Mailing Lists', $this -> plugin_name), array($Metabox, 'welcome_lists'), "newsletters_page_" . $this -> sections -> welcome, 'side', 'core');
			add_meta_box('emailsdiv', __('Total Emails', $this -> plugin_name), array($Metabox, 'welcome_emails'), "newsletters_page_" . $this -> sections -> welcome, 'side', 'core');
			add_meta_box('bouncesdiv', __('Bounced Emails', $this -> plugin_name), array($Metabox, 'welcome_bounces'), "newsletters_page_" . $this -> sections -> welcome, 'side', 'core');
			add_meta_box('statsdiv', __('Statistics Overview', $this -> plugin_name), array($Metabox, 'welcome_stats'), "newsletters_page_" . $this -> sections -> welcome, 'normal', 'core');
			add_meta_box('historydiv', __('Recent Emails', $this -> plugin_name), array($Metabox, 'welcome_history'), "newsletters_page_" . $this -> sections -> welcome, 'normal', 'core');
			
			do_action('do_meta_boxes', "newsletters_page" . $this -> sections -> welcome, 'side');
			do_action('do_meta_boxes', "newsletters_page" . $this -> sections -> welcome, 'normal');
			do_action('do_meta_boxes', "newsletters_page" . $this -> sections -> welcome, 'advanced');
		}
		
		function admin_head_send() {
			global $Metabox;
		
			add_meta_box('mailinglistsdiv', __('Subscribers', $this -> plugin_name), array($Metabox, 'send_mailinglists'), "newsletters_page_" . $this -> sections -> send, 'side', 'core');
			add_meta_box('themesdiv', __('Theme', $this -> plugin_name), array($Metabox, 'send_theme'), "newsletters_page_" . $this -> sections -> send, 'side', 'core');
			add_meta_box('submitdiv', __('Send Newsletter', $this -> plugin_name), array($Metabox, 'send_submit'), "newsletters_page_" . $this -> sections -> send, 'side', 'core');
			add_meta_box('setvariablesdiv', __('Variables &amp; Custom Fields', $this -> plugin_name), array($Metabox, 'send_setvariables'), "newsletters_page_" . $this -> sections -> send, 'normal', 'core');
			add_meta_box('templatesdiv', __('Email Templates', $this -> plugin_name), array($Metabox, 'send_templates'), "newsletters_page_" . $this -> sections -> send, 'normal', 'core');
			add_meta_box('attachmentdiv', __('Email Attachment', $this -> plugin_name), array($Metabox, 'send_attachment'), "newsletters_page_" . $this -> sections -> send, 'normal', 'core');
			add_meta_box('publishdiv', __('Publish as Post', $this -> plugin_name), array($Metabox, 'send_publish'), "newsletters_page_" . $this -> sections -> send, 'normal', 'core');
			
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> send, 'side');
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> send, 'normal');
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> send, 'advanced');
		}
		
		function admin_head_templates_save() {
			global $Metabox;
		
			add_meta_box('submitdiv', __('Newsletter Template', $this -> plugin_name), array($Metabox, 'templates_submit'), "admin_page_" . $this -> sections -> templates_save, 'side', 'core');
			
			do_action('do_meta_boxes', "admin_page_" . $this -> sections -> templates_save, 'side');
			do_action('do_meta_boxes', "admin_page_" . $this -> sections -> templates_save, 'normal');
			do_action('do_meta_boxes', "admin_page_" . $this -> sections -> templates_save, 'advanced');
		}
		
		function admin_head_settings() {
			global $Metabox;
			
			add_meta_box('submitdiv', __('Configuration Settings', $this -> plugin_name), array($Metabox, 'settings_submit'), "newsletters_page_" . $this -> sections -> settings, 'side', 'core');
			add_meta_box('generaldiv', __('General Mail Settings', $this -> plugin_name), array($Metabox, 'settings_general'), "newsletters_page_" . $this -> sections -> settings, 'normal', 'core');
			add_meta_box('sendingdiv', __('Sending Settings', $this -> plugin_name), array($Metabox, 'settings_sending'), "newsletters_page_" . $this -> sections -> settings, 'normal', 'core');
			add_meta_box('optindiv', __('Default Subscription Form Settings', $this -> plugin_name), array($Metabox, 'settings_optin'), "newsletters_page_" . $this -> sections -> settings, 'normal', 'core');
			add_meta_box('subscriptionsdiv', __('Paid Subscriptions', $this -> plugin_name), array($Metabox, 'settings_subscriptions'), "newsletters_page_" . $this -> sections -> settings, 'normal', 'core');
			add_meta_box('ppdiv', __('PayPal Configuration', $this -> plugin_name), array($Metabox, 'settings_pp'), "newsletters_page_" . $this -> sections -> settings, 'normal', 'core');
			add_meta_box('tcdiv', __('2CheckOut Configuration', $this -> plugin_name), array($Metabox, 'settings_tc'), "newsletters_page_" . $this -> sections -> settings, 'normal', 'core');
			add_meta_box('publishingdiv', __('Post Publishing Configuration', $this -> plugin_name), array($Metabox, 'settings_publishing'), "newsletters_page_" . $this -> sections -> settings, 'normal', 'core');
			add_meta_box('schedulingdiv', __('Email Scheduling', $this -> plugin_name), array($Metabox, 'settings_scheduling'), "newsletters_page_" . $this -> sections -> settings, 'normal', 'core');
			add_meta_box('bouncediv', __('Bounce Configuration', $this -> plugin_name), array($Metabox, 'settings_bounce'), "newsletters_page_" . $this -> sections -> settings, 'normal', 'core');
			add_meta_box('latestposts', __('Latest Posts Subscription', $this -> plugin_name), array($Metabox, 'settings_latestposts'), "newsletters_page_" . $this -> sections -> settings, 'normal', 'core');
			add_meta_box('customcss', __('Theme, Scripts &amp; Custom CSS', $this -> plugin_name), array($Metabox, 'settings_customcss'), "newsletters_page_" . $this -> sections -> settings, 'normal', 'core');
			
			if ($this -> language_ready()) {
				add_meta_box('languagediv', __('Language Configuration', $this -> plugin_name), array($Metabox, 'settings_language'), "newsletters_page_" . $this -> sections -> settings, 'normal', 'core');
			}
			
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> settings, 'side');
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> settings, 'normal');
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> settings, 'advanced');
		}
		
		function admin_head_settings_templates() {
			global $Metabox;
		
			add_meta_box('submitdiv', __('Configuration Settings', $this -> plugin_name), array($Metabox, 'settings_submit'), "newsletters_page_" . $this -> sections -> settings_templates, 'side', 'core');
			add_meta_box('confirmdiv', __('Confirmation Email', $this -> plugin_name), array($Metabox, 'settings_templates_confirm'), "newsletters_page_" . $this -> sections -> settings_templates, 'normal', 'core');
			add_meta_box('bouncediv', __('Bounce Email', $this -> plugin_name), array($Metabox, 'settings_templates_bounce'), "newsletters_page_" . $this -> sections -> settings_templates, 'normal', 'core');
			add_meta_box('unsubscribediv', __('Unsubscribe Email', $this -> plugin_name), array($Metabox, 'settings_templates_unsubscribe'), "newsletters_page_" . $this -> sections -> settings_templates, 'normal', 'core');
			add_meta_box('expirediv', __('Expiration Email', $this -> plugin_name), array($Metabox, 'settings_templates_expire'), "newsletters_page_" . $this -> sections -> settings_templates, 'normal', 'core');
			add_meta_box('orderdiv', __('Paid Subscription Email', $this -> plugin_name), array($Metabox, 'settings_templates_order'), "newsletters_page_" . $this -> sections -> settings_templates, 'normal', 'core');
			add_meta_box('schedulediv', __('Cron Schedule Email', $this -> plugin_name), array($Metabox, 'settings_templates_schedule'), "newsletters_page_" . $this -> sections -> settings_templates, 'normal', 'core');
			add_meta_box('subscribediv', __('New Subscription Email', $this -> plugin_name), array($Metabox, 'settings_templates_subscribe'), "newsletters_page_" . $this -> sections -> settings_templates, 'normal', 'core');
			
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> settings_templates, 'side');
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> settings_templates, 'normal');
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> settings_templates, 'advanced');
		}
		
		function admin_head_settings_subscribers() {
			global $Metabox;
			
			add_meta_box('submitdiv', __('Configuration Settings', $this -> plugin_name), array($Metabox, 'settings_submit'), "newsletters_page_" . $this -> sections -> settings_subscribers, 'side', 'core');
			add_meta_box('managementdiv', __('Subscriber Management Section', $this -> plugin_name), array($Metabox, 'settings_management'), "newsletters_page_" . $this -> sections -> settings_subscribers, 'normal', 'core');
			add_meta_box('subscribersdiv', __('Subscription Behaviour', $this -> plugin_name), array($Metabox, 'settings_subscribers'), "newsletters_page_" . $this -> sections -> settings_subscribers, 'normal', 'core');
			add_meta_box('unsubscribediv', __('Unsubscribe Behaviour', $this -> plugin_name), array($Metabox, 'settings_unsubscribe'), "newsletters_page_" . $this -> sections -> settings_subscribers, 'normal', 'core');
			
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> settings_subscribers, 'side');
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> settings_subscribers, 'normal');
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> settings_subscribers, 'advanced');
		}
		
		function admin_head_settings_extensions_settings() {
			global $Metabox;
			
			add_meta_box('submitdiv', __('Extensions Settings', $this -> plugin_name), array($Metabox, 'extensions_settings_submit'), "newsletters_page_" . $this -> sections -> extensions_settings, 'side', 'core');
			do_action($this -> pre . '_metaboxes_extensions_settings', "newsletters_page_" . $this -> sections -> extensions_settings);
			
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> extensions_settings, 'side');
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> extensions_settings, 'normal');
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> extensions_settings, 'advanced');
		}
		
		function admin_head_settings_system() {
			global $Metabox;
		
			add_meta_box('submitdiv', __('Configuration Settings', $this -> plugin_name), array($Metabox, 'settings_submit'), "newsletters_page_" . $this -> sections -> settings_system, 'side', 'core');
			add_meta_box('wprelateddiv', __('WordPress Related', $this -> plugin_name), array($Metabox, 'settings_wprelated'), "newsletters_page_" . $this -> sections -> settings_system, 'normal', 'core');
			add_meta_box('autoimportusersdiv', __('Auto Import Users', $this -> plugin_name), array($Metabox, 'settings_importusers'), "newsletters_page_" . $this -> sections -> settings_system, 'normal', 'core');
			add_meta_box('commentform', __('WordPress Comment- and Registration Form', $this -> plugin_name), array($Metabox, 'settings_commentform'), "newsletters_page_" . $this -> sections -> settings_system, 'normal', 'core');
			
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> settings_subscribers, 'side');
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> settings_subscribers, 'normal');
			do_action('do_meta_boxes', "newsletters_page_" . $this -> sections -> settings_subscribers, 'advanced');
		}
		
		function hardcoded($list_id = "select", $lists = null) {
			$options = $this -> get_option('embed');
			
			if ($this -> is_plugin_active('qtranslate')) {
				global $q_config;
				
				foreach ($options as $opt_key => $opt_val) {
					$options[$opt_key] = $options[$opt_key][$q_config['language']];
				}
				
				$options['language'] = $q_config['language'];
			}
			
			if ($options['ajax'] == "Y") {
				$wpoptinid = (!empty($_GET['divid'])) ? $_GET['divid'] : (time() * rand(1,999)); 
			} else {
				$wpoptinid = (empty($_GET[$this -> pre . 'formid'])) ? (time() * rand(1, 999)) : $_GET[$this -> pre . 'formid'];
			}
			
			if (!empty($list_id) && ($list_id == "select" || $list_id == "checkboxes")) {
				if (!empty($lists) && ($listsarray = @explode(",", $lists)) !== false) {
					$options['listsstring'] = $lists;
					$options['lists'] = $listsarray;
				}
			}
			
			$options['list'] = $list_id;
			$options['embed'] = true;
			$options['offsite'] = false;
			
			echo '<div class="' . $this -> pre . 'widget ' . $this -> pre . '" id="' . $this -> pre . 'widget-' . $wpoptinid . '">';
			echo $this -> render('widget-front', array('options' => $options, 'wpoptinid' => $wpoptinid), false);
			echo '</div>';
		}
		
		function wpmlwidget($args, $widget_args = array()) {
			extract($args, EXTR_SKIP);
			
			if (is_numeric($widget_args)) {
				$widget_args = array('number' => $widget_args);
			}
				
			$widget_args = wp_parse_args($widget_args, array('number' => -1));
			extract($widget_args, EXTR_SKIP);
		
			$options = $this -> get_option('widget');
			if (empty($options[$number])) {
				return;
			}
			
			//is qTranslate installed and active?
			if ($this -> is_plugin_active('qtranslate')) {
				global $q_config;
				$qtranslateactive = true;
			}
			
			if (!empty($options[$number]) && is_array($options[$number])) {
				foreach ($options[$number] as $opt_key => $opt_val) {
					
					//is qTranslate active?
					if (!empty($qtranslateactive) && $qtranslateactive == true && !empty($options[$number][$opt_key]) && is_array($options[$number][$opt_key])) {
						//assign the languaged value to the actual one
						$options[$number][$opt_key] = $options[$number][$opt_key][$q_config['language']];	
					}
					
					if (empty($opt_val)) {
						unset($options[$number][$opt_key]);
					}
				}
			}
			
			$embed = $this -> get_option('embed');		
			$newoptions = wp_parse_args($options[$number], $embed);
			
			if (!empty($qtranslateactive) && $qtranslateactive == true) {
				global $q_config;
				$newoptions['language'] = $q_config['language'];	
			}
			
			if ($options[$number]['ajax'] == "Y") {
				$wpoptinid = (!empty($_GET['divid'])) ? $_GET['divid'] : $number; 
			} elseif ($options[$number]['ajax'] == "N") {
				$wpoptinid = (empty($_GET[$this -> pre . 'formid'])) ? $number : $_GET[$this -> pre . 'formid'];
			}
			
			if (!empty($newoptions['list']) && ($newoptions['list'] == "select" || $newoptions['list'] == "checkboxes" || $newoptions['list'] == "multiple")) {
				if (!empty($newoptions['lists']) && ($lists = @explode(",", $newoptions['lists'])) !== false) {
					$newoptions['listsstring'] = $newoptions['lists'];
					$newoptions['lists'] = $lists;
				}
			}
		
			?>
			
			<?php echo $before_widget; ?>
			<?php $this -> render('widget-front', array('options' => $newoptions, 'args' => $args, 'wpoptinid' => $wpoptinid)); ?>
			<?php echo $after_widget; ?>
			
			<?php
		}
		
		function wpmlwidget_control($widget_args = array()) {
			global $wp_registered_widgets;
			static $updated = false;
		
			if (is_numeric($widget_args)) {
				$widget_args = array('number' => $widget_args);
			}
				
			$widget_args = wp_parse_args($widget_args, array('number' => -1));
			extract($widget_args, EXTR_SKIP);
		
			$options = $this -> get_option('widget');
			if (!is_array($options)) {
				$options = array();
			}
		
			if (!$updated && !empty($_POST['sidebar']) ) {
				$sidebar = (string) $_POST['sidebar'];
		
				$sidebars_widgets = wp_get_sidebars_widgets();
				if (isset($sidebars_widgets[$sidebar])) {
					$this_sidebar =& $sidebars_widgets[$sidebar];
				} else {
					$this_sidebar = array();
				}
		
				foreach ($this_sidebar as $_widget_id) {
					if ($this -> pre . 'widget' == $wp_registered_widgets[$_widget_id]['callback'] && isset($wp_registered_widgets[$_widget_id]['params'][0]['number']) ) {
						$widget_number = $wp_registered_widgets[$_widget_id]['params'][0]['number'];
						
						if (!in_array($this -> pre . "widget-$widget_number", $_POST['widget-id'])) {
							unset($options[$widget_number]);
						}
					}
				}
		
				if (!empty($_POST[$this -> pre . 'widget'])) {
					foreach ($_POST[$this -> pre . 'widget'] as $widget_number => $widget_value) {
						$options[$widget_number] = array(
							'title' 			=> 	$widget_value['title'], 
							'list' 				=> 	$widget_value['list'], 
							'lists'				=>	$widget_value['lists'],
							'subtitle' 			=> 	$widget_value['subtitle'], 
							'acknowledgement' 	=> 	$widget_value['acknowledgement'], 
							'subscribeagain'	=>	$widget_value['subscribeagain'],
							'ajax' 				=> 	$widget_value['ajax'],
							'button'			=>	$widget_value['button'],
							'captcha'			=>	$widget_value['captcha'],
						);
					}
				}
		
				$this -> update_option('widget', $options);
				$updated = true;
			}
		
			if (-1 == $number) {			
				$number = '%i%';
				$embed = $this -> get_option('embed');
				$options[$number]['subtitle'] = __('Subscribe to our newsletter.', $this -> plugin_name);
				
				foreach ($embed as $ekey => $eval) {
					$options[$number][$ekey] = $eval;	
				}
			}
			
			$this -> render('widget-control', array('number' => $number, 'options' => $options, 'curoptions' => $options[$number]), true, 'admin');
		}
		
		function wpmlwidget_register() {
			if (!$options = $this -> get_option('widget')) {
				$options = array();
			}
		
			$widget_ops = array('classname' => $this -> pre . 'widget ' . $this -> pre, 'description' => __('Subscription form on your sidebar.', $this -> plugin_name));
			$control_ops = array('width' => 400, 'height' => 350, 'id_base' => $this -> pre . 'widget');
			$name = __('Newsletter Subscription', $this -> plugin_name);
		
			$registered = false;
			if (!empty($options) && is_array($options)) {			
				foreach (array_keys($options) as $o) {					
					$id = $this -> pre . 'widget-' . $o;
					$registered = true;
					wp_register_sidebar_widget($id, $name, array($this, $this -> pre . 'widget'), $widget_ops, array('number' => $o));
					wp_register_widget_control($id, $name, array($this, $this -> pre . 'widget_control'), $control_ops, array('number' => $o));
				}
			}
		
			if (empty($registered) || $registered == false) {
				wp_register_sidebar_widget($this -> pre . 'widget-1', $name, array($this, $this -> pre . 'widget'), $widget_ops, array('number' => -1));
				wp_register_widget_control($this -> pre . 'widget-1', $name, array($this, $this -> pre . 'widget_control'), $control_ops, array('number' => -1));
			}
		}
		
		function admin_index() {	
			$this -> render_admin('index', false, true, 'admin');
		}
		
		function admin_send() {
			global $wpdb, $user_ID, $Db, $Template, $Html, $History, $HistoriesAttachment, $Mailinglist, $Queue, $Subscriber, $Field, $SubscribersList;
		
			$this -> remove_server_limits();
			$mailinglists = $Mailinglist -> get_all('*', true);
			$templates = $Template -> get_all();
			$sentmailscount = 0;
			
			/* Themes */
			$Db -> model = $Theme -> model;
			$themes = $Db -> find_all(false, false, array('title', "ASC"));
			
			switch ($_GET['method']) {			
				case 'template'		:
					if ($template = $Template -> get($_GET['id'])) {
						$this -> render_message(__('Email template has been loaded into the subject field and editor below.', $this -> plugin_name));
						$_POST = array('subject' => $template -> title, 'theme_id' => $template -> theme_id, 'inctemplate' => $template -> id, 'content' => $template -> content);
						$this -> render_admin('send', array('mailinglists' => $mailinglists, 'themes' => $themes, 'templates' => $templates));
					} else {
						$message = __('Email template could not be loaded, please try again.', $this -> plugin_name);
						$this -> redirect($this -> referer, "error", $message);	
					}
					break;				
				case 'history'		:
					if ($history = $History -> get($_GET['id'])) {	
						if (empty($_GET[$this -> pre . 'updated'])) {
							$this -> render_message(__('History/draft email has been loaded into the subject field and editor below.', $this -> plugin_name));
						}
								
						$_POST = array(
							'ishistory'			=>	$history -> id,
							'subject'			=>	$history -> subject,
							'content'			=>	$history -> message,
							'groups'			=>	$history -> groups,
							'mailinglists'		=>	$history -> mailinglists,
							'theme_id'			=>	$history -> theme_id,
							'conditions'		=>	maybe_unserialize($history -> conditions),
							'fields'			=>	maybe_unserialize($history -> conditions),
							'attachments'		=>	$history -> attachments,
						);
						
						$this -> render_admin('send', array('mailinglists' => $mailinglists, 'themes' => $themes, 'templates' => $templates), true, 'admin');
					} else {
						$message = __('History/draft email could not be loaded, please try again.', $this -> plugin_name);
						$this -> redirect($this -> referer, "error", $message);	
					}
					break;				
				default				:					
					if (!empty($_POST)) {
						if (!empty($_POST['groups'])) {
							global $Db, $wpmlGroup, $Mailinglist;
							
							foreach ($_POST['groups'] as $group_id) {
								$Db -> model = $Mailinglist -> model;
								
								if ($mailinglists = $Db -> find_all(array('group_id' => $group_id), array('id'))) {
									foreach ($mailinglists as $mailinglist) {
										$_POST['mailinglists'][] = $mailinglist -> id;
									}
								}
							}
						}
						
						$mailinglists = false;
						$mailinglist = false;
						
						global $errors;
						$errors = array();
												
						if (empty($_POST['subject'])) { $errors['subject'] = __('Please fill in an email subject', $this -> plugin_name); }
						if (empty($_POST['content'])) { $errors['content'] = __('Please fill in a newsletter message', $this -> plugin_name); }
						
						if (empty($_POST['preview'])) {
							if (empty($_POST['mailinglists']) || !is_array($_POST['mailinglists'])) { $errors['mailinglists'] = __('Please select mailing list(s)', $this -> plugin_name); }
						}
						
						if (!empty($_POST['sendattachment']) && $_POST['sendattachment'] == "Y") {						
							/* New Attachments */
							if (!empty($_FILES['attachments']['name'])) {
								$newattachments = array();
								
								foreach ($_FILES['attachments']['name'] as $fkey => $attachmentfile) {
									if ($_FILES['attachments']['error'][$fkey] == 0) {
										$name = $this -> stripext($_FILES['attachments']['name'][$fkey], 'name');
										$ext = $this -> stripext($_FILES['attachments']['name'][$fkey]);
										$attfile = $name . substr(time(), 0, 4) . '.' . $ext;
										$attpath = WP_CONTENT_DIR . DS . 'uploads' . DS;
										$attfull = $attpath . $attfile;
										
										if (move_uploaded_file($_FILES['attachments']['tmp_name'][$fkey], $attfull)) {
											$newattachments[] = array(
												'title'					=>	$_FILES['attachments']['name'][$fkey],
												'filename'				=>	$attfull,
											);	
										}
									}
								}
							}
						}
						
						$_POST['subject'] = stripslashes($_POST['subject']);
						$_POST['content'] = stripslashes($_POST['content']);
						
						//unset the fields if the "dofieldsconditions" was unchecked
						if (empty($_POST['dofieldsconditions'])) {
							unset($_POST['fields']);
						}
	
						if (empty($errors)) {					
							if (empty($_POST['preview']) && empty($_POST['draft'])) {												
								if (!empty($_POST)) {															
									if (!empty($errors)) {
										if ($this -> get_option('scheduling') == "Y") {
											$this -> render_error(__('Newsletter could not be scheduled/qeueued', $this -> plugin_name));
										} else {
											$this -> render_error(__('Newsletter could not be sent', $this -> plugin_name));
										}
									} else {								
										if (!empty($_POST['publishpost']) && $_POST['publishpost'] == "Y") {									
											$status = (!empty($_POST['post_status'])) ? $_POST['post_status'] : 'draft';
											$slug = (!empty($_POST['post_slug'])) ? $_POST['post_slug'] : $Html -> sanitize($_POST['subject'], '-');
										
											$post = array(
												'post_title'			=>	$_POST['subject'],
												'post_content'			=>	$this -> strip_set_variables($_POST['content']),
												'post_status'			=>	$status,
												'post_slug'				=>	$slug,
												'post_category'			=>	$_POST['cat'],
												'post_type'				=>	"post",
												'post_author'			=>	(empty($_POST['post_author'])) ? $user_ID : $_POST['post_author'],
											);
											
											$currstatus = $this -> get_option('sendonpublish');
											$this -> update_option('sendonpublish', 'N');
											$_POST['sendtolist'] = "N";
											$post_id = wp_insert_post($post);
											$this -> update_option('sendonpublish', $currstatus);
										} else { $post_id = false; }
										
										$history_data = array(
											'subject'			=>	$_POST['subject'],
											'message'			=>	$_POST['content'],
											'theme_id'			=>	$_POST['theme_id'],
											'mailinglists'		=>	serialize($_POST['mailinglists']),
											'groups'			=>	serialize($_POST['groups']),
											'newattachments'	=>	$newattachments,
										);
										
										if (!empty($_POST['ishistory'])) {										
											$history_data['id'] = $_POST['ishistory'];
											
											$Db -> model = 'History';
											if ($history_curr = $Db -> find(array('id' => $history_data['id']))) {
												$history_data['sent'] = ($history_curr -> sent + 1);
											} else {
												$history_data['sent'] = 1;
											}
										} else {
											$history_data['sent'] = 1;
										}
										
										$History -> save($history_data, false);
										$history_id = $History -> insertid;
									
										if ($this -> get_option('subscriptions') == "Y") {
											$SubscribersList -> check_expirations();
										}
										
										$subscriberids = array();
										$subscriberemails = array();
										
										if (!empty($_POST['mailinglists'])) {									
											//update scheduling
											$this -> scheduling(true);
											$mailinglistscondition = "(";
											$m = 1;
											
											foreach ($_POST['mailinglists'] as $mailinglist_id) {
												$mailinglistscondition .= "list_id = '" . $mailinglist_id . "'";
												if ($m < count($_POST['mailinglists'])) { $mailinglistscondition .= " OR "; }
												$m++;	
											}
											
											/* Fields Conditions */
											if (!empty($_POST['dofieldsconditions'])) {
												$fieldsquery = "";
												
												if (!empty($_POST['fields'])) {
													foreach ($_POST['fields'] as $field_slug => $field_value) {
														if (!empty($field_value)) {
															$fieldsquery .= " AND " . $wpdb -> prefix . $Subscriber -> table . "." . $field_slug . " = '" . $field_value . "'";
														}
													}
												}
											}
											
											/* Attachments */
											$Db -> model = $History -> model;
											$history = $Db -> find(array('id' => $history_id));
											
											$query = "SELECT DISTINCT " . $wpdb -> prefix . $Subscriber -> table . ".id, "
											. $wpdb -> prefix . $Subscriber -> table . ".email FROM " 
											. $wpdb -> prefix . $Subscriber -> table . " LEFT JOIN "
											. $wpdb -> prefix . $SubscribersList -> table . " ON "
											. $wpdb -> prefix . $Subscriber -> table . ".id = " . $wpdb -> prefix . $SubscribersList -> table . ".subscriber_id WHERE "
											. $mailinglistscondition . ") AND " . $wpdb -> prefix . $SubscribersList -> table . ".active = 'Y'"
											. $fieldsquery;
											
											$sentmailscount = 0;
											$q_queries = array();
											
											if ($subscribers = $wpdb -> get_results($query)) {				
												$datasets = array();
												$q_queries = array();
												$d = 0;
												
												foreach ($subscribers as $subscriber) {												
													$subscriber -> mailinglist_id = $_POST['mailinglists'][0];										
													$subscriber -> mailinglists = $Subscriber -> mailinglists($subscriber -> id, $_POST['mailinglists']);
													
													if ($this -> get_option('sendingprogress') == "N") {
														$q_queries[] = $Queue -> save(
															$subscriber, 
															$_POST['subject'], 
															$_POST['content'], 
															$history -> attachments, 
															$post_id, 
															$history_id, 
															true, 
															$_POST['theme_id'], 
															$_POST['senddate']
														);
													} else {
														$dataset = array(
															'id'				=>	$subscriber -> id,
															'email'				=>	$subscriber -> email,
															'mailinglist_id'	=>	$subscriber -> mailinglist_id,
															'mailinglists'		=>	$subscriber -> mailinglists,
															'format'			=> 	(empty($subscriber -> format) ? 'html' : $subscriber -> format),
														);
													
														$datasets[$d] = $dataset;
													}
													
													$d++;
												}
												
												if (!empty($q_queries)) {												
													foreach ($q_queries as $q_query) {
														if (!empty($q_query)) {
															$wpdb -> query($q_query);
														}
													}
												}
												
												if ($this -> get_option('sendingprogress') == "Y") {						
													$this -> render('send-post', array('subscribers' => $datasets, 'subject' => $_POST['subject'], 'content' => $_POST['content'], 'attachments' => $history -> attachments, 'post_id' => $post_id, 'history_id' => $history_id, 'theme_id' => $_POST['theme_id']), true, 'admin');
													$dontrendersend = true;
												} else {
													$message = count($subscribers) . ' ' . __('emails have been queued.', $this -> plugin_name);
													$this -> redirect('?page=' . $this -> sections -> queue, 'message', $message);
												}
											}
										}
										
										if (!empty($_POST['inctemplate'])) {
											$Template -> inc_sent($_POST['inctemplate']);
										}
									}
								}
							} elseif (!empty($_POST['draft'])) {									
								/* History */			
								$history_data = array(
									'subject'			=>	$_POST['subject'],
									'message'			=>	$_POST['content'],
									'theme_id'			=>	$_POST['theme_id'],
									'conditions'		=>	serialize($_POST['fields']),
									'mailinglists'		=>	serialize($_POST['mailinglists']),
									'groups'			=>	serialize($_POST['groups']),
									'newattachments'	=>	$newattachments,
								);
								
								if (!empty($_POST['ishistory'])) {										
									$history_data['id'] = $_POST['ishistory'];
									
									$Db -> model = $History -> model;
									if ($history_curr = $Db -> find(array('id' => $history_data['id']))) {
										$history_data['sent'] = $history_curr -> sent;
									}
								}
								
								if ($History -> save($history_data, false)) {
									$message = __('Draft has been successfully saved. It has been saved to your email history.', $this -> plugin_name);
									$this -> redirect('?page=' . $this -> sections -> send . '&method=history&id=' . $History -> insertid, 'message', $message);
								} else {
									$message = __('Draft could not be saved. Please fill in all required fields', $this -> plugin_name);
									$this -> render_error($message);
								}
							/* Send a preview email */
							} else {						
								$history_data = array(
									'subject'			=>	$_POST['subject'],
									'message'			=>	$_POST['content'],
									'theme_id'			=>	$_POST['theme_id'],
									'conditions'		=>	serialize($_POST['fields']),
									'mailinglists'		=>	serialize($_POST['mailinglists']),
									'groups'			=>	serialize($_POST['groups']),
									'newattachments'	=>	$newattachments,
								);
								
								if (!empty($_POST['ishistory'])) {										
									$history_data['id'] = $_POST['ishistory'];
									
									$Db -> model = $History -> model;
									if ($history_curr = $Db -> find(array('id' => $history_data['id']))) {
										$history_data['sent'] = $history_curr -> sent;
									}
								}
								
								$History -> save($history_data, false);
								$history_id = $History -> insertid;
								$Db -> model = $History -> model;
								$history = $Db -> find(array('id' => $history_id));
							
								$subscriber -> id = $Subscriber -> admin_subscriber_id();
								$subscriber -> email = $this -> get_option('adminemail');
								$subject = $_POST['subject'];
								$message = $this -> render_email('send', array('message' => $_POST['content'], 'subject' => $subject, 'subscriber' => $subscriber, 'history_id' => $history_id), false, true, true, $_POST['theme_id']);
								
								if (!$this -> execute_mail($subscriber, $subject, $message, $history -> attachments, $history_id, false, false)) {
									$this -> render_error(__('Preview cannot be sent, please check your email settings under Configuration.', $this -> plugin_name));
								} else {
									$this -> render_message(__('Preview has been sent to', $this -> plugin_name) . ' <strong>' . $this -> get_option('adminemail') . '</strong>');
								}
								
								$_POST = array(
									'ishistory'			=>	$history -> id,
									'subject'			=>	$history -> subject,
									'content'			=>	$history -> message,
									'groups'			=>	$history -> groups,
									'mailinglists'		=>	$history -> mailinglists,
									'theme_id'			=>	$history -> theme_id,
									'conditions'		=>	maybe_unserialize($history -> conditions),
									'fields'			=>	maybe_unserialize($history -> conditions),
									'attachments'		=>	$history -> attachments,
								);
							}
						} else {
							if (!empty($_POST['preview'])) {
								$message = __('Preview could not be sent', $this -> plugin_name);
							} elseif (!empty($_POST['draft'])) {
								if (empty($errors['mailinglists'])) {
									$message = __('Draft could not be saved', $this -> plugin_name);
								} else {
									$message = __('Draft could not be saved, please select at least one mailing list.', $this -> plugin_name);	
								}
							} else {
								if (!empty($_POST['sendtype']) && $_POST['sendtype'] == "queue") {
									$message = __('Newsletter could not be scheduled/queued', $this -> plugin_name);
								} else {
									$message = __('Newsletter could not be sent', $this -> plugin_name);
								}
							}
							
							$this -> render_error($message);
						}
					}
					
					if (empty($dontrendersend) || $dontrendersend == false) {
						$this -> render('send', array('mailinglists' => $mailinglists, 'themes' => $themes, 'templates' => $templates, 'errors' => $errors), true, 'admin');
					}
					break;
				}
		}
		
		function admin_autoresponders() {
			global $wpdb, $Db, $Autoresponder, $AutorespondersList, $Autoresponderemail;
			$Db -> model = $Autoresponder -> model;
			
			switch ($_GET['method']) {
				case 'save'					:
					if (!empty($_POST)) {
						if ($Db -> save($_POST)) {
							$message = __('Autoresponder has been saved.', $this -> plugin_name);
							$this -> redirect("?page=" . $this -> sections -> autoresponders, 'message', $message);
						} else {
							$this -> render_error(__('Autoresponder could not be saved, please try again.', $this -> plugin_name));	
							$this -> render('autoresponders' . DS . 'save', false, true, 'admin');
						}
					} else {
						if (!empty($_GET['id'])) {
							$Db -> model = $Autoresponder -> model;
							$autoresponder = $Db -> find(array('id' => $_GET['id']));	
						}
						
						$this -> render('autoresponders' . DS . 'save', array('autoresponder' => $autoresponder), true, 'admin');
					}
					break;
				case 'delete'				:
					if (!empty($_GET['id'])) {
						if ($Db -> delete($_GET['id'])) {
							$msg_type = 'message';
							$message = __('Autoresponder has been deleted.', $this -> plugin_name);
						} else {
							$msg_type = 'error';
							$message = __('Autoresponder cannot be deleted, please try again.', $this -> plugin_name);
						}
					} else {
						$msg_type = 'error';
						$message = __('No autoresponder was specified.', $this -> plugin_name);
					}
					
					$this -> redirect($this -> referer, $msg_type, $message);
					break;
				case 'mass'					:
					if (!empty($_POST['autoresponderslist'])) {
						if (!empty($_POST['action'])) {
							$autoresponders = $_POST['autoresponderslist'];
							
							switch ($_POST['action']) {
								case 'delete'				:
									foreach ($autoresponders as $autoresponder_id) {
										//remove the autoresponder
										$Db -> model = $Autoresponder -> model;
										$Db -> delete($autoresponder_id);
									}
									
									$msg_type = 'message';
									$message = __('Selected autoresponders and scheduled messages were removed.', $this -> plugin_name);
									break;
								case 'activate'				:
									foreach ($autoresponders as $autoresponder_id) {
										$Db -> model = $Autoresponder -> model;
										$Db -> save_field('status', "active", array('id' => $autoresponder_id));
									}
									
									$msg_type = 'message';
									$message = __('Selected autoresponders have been activated and messages will be scheduled for new subscriptions.', $this -> plugin_name);
									break;
								case 'deactivate'			:
									foreach ($autoresponders as $autoresponder_id) {
										$Db -> model = $Autoresponder -> model;
										$Db -> save_field('status', "inactive", array('id' => $autoresponder_id));
									}
									
									$msg_type = 'message';
									$message = __('Selected autoresponders have been deactivated and no more messages will be scheduled for them.', $this -> plugin_name);
									break;	
							}
						} else {
							$msg_type = 'error';
							$message = __('No action was specified.', $this -> plugin_name);
						}
					} else {
						$msg_type = 'error';
						$message = __('No autoresponders were selected.', $this -> plugin_name);
					}
					
					$this -> redirect("?page=" . $this -> sections -> autoresponders, $msg_type, $message);
					break;
				case 'autoresponderscheduling'			:
					if (!empty($_POST['autoresponderscheduling'])) {
						$this -> update_option('autoresponderscheduling', $_POST['autoresponderscheduling']);
						$this -> autoresponder_scheduling();
						
						$msg_type = 'message';
						$message = __('Autoresponders schedule interval has been updated.', $this -> plugin_name);
					} else {
						$msg_type = 'error';
						$message = __('No schedule interval was chosen.', $this -> plugin_name);
					}
					
					$this -> redirect('?page=' . $this -> sections -> autoresponders, $msg_type, $message);
					break;
				default						:
					$perpage = (isset($_COOKIE[$this -> pre . 'autorespondersperpage'])) ? $_COOKIE[$this -> pre . 'autorespondersperpage'] : 15;
					$searchterm = (!empty($_GET[$this -> pre . 'searchterm'])) ? $_GET[$this -> pre . 'searchterm'] : false;
					$searchterm = (!empty($_POST['searchterm'])) ? $_POST['searchterm'] : $searchterm;
					
					if (!empty($_POST['searchterm'])) {
						$this -> redirect($this -> url . '&' . $this -> pre . 'searchterm=' . urlencode($searchterm));
					}
					
					$conditions = (!empty($searchterm)) ? array('title' => "LIKE '%" . $searchterm . "%'") : false;
					
					$ofield = (isset($_COOKIE[$this -> pre . 'autoresponderssorting'])) ? $_COOKIE[$this -> pre . 'autoresponderssorting'] : "modified";
					$odir = (isset($_COOKIE[$this -> pre . 'autoresponders' . $ofield . 'dir'])) ? $_COOKIE[$this -> pre . 'autoresponders' . $ofield . 'dir'] : "DESC";
					$order = array($ofield, $odir);
					
					$data = array();
					if (!empty($_GET['showall'])) {
						$Db -> model = $Autoresponder -> model;
						$lists = $Db -> find_all(false, "*", $order);
						$data[$Autoresponder -> model] = $lists;
						$data['Paginate'] = false;
					} else {
						//$data = $Autoresponder -> get_all_paginated($conditions, $searchterm, $this -> sections -> autoresponders, $perpage, $order);
						$data = $this -> paginate($Autoresponder -> model, false, $this -> sections -> autoresponders, $conditions, $searchterm, $perpage, $order);
					}
					
					$this -> render('autoresponders' . DS . 'index', array('autoresponders' => $data[$Autoresponder -> model], 'paginate' => $data['Paginate']), true, 'admin');
					break;	
			}
		}
		
		function admin_autoresponderemails() {
			global $wpdb, $Db, $Autoresponder, $Autoresponderemail,
			$History, $Subscriber, $Queue, $SubscribersList, $Html;
			
			switch ($_GET['method']) {
				case 'send'					:
					if (!empty($_GET['id'])) {
						$query = "SELECT " . $wpdb -> prefix . $Autoresponderemail -> table . ".id, " 
						. $wpdb -> prefix . $SubscribersList -> table . ".list_id, "
						. $wpdb -> prefix . $Autoresponderemail -> table . ".subscriber_id, "
						. $wpdb -> prefix . $Autoresponderemail -> table . ".autoresponder_id FROM " . $wpdb -> prefix . $Autoresponderemail -> table . " LEFT JOIN " 
						. $wpdb -> prefix . $SubscribersList -> table . " ON " . $wpdb -> prefix . $Autoresponderemail -> table . ".subscriber_id = " . $wpdb -> prefix . $SubscribersList -> table . ".subscriber_id 
						WHERE " . $wpdb -> prefix . $Autoresponderemail -> table . ".id = '" . $_GET['id'] . "' LIMIT 1";
						
						if ($ae = $wpdb -> get_row($query)) {						
							$query = "SELECT " . $wpdb -> prefix . $History -> table . ".id, " 
							. $wpdb -> prefix . $History -> table . ".subject, " 
							. $wpdb -> prefix . $History -> table . ".message, " 
							. $wpdb -> prefix . $History -> table . ".theme_id FROM " 
							. $wpdb -> prefix . $History -> table . " LEFT JOIN " 
							. $wpdb -> prefix . $Autoresponder -> table . " ON " . $wpdb -> prefix . $History -> table . ".id = " . $wpdb -> prefix . $Autoresponder -> table . ".history_id WHERE " 
							. $wpdb -> prefix . $Autoresponder -> table . ".id = '" . $ae -> autoresponder_id . "' LIMIT 1;";
							
							$history = $wpdb -> get_row($query);
					
							/* The Subscriber */
							$Db -> model = $Subscriber -> model;
							$subscriber = $Db -> find(array('id' => $ae -> subscriber_id), false, false, true, false);
							$subscriber -> mailinglist_id = $ae -> list_id;
							
							/* The Message */
							$eunique = $Html -> eunique($subscriber, $history -> id);
							
							/* Queue the email */
							if ($Queue -> save($subscriber, $history -> subject, $history -> message, false, false, $history -> id, false, $history -> theme_id)) {
								$addedtoqueue++;
								$Db -> model = $Autoresponderemail -> model;
								//$Db -> delete($ae -> id);	
								$Db -> save_field('status', "sent", array('id' => $ae -> id));
								
								$msg_type = 'message';
								$message = __('Autoresponder email has been added to the email queue.', $this -> plugin_name);
							} else {
								$msg_type = 'error';
								$message = __('Autoresponder email could not be queued.', $this -> plugin_name);	
							}
						} else {
							$msg_type = 'error';
							$message = __('Autoresponder email cannot be read.', $this -> plugin_name);	
						}
					} else {
						$msg_type = 'error';
						$message = __('No autoresponder email was specified.', $this -> plugin_name);	
					}
					
					$this -> redirect($this -> referer, $msg_type, $message);
					break;
				case 'delete'				:
					if (!empty($_GET['id'])) {
						$Db -> model = $Autoresponderemail -> model;
						
						if ($Db -> delete($_GET['id'])) {
							$msg_type = 'message';
							$message = __('Autoresponder email has been removed.', $this -> plugin_name);
						} else {
							$msg_type = 'error';
							$message = __('Autoresponder email cannot be deleted.', $this -> plugin_name);
						}
					} else {
						$msg_type = 'error';
						$message = __('No autoresponder email has been specified.', $this -> plugin_name);
					}
					
					$this -> redirect($this -> referer, $msg_type, $message);
					break;
				case 'mass'					:
					if (!empty($_POST['autoresponderemailslist'])) {
						if (!empty($_POST['action'])) {
							$autoresponderemails = $_POST['autoresponderemailslist'];
							
							switch ($_POST['action']) {
								case 'delete'				:
									foreach ($autoresponderemails as $ae_id) {
										//remove the autoresponder
										$Db -> model = $Autoresponderemail -> model;
										$Db -> delete($ae_id);
									}
									
									$msg_type = 'message';
									$message = __('Selected autoresponder emails were removed.', $this -> plugin_name);
									break;
								case 'send'				:
									foreach ($autoresponderemails as $ae_id) {
										$query = "SELECT " . $wpdb -> prefix . $Autoresponderemail -> table . ".id, " 
										. $wpdb -> prefix . $SubscribersList -> table . ".list_id, "
										. $wpdb -> prefix . $Autoresponderemail -> table . ".subscriber_id, "
										. $wpdb -> prefix . $Autoresponderemail -> table . ".autoresponder_id FROM " . $wpdb -> prefix . $Autoresponderemail -> table . " LEFT JOIN " 
										. $wpdb -> prefix . $SubscribersList -> table . " ON " . $wpdb -> prefix . $Autoresponderemail -> table . ".subscriber_id = " . $wpdb -> prefix . $SubscribersList -> table . ".subscriber_id 
										WHERE " . $wpdb -> prefix . $Autoresponderemail -> table . ".id = '" . $ae_id . "' LIMIT 1";
										
										if ($ae = $wpdb -> get_row($query)) {						
											$query = "SELECT " . $wpdb -> prefix . $History -> table . ".id, " 
											. $wpdb -> prefix . $History -> table . ".subject, " 
											. $wpdb -> prefix . $History -> table . ".message, " 
											. $wpdb -> prefix . $History -> table . ".theme_id FROM " 
											. $wpdb -> prefix . $History -> table . " LEFT JOIN " 
											. $wpdb -> prefix . $Autoresponder -> table . " ON " . $wpdb -> prefix . $History -> table . ".id = " . $wpdb -> prefix . $Autoresponder -> table . ".history_id WHERE " 
											. $wpdb -> prefix . $Autoresponder -> table . ".id = '" . $ae -> autoresponder_id . "' LIMIT 1;";
											
											$history = $wpdb -> get_row($query);
									
											/* The Subscriber */
											$Db -> model = $Subscriber -> model;
											$subscriber = $Db -> find(array('id' => $ae -> subscriber_id), false, false, true, false);
											$subscriber -> mailinglist_id = $ae -> list_id;
											
											/* The Message */
											$eunique = $Html -> eunique($subscriber, $history -> id);
											
											/* Queue the email */
											if ($Queue -> save($subscriber, $history -> subject, $history -> message, false, false, $history -> id, false, $history -> theme_id)) {
												$addedtoqueue++;
												$Db -> model = $Autoresponderemail -> model;
												//$Db -> delete($ae -> id);	
												$Db -> save_field('status', "sent", array('id' => $ae -> id));
											}
										}
									}
									
									$msg_type = 'message';
									$message = __('Selected autoresponder emails were added to the queue.', $this -> plugin_name);
									break;
							}
						} else {
							$msg_type = 'error';
							$message = __('No action was specified.', $this -> plugin_name);
						}
					} else {
						$msg_type = 'error';
						$message = __('No autoresponders were selected.', $this -> plugin_name);
					}
					
					$this -> redirect("?page=" . $this -> sections -> autoresponderemails, $msg_type, $message);
					break;
				default						:
					$perpage = (isset($_COOKIE[$this -> pre . 'autoresponderemailsperpage'])) ? $_COOKIE[$this -> pre . 'autoresponderemailsperpage'] : 15;
					$searchterm = (!empty($_GET[$this -> pre . 'searchterm'])) ? $_GET[$this -> pre . 'searchterm'] : false;
					$searchterm = (!empty($_POST['searchterm'])) ? $_POST['searchterm'] : $searchterm;
					
					if (!empty($_POST['searchterm'])) {
						$this -> redirect($this -> url . '&' . $this -> pre . 'searchterm=' . urlencode($searchterm));
					}
					
					$conditions = (!empty($searchterm)) ? array('title' => "LIKE '%" . $searchterm . "%'") : false;
					
					if (isset($_COOKIE[$this -> pre . 'autoresponderemailsfilter_status'])) {
						switch($_COOKIE[$this -> pre . 'autoresponderemailsfilter_status']) {
							case 'all'		:
								//do nothing...
								break;
							case 'sent'		:
								$conditions['status'] = "sent";
								break;
							case 'unsent'	:
							default			:
								$conditions['status'] = "unsent";
								break;	
						}
					}
					
					if (isset($_COOKIE[$this -> pre . 'autoresponderemailsfilter_autoresponder_id'])) {
						if (empty($conditions['status'])) {
							$conditions['autoresponder_id'] = $_COOKIE[$this -> pre . 'autoresponderemailsfilter_autoresponder_id'];
						} else {
							$conditions['status'] .= "' AND autoresponder_id = '" . $_COOKIE[$this -> pre . 'autoresponderemailsfilter_autoresponder_id'] . "";
						}
					}
					
					$ofield = (isset($_COOKIE[$this -> pre . 'autoresponderemailssorting'])) ? $_COOKIE[$this -> pre . 'autoresponderemailssorting'] : "modified";
					$odir = (isset($_COOKIE[$this -> pre . 'autoresponderemails' . $ofield . 'dir'])) ? $_COOKIE[$this -> pre . 'autoresponderemails' . $ofield . 'dir'] : "DESC";
					$order = array($ofield, $odir);
					
					$order = array('modified', "DESC");
					if (!empty($_GET['showall'])) {
						$Db -> model = $Autoresponderemail -> model;
						$autoresponderemails = $Db -> find_all($conditions, "*", $order, false, true);
						$data[$Autoresponderemail -> model] = $autoresponderemails;
						$data['Paginate'] = false;	
					} else {
						$data = $this -> paginate($Autoresponderemail -> model, false, $this -> sections -> autoresponderemails, $conditions, $searchterm, $perpage, $order);
					}
					
					$this -> render('autoresponderemails' . DS . 'index', array('autoresponderemails' => $data[$Autoresponderemail -> model], 'paginate' => $data['Paginate']), true, 'admin');
					break;	
			}
		}
		
		function admin_mailinglists() {
			global $wpdb, $Db, $Mailinglist, $Subscriber, $SubscribersList;
			$Db -> model = $Mailinglist -> model;
		
			switch ($_GET['method']) {
				case 'save'			:
					if (!empty($_POST)) {
						if ($Mailinglist -> save($_POST)) {
							$message = __('Mailing list has been saved', $this -> plugin_name);
							$this -> redirect($this -> url, 'message', $message);
						} else {
							$this -> render_error(__('Mailing list could not be saved', $this -> plugin_name));
							$mailinglist = $this -> init_class('wpmlMailinglist', $_POST);
							$this -> render_admin('mailinglists' . DS . 'save', array('mailinglist' => $mailinglist, 'errors' => $this -> Mailinglist -> errors));
						}
					} else {
						if (!empty($_GET['id'])) {
							$mailinglist = $Mailinglist -> get($_GET['id']);
						}
						
						if (!empty($_GET['group_id'])) { $Mailinglist -> data -> group_id = $_GET['group_id']; }
						$this -> render_admin('mailinglists' . DS . 'save', array('mailinglist' => $mailinglist));
					}
					break;
				case 'view'			:
					if (!empty($_GET['id'])) {
						if ($mailinglist = $Mailinglist -> get($_GET['id'])) {
							$perpage = (!empty($_COOKIE[$this -> pre . 'subscribersperpage'])) ? $_COOKIE[$this -> pre . 'subscribersperpage'] : 15;						
							$sub = $this -> sections -> lists . '&amp;method=view&amp;id=' . $_GET['id'];
							$conditions = array('list_id' => $_GET['id']);
							$searchterm = false;
							$order = array('modified', "DESC");
							$data = $this -> paginate($SubscribersList -> model, false, $sub, $conditions, $searchterm, $perpage, $order);
							$subscribers = $data[$SubscribersList -> model];
							
							$this -> render_admin('mailinglists' . DS . 'view', array('mailinglist' => $mailinglist, 'subscribers' => $subscribers, 'paginate' => $data['Paginate']));
						} else {
							$this -> render_error(__('Mailing list could not be read', $this -> plugin_name));
						}
					} else {
						$this -> render_error(__('No mailing list was specified', $this -> plugin_name));
					}
					break;
				case 'delete'		:
					if (!empty($_GET['id'])) {
						if ($Mailinglist -> delete($_GET['id'])) {
							$msg_type = 'message';
							$message = __('Mailing list has been removed', $this -> plugin_name);
						} else {
							$msg_type = 'error';
							$message = __('Mailing list cannot be removed', $this -> plugin_name);
						}
					} else {
						$msg_type = 'error';
						$message = __('No mailing list was specified', $this -> plugin_name);
					}
					
					$this -> redirect($this -> url, $msg_type, $message);
					break 1;
				case 'mass'			:
					if (!empty($_POST['mailinglistslist'])) {
						if (!empty($_POST['action'])) {
							$lists = $_POST['mailinglistslist'];
							
							switch ($_POST['action']) {
								case 'setgroup'			:
									if (!empty($_POST['setgroup_id'])) {
										foreach ($lists as $list_id) {
											$Mailinglist -> save_field('group_id', $_POST['setgroup_id'], $list_id);	
										}
										
										$msg_type = "message";
										$message = __('Selected mailing lists assigned to the chosen group.', $this -> plugin_name);
									} else {
										$msg_type = "message";
										$message = __('No group was selected.', $this -> plugin_name);
									}
									break;
								case 'delete'			:
									$Mailinglist -> delete_array($lists);
									$msg_type = "message";
									$message = __('Selected mailing lists have been removed', $this -> plugin_name);
									break;
								case 'private'			:
									foreach ($lists as $id) {
										$Mailinglist -> save_field('privatelist', 'Y', $id);
									}
									
									$msg_type = "message";
									$message = __('Selected mailing lists have been set as private', $this -> plugin_name);
									break;
								case 'notprivate'		:
									foreach ($lists as $id) {
										$Mailinglist -> save_field('privatelist', 'N', $id);
									}
									
									$msg_type = "message";
									$message = __('Selected mailing lists have been set as not private', $this -> plugin_name);
									break;
							}
						} else {
							$msg_type = "error";
							$message = __('No action was selected', $this -> plugin_name);
						}
					} else {
						$msg_type = "error";
						$message = __('No mailing lists were selected', $this -> plugin_name);
					}
					
					$this -> redirect($this -> url, $msg_type, $message);
					break;
				case 'offsite'			:
					if (!empty($_GET['listid'])) {
						$this -> update_option('offsitelist', $_GET['listid']);
					} else {
						$msg_type = 'error';
						$message = __('No mailing list was specified', $this -> plugin_name);
					}
					
					$this -> redirect($this -> url . '&method=offsitewizard&listid=' . $_GET['listid'], $msg_type, $message);
					break;
				case 'offsitewizard'	:
					global $Html, $FieldsList;
				
					$code = false;
					$listid = (!empty($_GET['listid'])) ? $_GET['listid'] : $_POST['list'];
					
					if (!empty($_POST)) {
						$opts = array('title', 'list', 'width', 'height', 'button', 'stylesheet', 'fields');
					
						foreach ($_POST as $pkey => $pval) {					
							if (in_array($pkey, $opts)) {						
								if (!empty($pval)) {
									$this -> update_option('offsite' . $pkey, stripslashes($pval));
								}
							}
						}
															
						if (empty($listid)) {
							$this -> render_error(__('Please select mailing list(s)', $this -> plugin_name));
						}
					} else {
						$this -> render_message(__('Offsite code is specifically used for non-WordPress and other remote websites, not for the current one.', $this -> plugin_name));	
					}
	
					if (!empty($listid)) {				
						$options = $this -> get_option('offsite');
						
						$options['title'] = (empty($_POST['title'])) ? get_option('blogname') : $_POST['title'];
						$options['list'] = $listid;
						$options['button'] = (empty($_POST['button'])) ? __('Subscribe', $this -> plugin_name) : $_POST['button'];
						$options['ajax'] = "Y";
						$options['stylesheet'] = (empty($_POST['stylesheet'])) ? "Y" : $_POST['stylesheet'];
						$wpoptinid = time();
						$options['wpoptinid'] = $wpoptinid;
						
						$fields = false;
						if (empty($_POST['fields']) || (!empty($_POST['fields']) && $_POST['fields'] == "Y")) {
							$fields = $FieldsList -> fields_by_list($listid);
						}
						
						ob_start();
						$this -> render('offsite-form', array('options' => $options, 'fields' => $fields), true, 'admin');
						$code = ob_get_clean();
						
						$offsiteurl = rtrim(get_bloginfo('home'), '/') . '/?' . $this -> pre . 'method=offsite&list=' . $listid;
					}
					
					$this -> render_admin('offsite-wizard', array('code' => $code, 'offsiteurl' => $offsiteurl, 'listid' => $listid));
					break;
				default				:				
					$perpage = (isset($_COOKIE[$this -> pre . 'listsperpage'])) ? $_COOKIE[$this -> pre . 'listsperpage'] : 15;
					$searchterm = (!empty($_GET[$this -> pre . 'searchterm'])) ? $_GET[$this -> pre . 'searchterm'] : false;
					$searchterm = (!empty($_POST['searchterm'])) ? $_POST['searchterm'] : $searchterm;
					
					if (!empty($_POST['searchterm'])) {
						$this -> redirect($this -> url . '&' . $this -> pre . 'searchterm=' . urlencode($searchterm));
					}
					
					$conditions = (!empty($searchterm)) ? array('title' => "LIKE '%" . $searchterm . "%'") : false;
					
					$ofield = (isset($_COOKIE[$this -> pre . 'listssorting'])) ? $_COOKIE[$this -> pre . 'listssorting'] : "modified";
					$odir = (isset($_COOKIE[$this -> pre . 'lists' . $ofield . 'dir'])) ? $_COOKIE[$this -> pre . 'lists' . $ofield . 'dir'] : "DESC";
					$order = array($ofield, $odir);
					
					$data = array();
					if (!empty($_GET['showall'])) {
						$Db -> model = $Mailinglist -> model;
						$lists = $Db -> find_all(false, "*", $order);
						$data[$Mailinglist -> model] = $lists;
						$data['Paginate'] = false;
					} else {
						$data = $Mailinglist -> get_all_paginated($conditions, $searchterm, $this -> sections -> lists, $perpage, $order);
					}
					
					$this -> render_admin('mailinglists' . DS . 'index', array('mailinglists' => $data[$Mailinglist -> model], 'paginate' => $data['Pagination']));
					break;
			}
		}
		
		function admin_groups() {
			global $wpdb, $Db, $wpmlGroup, $Mailinglist;
			$Db -> model = $wpmlGroup -> model;
			
			switch ($_GET['method']) {
				case 'save'						:
					$Db -> model = $wpmlGroup -> model;
					
					if (!empty($_POST)) {
						if ($Db -> save($_POST)) {
							$message = __('Group has been saved.', $this -> plugin_name);
							$this -> redirect($this -> url, 'message', $message);
						} else {
							$this -> render_error(__('Group could not be saved.', $this -> plugin_name));
							$group = $this -> init_class($wpmlGroup -> model, $_POST);
							$this -> render_admin('groups' . DS . 'save', array('group' => $group, 'errors' => $wpmlGroup -> errors));
						}
					} else {
						if (!empty($_GET['id'])) {
							$group = $Db -> find($_GET['id']);
						}
						
						$this -> render_admin('groups' . DS . 'save', array('group' => $group), true, 'admin');
					}
					break;
				case 'view'						:
					if (!empty($_GET['id'])) {
						if ($group = $Db -> find(array('id' => $_GET['id']))) {
							$perpage = (!empty($_COOKIE[$this -> pre . 'listsperpage'])) ? $_COOKIE[$this -> pre . 'listsperpage'] : 15;
							$data = $Mailinglist -> get_all_paginated(array('group_id' => $_GET['id']), false, $this -> sections -> groups . '&amp;method=view&amp;id=' . $_GET['id'], $perpage);
							$this -> render_admin('groups' . DS . 'view', array('group' => $group, 'mailinglists' => $data['Mailinglist'], 'paginate' => $data['Pagination']));
						} else {
							$this -> render_error(__('Group could not be read', $this -> plugin_name));
						}
					} else {
						$this -> render_error(__('No group was specified', $this -> plugin_name));
					}
					break;
				case 'delete'					:
					if (!empty($_GET['id'])) {
						if ($Db -> delete($_GET['id'])) {
							$Db -> model = $Mailinglist -> model;
							$Db -> save_field('group_id', "0", array('group_id' => $_GET['id']));
							
							$msg_type = 'message';
							$message = __('Group has been removed', $this -> plugin_name);
						} else {
							$msg_type = 'error';
							$message = __('Group cannot be removed', $this -> plugin_name);
						}
					} else {
						$msg_type = 'error';
						$message = __('No group was specified', $this -> plugin_name);
					}
					
					$this -> redirect($this -> url, $msg_type, $message);
					break;
				case 'mass'						:
					if (!empty($_POST['groupslist'])) {
						if (!empty($_POST['action'])) {
							$groups = $_POST['groupslist'];
							
							switch ($_POST['action']) {
								case 'delete'			:
									
									foreach ($groups as $group_id) {
										$Db -> model = $wpmlGroup -> model;
										$Db -> delete($group_id);	
									}
									
									$msg_type = "message";
									$message = __('Selected groups have been removed.', $this -> plugin_name);
									break;
							}
						} else {
							$msg_type = "error";
							$message = __('No action was selected', $this -> plugin_name);
						}
					} else {
						$msg_type = "error";
						$message = __('No groups were selected', $this -> plugin_name);
					}
					
					$this -> redirect($this -> url, $msg_type, $message);
					break;
				default							:
					$perpage = (isset($_COOKIE[$this -> pre . 'groupsperpage'])) ? $_COOKIE[$this -> pre . 'groupsperpage'] : 15;
					$searchterm = (!empty($_GET[$this -> pre . 'searchterm'])) ? $_GET[$this -> pre . 'searchterm'] : false;
					$searchterm = (!empty($_POST['searchterm'])) ? $_POST['searchterm'] : $searchterm;
					
					if (!empty($_POST['searchterm'])) {
						$this -> redirect($this -> url . '&' . $this -> pre . 'searchterm=' . urlencode($searchterm));
					}
					
					$conditions = (!empty($searchterm)) ? array('title' => "LIKE '%" . $searchterm . "%'") : false;
					
					$ofield = (isset($_COOKIE[$this -> pre . 'groupssorting'])) ? $_COOKIE[$this -> pre . 'groupssorting'] : "modified";
					$odir = (isset($_COOKIE[$this -> pre . 'groups' . $ofield . 'dir'])) ? $_COOKIE[$this -> pre . 'groups' . $ofield . 'dir'] : "DESC";
					$order = array($ofield, $odir);
					
					$data = array();
					if (!empty($_GET['showall'])) {
						$Db -> model = $wpmlGroup -> model;
						$lists = $Db -> find_all(false, "*", $order);
						$data[$wpmlGroup -> model] = $lists;
						$data['Paginate'] = false;
					} else {
						$data = $wpmlGroup -> get_all_paginated($conditions, $searchterm, $this -> sections -> groups, $perpage, $order);
					}
				
					if (!empty($data['wpmlGroup'][0])) { $groups = (object) $data['wpmlGroup']; }
					else { $groups = false; }
					
					$this -> render('groups' . DS . 'index', array('groups' => $groups, 'paginate' => $data['Pagination']), true, 'admin');
					break;	
			}
		}
		
		function admin_subscribers() {
			global $wpdb, $Db, $Field, $Subscriber, $SubscribersList, $Mailinglist;
			$Db -> model = $Subscriber -> model;
				
			switch ($_GET['method']) {
				case 'save'			:
					if (!empty($_POST)) {				
						if (!empty($_POST['Subscriber']['id'])) {
							$SubscribersList -> delete_all(array('subscriber_id' => $_POST['Subscriber']['id']));
						}
						
						$Db -> model = $Field -> model;
						$conditions['1'] = "1 AND `slug` != 'email'";
						if ($fields = $Db -> find_all($conditions)) {
							foreach ($fields as $field) {
								if (!empty($_POST[$field -> slug])) {
									if (is_array($_POST[$field -> slug])) {
										foreach ($_POST[$field -> slug] as $fkey => $fval) {
											$_POST['Subscriber'][$field -> slug][$fkey] = $fval;
										}
									} else {
										$_POST['Subscriber'][$field -> slug] = $_POST[$field -> slug];
									}
								}
							}
						}
							
						if ($Subscriber -> save($_POST)) {
							$message = __('Subscriber has been saved', $this -> plugin_name);
							$this -> redirect($this -> url, 'message', $message);
						} else {
							$Subscriber -> get($_POST['subscriber_id']);
							$this -> render_error(__('Subscriber could not be saved', $this -> plugin_name));
							$this -> render_admin('subscribers' . DS . 'save', array('subscriber' => $this -> init_class('wpmlSubscriber', $this -> Subscriber -> data), 'errors' => $this -> Subscriber -> error));
						}
					} else {
						$Subscriber -> get($_GET['id']);
						if (!empty($_GET['mailinglist_id'])) { $Subscriber -> data -> mailinglists[] = $_GET['mailinglist_id']; }
						$this -> render_admin('subscribers' . DS . 'save');
					}
					break;
				case 'view'			:
					if (!empty($_GET['id'])) {
						if ($subscriber = $Subscriber -> get($_GET['id'])) {
							$this -> render_admin('subscribers' . DS . 'view', array('subscriber' => $subscriber));
						} else {						
							$message = __('Subscriber cannot be read', $this -> plugin_name);
							$this -> redirect($this -> url, 'error', $message);
						}
					} else {
						$message = __('No subscriber was specified', $this -> plugin_name);
						$this -> redirect($this -> url, 'error', $message);
					}
					break;
				case 'delete'		:
					if (!empty($_GET['id'])) {
						$Db -> model = $Subscriber -> model;
					
						if ($Db -> delete($_GET['id'])) {
							$message_type = 'message';
							$message = __('Subscriber has been removed', $this -> plugin_name);
						} else {
							$message_type = 'error';
							$message = __('Subscriber cannot be removed', $this -> plugin_name);
						}
					} else {
						$message_type = 'error';
						$message = __('No subscriber was specified', $this -> plugin_name);
					}
					
					$this -> redirect($this -> referer, $message_type, $message);
					break;
				case 'mass'			:			
					if (!empty($_POST['subscriberslist'])) {
						if (!empty($_POST['action'])) {
							$subscribers = $_POST['subscriberslist'];
							
							switch ($_POST['action']) {
								case 'assignlists'		:
									if (!empty($_POST['lists'])) {
										foreach ($subscribers as $subscriber_id) {
											foreach ($_POST['lists'] as $list_id) {
												$Db -> model = $Mailinglist -> model;
												
												if ($mailinglist = $Db -> find(array('id' => $list_id))) {
													$sl = array('subscriber_id' => $subscriber_id, 'list_id' => $list_id, 'active' => "Y");
													
													if ($mailinglist -> paid == "Y") {
														$sl['paid'] = "Y";
													}
													
													$SubscribersList -> save($sl, true);
												}
											}
										}
										
										$msg_type = 'message';
										$message = __('Selected mailing lists have been appended to the subscribers', $this -> plugin_name);
									} else {
										$msg_type = 'error';
										$message = __('No mailing lists were selected', $this -> plugin_name);
									}
									break;
								case 'setlists'			:
									if (!empty($_POST['lists'])) {
										foreach ($subscribers as $subscriber_id) {
											$SubscribersList -> delete_all(array('subscriber_id' => $subscriber_id));
											
											foreach ($_POST['lists'] as $list_id) {
												$Db -> model = $Mailinglist -> model;
												
												if ($mailinglist = $Db -> find(array('id' => $list_id))) {
													$sl = array('subscriber_id' => $subscriber_id, 'list_id' => $list_id, 'active' => "Y");
													
													if ($mailinglist -> paid == "Y") {
														$sl['paid'] = "Y";
													}
													
													$SubscribersList -> save($sl, true);
												}
											}
										}
										
										$msg_type = 'message';
										$message = __('Selected mailing lists have been assigned to the subscribers', $this -> plugin_name);
									} else {
										$msg_type = 'error';
										$message = __('No mailing lists were selected', $this -> plugin_name);
									}
									break;
								case 'delete'			:							
									foreach ($subscribers as $subscriber_id) {
										$Db -> model = $Subscriber -> model;
										$Db -> delete($subscriber_id);
									}
									
									$msg_type = 'message';
									$message = __('Selected subscribers have been removed', $this -> plugin_name);
									break;
								case 'active'			:
									if (!empty($subscribers)) {
										foreach ($subscribers as $subscriber_id) {
											$Db -> model = $SubscribersList -> model;
											$Db -> save_field('active', "Y", array('subscriber_id' => $subscriber_id));
										}
									}
									
									$msg_type = 'message';
									$message = __('Selected subscribers set as active', $this -> plugin_name);
									break;
								case 'inactive'			:
									foreach ($subscribers as $subscriber_id) {
										$Db -> model = $SubscribersList -> model;
										$Db -> save_field('active', "N", array('subscriber_id' => $subscriber_id));
									}
									
									$msg_type = 'message';
									$message = __('Selected subscribers deactivated', $this -> plugin_name);
									break;
							}
						} else {
							$msg_type = 'error';
							$message = __('No action was selected', $this -> plugin_name);
						}
					} else {
						$msg_type = 'error';
						$message = __('No subscribers were selected', $this -> plugin_name);
					}
					
					$this -> redirect($this -> referer, $msg_type, $message);
					break;
	            case 'check-bounced'    :
	                $bounce_results = $this -> bounce(false, "pop");
	                $bounce_message = "";
	                $bounce_message .= $bounce_results[0] . " ";
	                $bounce_message .= __('subscribers', $this -> plugin_name) . ' ';
	                $bounce_message .= __('and', $this -> plugin_name) . ' ';
	                $bounce_message .= $bounce_results[1] . " ";
	                $bounce_message .= __('bounced emails were removed.', $this -> plugin_name);
	                $this -> redirect("?page=" . $this -> sections -> subscribers, 'message', $bounce_message);
	                break;
				default			:
					$oldperpage = 15;
				
					// screen options changes?
					if (!empty($_POST['screenoptions'])) {
						if (!empty($_POST['fields']) && is_array($_POST['fields'])) {
							$this -> update_option('screenoptions_subscribers_fields', $_POST['fields']);	
						} else { delete_option($this -> pre . 'screenoptions_subscribers_fields'); }
						
						if (!empty($_POST['custom']) && is_array($_POST['custom'])) {
							$this -> update_option('screenoptions_subscribers_custom', $_POST['custom']);
						} else { delete_option($this -> pre . 'screenoptions_subscribers_custom'); }
						
						if (!empty($_POST['perpage'])) {
							$oldperpage = $_POST['perpage'];
						}
					}
				
					$perpage = (isset($_COOKIE[$this -> pre . 'subscribersperpage'])) ? $_COOKIE[$this -> pre . 'subscribersperpage'] : $oldperpage;
					$searchterm = (!empty($_GET[$this -> pre . 'searchterm'])) ? $_GET[$this -> pre . 'searchterm'] : false;
					$searchterm = (!empty($_POST['searchterm'])) ? $_POST['searchterm'] : $searchterm;
					
					if (!empty($_POST['searchterm'])) {
						$this -> redirect($this -> url . '&' . $this -> pre . 'searchterm=' . urlencode($searchterm));
					}
					
					$conditions = (!empty($searchterm)) ? array('email' => "LIKE '%" . $searchterm . "%'") : false;
					
					$Db -> model = $Field -> model;
					$fieldsconditions['1'] = "1 AND `slug` != 'email'";
					if ($fields = $Db -> find_all($fieldsconditions)) {
						if (empty($conditions) || !is_array($conditions)) { $conditions = array(); }
					
						foreach ($fields as $field) {
							$conditions[$field -> slug] = "LIKE '%" . $searchterm . "%'";
						}
					}
					
					$ofield = (isset($_COOKIE[$this -> pre . 'subscriberssorting'])) ? $_COOKIE[$this -> pre . 'subscriberssorting'] : 'modified';
					$odir = (isset($_COOKIE[$this -> pre . 'subscribers' . $ofield . 'dir'])) ? $_COOKIE[$this -> pre . 'subscribers' . $ofield . 'dir'] : "DESC";
					$order = array($ofield, $odir);
					
					$data = array();
					$Subscriber -> recursive = true;
					
					if (!empty($_GET['showall'])) {
						$Db -> model = $Subscriber -> model;
						$subscribers = $Db -> find_all(false, "*", $order);
						$data[$Subscriber -> model] = $subscribers;
						$data['Paginate'] = false;
					} else {
						$data = $Subscriber -> get_all_paginated($conditions, $searchterm, $this -> sections -> subscribers, $perpage, $order);
					}
					
					$this -> render_admin('subscribers' . DS . 'index', array('subscribers' => $data[$Subscriber -> model], 'paginate' => $data['Pagination']));
					break;
			}
		}
		
		function admin_importexport() {
			global $wpdb, $Field, $Subscriber, $SubscribersList, $Mailinglist;
		
			if (!empty($_POST)) {
				$this -> remove_server_limits();
				
				switch ($_GET['method']) {
					case 'import'			:							
						if (empty($_FILES['file']['name'])) { $error['file'] = __('No file selected for uploading', $this -> plugin_name); }
						elseif (!is_uploaded_file($_FILES['file']['tmp_name'])) { $error['file'] = __('File could not be uploaded', $this -> plugin_name); }
						if (empty($_POST['importlists'])) { $error['mailinglists'] = __('No mailing list selected', $this -> plugin_name); }
						if (empty($_POST['filetype'])) { $error['filetype'] = __('No file type has been selected', $this -> plugin_name); }
						
						if (empty($error)) {
							$numberimported = 0;
							$datasets = array();
							
							if ($_POST['filetype'] == "mac") {
								$structure = array(
									'fname'		=>	0,
									'lname'		=>	1,
									'email'		=>	4,
								);
															
								include_once($this -> plugin_base . DS . 'vendors' . DS . 'class.vcard.php');
								$conv = new vcard_convert();
								$conv -> fromFile($_FILES['file']['tmp_name']);
								$data = $conv -> toCSV(',', false, false, null);
								
								$fileName = time() . '.csv';
								$filePath = ABSPATH . 'wp-content' . DS . 'uploads' . DS;
								$fileFull = $filePath . $fileName;
								$fh = fopen($fileFull, "w");
								
								if ($fh) {
									fwrite($fh, $data);
									fclose($fh);
								} else {
									$error[] = __('Csv file could not be created! Check "wp-content/uploads" permissions!', $this -> plugin_name);
								}
							} elseif ($_POST['filetype'] == "csv") {
								$fileFull = $_FILES['file']['tmp_name'];
							
								foreach ($_POST['fields'] as $key => $val) {
									$structure[$key] = (!empty($_POST['fields'][$key]) && $_POST['fields'][$key] == "Y") ? ($_POST[$key . 'column'] - 1) : false;
								}
							}
							
							if ($fh = fopen($fileFull, "r")) {
								$delimiter = (empty($_POST['delimiter'])) ? "," : $_POST['delimiter'];
								$d = 0;
								$i_queries = array();
								$import_progress = (empty($_POST['import_progress']) || $_POST['import_progress'] == "N") ? false : true;
								
								$afterlists = array();							
								if (!empty($_POST['importlists'])) {								
									foreach ($_POST['importlists'] as $importlist_id) {
										if ($mailinglist = $wpdb -> get_row("SELECT `id`, `paid` FROM `" . $wpdb -> prefix . $Mailinglist -> table . "` WHERE `id` = '" . $importlist_id . "'")) {
											$paid = (empty($mailinglist -> paid) || $mailinglist -> paid == "N") ? "N" : "Y";
											$afterlists[] = array('id' => $importlist_id, 'paid' => $paid, 'active' => "Y");
										}
									}
								}
								
								while (($row = fgetcsv($fh, "1000", $delimiter)) !== false) {
									$this -> remove_server_limits();
								
									if (!empty($row)) {
										$addlists = array();	//additional lists specified in the CSV
										$thisafterlists = $afterlists;
										$mailinglists = $_POST['importlists'];
										$email = $row[$structure['email']];
										
										if (!empty($email) && $Subscriber -> email_validate($email)) {
											if ($user = $Subscriber -> get_user_by_email($email)) {
												$registered = "Y";
												$user_id = $user -> ID;
											} else {
												$registered = "N";
												$user_id = 0;
											}
											
											$current_id = $Subscriber -> email_exists($email);
											
											/* mailing lists column */
											if (!empty($_POST['fields']['mailinglists']) && 
												$_POST['fields']['mailinglists'] == "Y" && 
												!empty($_POST['mailinglistscolumn'])) {
												
												$caddlists = $row[($_POST['mailinglistscolumn'] - 1)];
												if (($addlistsarr = explode(",", $caddlists)) !== false) {																					
													foreach ($addlistsarr as $addlisttitle) {
														$newaddlisttitle = trim($addlisttitle);
														$addlists[] = $newaddlisttitle;
														
														$checkquery = "SELECT `id` FROM `" . $wpdb -> prefix . $Mailinglist -> table . "` WHERE `title` = '" . $newaddlisttitle . "'";
														
														if ($mailinglist_id = $wpdb -> get_var($checkquery)) {
															//do nothing, this list exists	
														} else {
															//we'll create the mailinglist
															if (!empty($_POST['autocreatemailinglists']) && $_POST['autocreatemailinglists'] == "Y") {
																$mailinglistdata = array(
																	'title'					=>	$newaddlisttitle,
																	'privatelist'			=>	"N",
																	'group_id'				=>	0,
																	'paid'					=>	"N",
																);
																
																if ($Mailinglist -> save($mailinglistdata, true)) {
																	$mailinglist_id = $Mailinglist -> insertid;
																}
															}
														}
														
														if (!empty($mailinglist_id)) {
															if (empty($mailinglists) || (!empty($mailinglists) && !in_array($mailinglist_id, $mailinglists))) {
																$mailinglists[] = $mailinglist_id;
																
																if ($mailinglist = $wpdb -> get_row("SELECT `id`, `paid` FROM `" . $wpdb -> prefix . $Mailinglist -> table . "` WHERE `id` = '" . $mailinglist_id . "'")) {
																	$paid = (empty($mailinglist -> paid) || $mailinglist -> paid == "N") ? "N" : "Y";
																	$thisafterlists[] = array('id' => $mailinglist_id, 'paid' => $paid, 'active' => "Y");
																}
															}
														}
													}
												}
											}
											
											if ($Subscriber -> email_validate($email)) {
												$datasets[$d] = array(
													'id'					=>	((empty($current_id)) ? false : $current_id),
													'email'					=>	$email,
													'active'				=>	"Y",
													'registered'			=>	$registered,
													'user_id'				=>	$user_id,
													'mailinglists'			=>	$mailinglists,
													'afterlists'			=>	$thisafterlists,
												);
												
												if (!empty($_POST['fields'])) {										
													foreach ($_POST['fields'] as $field => $value) {
														if (empty($datasets[$d][$field])) {
															$datasets[$d][$field] = $row[($_POST[$field . 'column'] - 1)];
														}
													}
												}
												
												if (empty($import_progress) || $import_progress == false) {
													$datasets[$d]['justsubscribe'] = true;
													$datasets[$d]['fromregistration'] = true;
													$datasets[$d]['username'] = $email;
												
													if ($Subscriber -> save($datasets[$d], false, false)) {
														$numberimported++;	
													}
													
													/*$new_query = $Subscriber -> save($datasets[$d], false, true);
													if (!empty($cur_id)) {
														$i_queries[$cur_id] = $new_query;
													} else {
														$i_queries[] = $new_query;
													}*/
												}
												
												$d++;
											}
										}
									}
								}
								
								if (empty($import_progress) || $import_progress == false) {
									/*
									$numberimported = 0;
																		
									if (!empty($i_queries)) {
										foreach ($i_queries as $i_id => $i_query) {									
											$wpdb -> query($i_query);									
											$insertid = mysql_insert_id();
											$subscriber_id = (empty($insertid)) ? $i_id : $insertid;
											
											if (!empty($afterlists)) {
												foreach ($afterlists as $mailinglist) {
													$sl_data = array('subscriber_id' => $subscriber_id, 'list_id' => $mailinglist['id'], 'paid' => $mailinglist['paid'], 'active' => $mailinglist['active']);
													$sl_query = $SubscribersList -> save($sl_data, false, true);
													
													if (!empty($sl_query)) {
														$wpdb -> query($sl_query);	
													}
												}
											}
											
											$numberimported++;
											$insertid = null;
										}
									}
									*/
									
									if (!empty($numberimported)) {
										$this -> render_message($numberimported . ' ' . __('subscribers successfully imported', $this -> plugin_name));
									} else {
										$this -> render_message(__('No subscribers were imported', $this -> plugin_name));
									}
										
									$this -> render_admin('import-export', array('mailinglists' => $mailinglists));
								} else {
									$this -> render('import-post', array('subscribers' => $datasets), true, 'admin');
								}
							} else {
								/* CSV could not be read */
								
							}
						} else {
							$this -> render_error(__('Subscribers could not be imported', $this -> plugin_name));
							$this -> render_admin('import-export', array('mailinglists' => $mailinglists, 'importerrors' => $error));
						}
						
						break;		
					case 'export'				:
						global $wpdb, $Subscriber, $SubscribersList, $Field, $Country;
						$errors = false;
						
						if (empty($_POST['export_lists']) || !is_array($_POST['export_lists'])) { $errors[] = __('Please select export list(s)', $this -> plugin_name); }
						if (empty($_POST['export_filetype'])) { $errors[] = __('Please select an export filetype', $this -> plugin_name); }
						
						$exportfilename = 'subscribers-' . date("Ymd", time()) . '.csv';
						$exportfilepath = WP_CONTENT_DIR . DS . 'uploads' . DS . $this -> plugin_name . DS . 'export' . DS;
						$exportfilefull = $exportfilepath . $exportfilename;
						if (!$fh = fopen($exportfilefull, "w")) { $errors[] = sprintf(__('Export file could not be created, please check permissions on <b>%s</b> to make sure it is writable.', $this -> plugin_name), "/wp-content/uploads/wp-mailinglist/export/"); }
						else { fclose($fh); }
						
						@chmod($exportfilefull, 0777);
						
						if (empty($errors)) {
							$query = "";
							$query .= "SELECT *, COUNT(" . $wpdb -> prefix . $Subscriber -> table . ".email) FROM `" . $wpdb -> prefix . $Subscriber -> table . "`";
							$query .= " LEFT JOIN `" . $wpdb -> prefix . $SubscribersList -> table . "` ON";
							$query .= " " . $wpdb -> prefix . $Subscriber -> table . ".id = " . $wpdb -> prefix . $SubscribersList -> table . ".subscriber_id";
							
							if (!empty($_POST['export_lists'])) {
								$query .= " WHERE (";
								$e = 1;
								
								foreach ($_POST['export_lists'] as $list_id) {
									$query .= "" . $wpdb -> prefix . $SubscribersList -> table . ".list_id = '" . $list_id . "'";
									if ($e < count($_POST['export_lists'])) { $query .= " OR "; }
									$e++;
								}
								
								$query .= ")";
							}
							
							if (!empty($_POST['export_status']) && $_POST['export_status'] != "all") {
								$active = ($_POST['export_status'] == "active") ? "Y" : "N";
								$query .= " AND " . $wpdb -> prefix . $SubscribersList -> table . ".active = '" . $active . "'";
							}
							
							$query .= " GROUP BY " . $wpdb -> prefix . $Subscriber -> table . ".email"; 
							$subscribers = $wpdb -> get_results($query);
							
							$datasets = array();
							if (!empty($subscribers)) {
								$d = 0;
								
								$fieldsquery = "SELECT * FROM `" . $wpdb -> prefix . $Field -> table . "` WHERE `slug` != 'email' ORDER BY `order` ASC";
								$fields = $wpdb -> get_results($fieldsquery);
								
								$headings = array();
								$headings[] = __('ID', $this -> plugin_name);
								$headings[] = __('Email Address', $this -> plugin_name);
								
								if (!empty($fields)) {
									foreach ($fields as $field) {
										$headings[] = $field -> title;
									}
								}
								
								$headings[] = __('Created', $this -> plugin_name); 
								$headings[] = __('Modified', $this -> plugin_name);
								
								$data = "";
								$data .= '"' . implode('","', $headings) . '"' . "\r\n";
							
								foreach ($subscribers as $subscriber) {
									$datasets[$d] = array(
										'id'					=>	$subscriber -> id,
										'email'					=>	$subscriber -> email,
									);
									
									if (!empty($fields)) {
										foreach ($fields as $field) {
											if (!empty($field -> fieldoptions)) {
												$fieldoptions = unserialize($field -> fieldoptions);
											}
											
											switch ($_POST['export_purpose']) {
												case 'other'				:											
													switch ($field -> type) {
														case 'select'				:
														case 'radio'				:
															$datasets[$d][$field -> slug] = $fieldoptions[$subscriber -> {$field -> slug}];
															break;
														case 'checkbox'				:
															$checkboxes = array();
															$supoptions = maybe_unserialize($subscriber -> {$field -> slug});
															if (!empty($supoptions) && is_array($supoptions)) {
																foreach ($supoptions as $subopt) {
																	$checkboxes[] = $fieldoptions[$subopt];
																}
															}
														
															$datasets[$d][$field -> slug] = (!empty($checkboxes) && is_array($checkboxes)) ? implode(",", $checkboxes) : '';
															break;
														case 'pre_country'			:
															$country = $wpdb -> get_var("SELECT `value` FROM " . $wpdb -> prefix . $Country -> table . " WHERE `id` = '" . $subscriber -> {$field -> slug} . "'");
															$datasets[$d][$field -> slug] = (!empty($country)) ? $country : '';
															break;
														case 'pre_date'				:
															$date = maybe_unserialize($subscriber -> {$field -> slug});
															$datasets[$d][$field -> slug] = (!empty($date) && is_array($date) && (!empty($date['y']) || !empty($date['m']) || !empty($date['d']))) ? $date['y'] . '-' . $date['m'] . '-' . $date['d'] : '';
															break;
														case 'pre_gender'			:
															$datasets[$d][$field -> slug] = $Html -> gender($subscriber -> {$field -> slug});
															break;
														default						:
															$datasets[$d][$field -> slug] = $subscriber -> {$field -> slug};
															break;
													}
													break;
												case 'newsletters'			:
												default						:
													switch ($field -> type) {
														case 'select'				:
														case 'radio'				:
															$datasets[$d][$field -> slug] = $fieldoptions[$subscriber -> {$field -> slug}];
															break;
														default						:
															$datasets[$d][$field -> slug] = $subscriber -> {$field -> slug};
															break;
													}
													break;
											}
										}
									}
									
									$datasets[$d]['created'] = $subscriber -> created;
									$datasets[$d]['modified'] = $subscriber -> modified;
									
									$data .= '"' . implode('","', $datasets[$d]) . '"' . "\r\n";
									
									$d++;
								}
							}
							
							if (!empty($_POST['export_progress']) && $_POST['export_progress'] == "Y") {
								$this -> render('export-post', array('subscribers' => $datasets, 'headings' => $headings, 'exportfile' => $exportfilename), true, 'admin');
							} else {
								$fh = fopen($exportfilefull, "w");
								fwrite($fh, $data);
								fclose($fh);
								@chmod($exportfilefull, 0777);
								
								$message = $d . ' ' . sprintf(__('subscribers have been exported. %s', $this -> plugin_name), '<a href="' . WP_CONTENT_URL . '/uploads/' . $this -> plugin_name . '/export/' . $exportfilename . '">' . __('Download CSV', $this -> plugin_name) . '</a>');
								$this -> render_message($message);
								$this -> render('import-export', array('exportfile' => $exportfilename), true, 'admin');
							}
						} else {
							$this -> render('import-export', array('exporterrors' => $errors), true, 'admin');
						}
						break;
				}
			} else {
				$this -> render_admin('import-export', array('mailinglists' => $mailinglists));
			}
		}
		
		function admin_themes() {
			global $wpdb, $Db, $Theme;
			$Db -> model = $Theme -> model;
			$method = $_GET['method'];
			
			switch ($method) {
				case 'save'			:
					if (!empty($_POST)) {
						if ($Db -> save($_POST)) {
							$message = __('Theme has been saved', $this -> plugin_name);
							$this -> redirect('?page=' . $this -> sections -> themes, 'message', $message);
						} else {
							$this -> render_error(__('Theme could not be saved', $this -> plugin_name));
							$this -> render('themes' . DS . 'save', false, true, 'admin');
						}
					} else {
						$Db -> find(array('id' => $_GET['id']));
						$Theme -> data -> paste = $Theme -> data -> content;
						$this -> render_admin('themes' . DS . 'save');
					}
					break;
				case 'delete'		:
					if (!empty($_GET['id'])) {
						if ($Db -> delete($_GET['id'])) {
							$msgtype = 'message';
							$message = __('Theme has been removed', $this -> plugin_name);
						} else {
							$msgtype = 'error';
							$message = __('Theme could not be removed', $this -> plugin_name);
						}
					} else {
						$msgtype = 'error';
						$message = __('No theme was specified', $this -> plugin_name);
					}
					
					$this -> redirect('?page=' . $this -> sections -> themes, $msgtype, $message);
					break;
				case 'default'		:
					if (!empty($_GET['id'])) {
						$Db -> model = $Theme -> model;
						$Db -> save_field('def', "N");
						
						$Db -> model = $Theme -> model;
						$Db -> save_field('def', "Y", array('id' => $_GET['id']));
						
						$msg_type = 'message';
						$message = __('Selected theme has been set as the default', $this -> plugin_name);
					} else {
						$msg_type = 'error';
						$message = __('No theme was specified', $this -> plugin_name);
					}
					
					$this -> redirect("?page=" . $this -> sections -> themes, $msg_type, $message);
					break;
				case 'mass'			:
					if (!empty($_POST['action'])) {
						$themes = $_POST['themeslist'];
						
						if (!empty($themes)) {
							switch ($_POST['action']) {
								case 'delete'				:
									foreach ($themes as $theme_id) {
										$Db -> model = $Theme -> model;
										$Db -> delete($theme_id);
									}
									
									$msg_type = 'message';
									$message = __('Selected themes have been removed', $this -> plugin_name);
									break;
							}
						} else {
							$msg_type = 'error';
							$message = __('No themes were selected', $this -> plugin_name);
						}
					} else {
						$msg_type = 'error';
						$message = __('No action was selected', $this -> plugin_name);
					}
					
					$this -> redirect($this -> url, $msg_type, $message);
					break;
				default				:
					$perpage = (empty($_COOKIE[$this -> pre . 'themesperpage'])) ? 15 : $_COOKIE[$this -> pre . 'themesperpage'];
					$searchterm = (!empty($_GET[$this -> pre . 'searchterm'])) ? $_GET[$this -> pre . 'searchterm'] : false;
					$searchterm = (!empty($_POST['searchterm'])) ? $_POST['searchterm'] : $searchterm;
					
					if (!empty($_POST['searchterm'])) {
						$this -> redirect($this -> url . '&' . $this -> pre . 'searchterm=' . urlencode($searchterm));
					}
					
					$conditions = (!empty($searchterm)) ? array('title' => "LIKE '%" . $searchterm . "%'") : false;
					
					$ofield = (isset($_COOKIE[$this -> pre . 'themessorting'])) ? $_COOKIE[$this -> pre . 'themessorting'] : "modified";
					$odir = (isset($_COOKIE[$this -> pre . 'themes' . $ofield . 'dir'])) ? $_COOKIE[$this -> pre . 'themes' . $ofield . 'dir'] : "DESC";
					$order = array($ofield, $odir);
					
					if (!empty($_GET['showall'])) {
						$Db -> model = $Theme -> model;
						$themes = $Db -> find_all(false, "*", $order);
						$data[$Theme -> model] = $themes;
						$data['Paginate'] = false;
					} else {
						$data = $Theme -> get_all_paginated($conditions, $searchterm, $this -> sections -> themes, $perpage, $order);
					}
					
					$this -> render_admin('themes' . DS . 'index', array('themes' => $data[$Theme -> model], 'paginate' => $data['Pagination']));
					break;
			}
		}
		
		function admin_templates() {
			global $wpdb, $Db, $Template;
			$Db -> model = $Template -> model;
			
			//get the page method
			$method = (empty($_GET['method'])) ? preg_replace("/newsletters\-templates\-/si", "", $_GET['page']) : $_GET['method'];
			
			switch ($method) {
				case 'save'			:
					$this -> render_message(__('Email templates are meant for content only, use the Themes for newsletter layouts.', $this -> plugin_name));
				
					if (!empty($_POST)) {
						if ($Template -> save($_POST)) {
							$message = __('Template has been saved', $this -> plugin_name);
							$this -> redirect('?page=' . $this -> sections -> templates, 'message', $message);
						} else {
							$this -> render_error(__('Template could not be saved', $this -> plugin_name));
							$this -> render('templates' . DS . 'save', false, true, 'admin');
						}
					} else {
						$Template -> get($_GET['id']);
						$_POST['content'] = $Template -> data[$Template -> model] -> content;
						$this -> render_admin('templates' . DS . 'save');
					}
					break;
				case 'delete'					:
					if (!empty($_GET['id'])) {
						if ($Template -> delete($_GET['id'])) {
							$message = __('Template has been removed', $this -> plugin_name);
							$this -> redirect($this -> url, 'message', $message);
						}
					} else {
						$message = __('No template was specified', $this -> plugin_name);
						$this -> redirect($this -> url, 'error', $message);
					}
					break;
				case 'view'						:
					if (!empty($_GET['id'])) {
						if ($template = $Db -> find(array('id' => $_GET['id']))) {
							$this -> render_admin('templates' . DS . 'view', array('template' => $template));
						} else {
							$message = __('Template cannot be read', $this -> plugin_name);
							$this -> redirect($this -> url, 'error', $message);
						}
					} else {
						$message = __('No template was specified', $this -> plugin_name);
						$this -> redirect($this -> url, 'error', $message);
					}
					break;
				case 'mass'						:
					if (!empty($_POST['action'])) {
						if (!empty($_POST['templateslist'])) {
							if ($Template -> delete_array($_POST['templateslist'])) {
								$msg_type = 'message';
								$message = __('Selected templates removed', $this -> plugin_name);
							} else {
								$msg_type = 'error';
								$message = __('Templates could not be removed', $this -> plugin_name);
							}
						} else {
							$msg_type = 'error';
							$message = __('No templates were selected', $this -> plugin_name);
						}
					} else {
						$msg_type = 'error';
						$message = __('No action was selected', $this -> plugin_name);
					}
					
					$this -> redirect($this -> url, $msg_type, $message);
					break;
				default 						:
					$perpage = (empty($_COOKIE[$this -> pre . 'templatesperpage'])) ? 15 : $_COOKIE[$this -> pre . 'templatesperpage'];
					$searchterm = (!empty($_GET[$this -> pre . 'searchterm'])) ? $_GET[$this -> pre . 'searchterm'] : false;
					$searchterm = (!empty($_POST['searchterm'])) ? $_POST['searchterm'] : $searchterm;
					
					if (!empty($_POST['searchterm'])) {
						$this -> redirect($this -> url . '&' . $this -> pre . 'searchterm=' . urlencode($searchterm));
					}
					
					$conditions = (!empty($searchterm)) ? array('title' => "LIKE '%" . $searchterm . "%'") : false;
					
					$ofield = (isset($_COOKIE[$this -> pre . 'templatessorting'])) ? $_COOKIE[$this -> pre . 'templatessorting'] : "modified";
					$odir = (isset($_COOKIE[$this -> pre . 'templates' . $ofield . 'dir'])) ? $_COOKIE[$this -> pre . 'templates' . $ofield . 'dir'] : "DESC";
					$order = array($ofield, $odir);
					
					if (!empty($_GET['showall'])) {
						$Db -> model = $Template -> model;
						$templates = $Db -> find_all(false, "*", $order);
						$data[$Template -> model] = $templates;
						$data['Paginate'] = false;
					} else {
						$data = $Template -> get_all_paginated($conditions, $searchterm, $this -> sections -> templates, $perpage, $order);
					}
					
					$this -> render_admin('templates' . DS . 'index', array('templates' => $data[$Template -> model], 'paginate' => $data['Pagination']));	
					break;
			}
		}
		
		function admin_mailqueue() {
			global $wpdb, $Db, $Queue, $Email, $Subscriber;
			$Db -> model = $Queue -> model;
			
			if ($this -> get_option('scheduling') == "N") {
				$this -> render_error(__('Email scheduling is turned off', $this -> plugin_name));
			}
			
			switch ($_GET['method']) {
				case 'clear'				:
					$Queue -> truncate();
					$message = __('The queue has been truncated', $this -> plugin_name);
					$this -> redirect($this -> url, 'message', $message);
					break;
				case 'mass'					:			
					if (!empty($_POST['action'])) {
						if (!empty($_POST['Queue']['checklist'])) {
							$emails = $_POST['Queue']['checklist'];
						
							switch ($_POST['action']) {
								case 'send'					:
									$subscriberemails = array();
									$emailssent = 0;
								
									foreach ($emails as $email_id) {									
										$this -> remove_server_limits();							
										$Db -> model = $Queue -> model;
									
										if ($email = $Db -> find(array('id' => $email_id))) {											
											$subscriber = $Subscriber -> get($email -> subscriber_id, false);
											$subscriber -> mailinglist_id = $email -> mailinglist_id;
											$eunique = md5($subscriber -> id . $subscriber -> mailinglist_id . $email -> history_id . date("YmdH", time()));
											
											if ((empty($subscriberemails[$email -> history_id])) || (!empty($subscriberemails[$email -> history_id]) && !in_array($subscriber -> email, $subscriberemails[$email -> history_id]))) {						
												$subscriberemails[$email -> history_id][] = $subscriber -> email;
												$message = $this -> render_email('send', array('message' => $email -> message, 'subject' => $email -> subject, 'subscriber' => $subscriber, 'history_id' => $email -> history_id, 'post_id' => $email -> post_id, 'eunique' => $eunique), false, $this -> htmltf($subscriber -> format), true, $email -> theme_id);
												
												if ($this -> execute_mail($subscriber, $email -> subject, $message, $email -> attachments, $email -> history_id, $eunique)) {
													$Queue -> delete($email -> id);
													$emailssent++;	
												}
											}
										}
									}
									
									$msg_type = 'message';
									$message = $emailssent . ' ' . __('queue email(s) have been sent out', $this -> plugin_name);
									
									break;
								case 'delete'				:
									if ($Queue -> delete_array($emails)) {
										$msg_type = 'message';
										$message = count($emails) . ' ' . __('queue email(s) removed', $this -> plugin_name);
									} else {
										$msg_type = 'error';
										$message = __('Queue emails cannot be removed', $this -> plugin_name);
									}
									break;
							}
						} else {
							$msg_type = 'error';
							$message = __('No queue emails were selected', $this -> plugin_name);
						}
					} else {
						$msg_type = 'error';
						$message = __('No action was selected', $this -> plugin_name);
					}
					
					$this -> redirect($this -> url, $msg_type, $message);
					break;
				default						:
					$perpage = (isset($_COOKIE[$this -> pre . 'queuesperpage'])) ? $_COOKIE[$this -> pre . 'queuesperpage'] : 15;
				
					$ofield = (isset($_COOKIE[$this -> pre . 'queuessorting'])) ? $_COOKIE[$this -> pre . 'queuessorting'] : "modified";
					$odir = (isset($_COOKIE[$this -> pre . 'queues' . $ofield . 'dir'])) ? $_COOKIE[$this -> pre . 'queues' . $ofield . 'dir'] : "DESC";
					$order = array($ofield, $odir);
					
					if (!empty($_GET['showall'])) {
						/*$Db -> model = $Queue -> model;
						$emails = $Db -> find_all(false, "*", $order);
						$data[$Queue -> model] = $emails;
						$data['Paginate'] = false;*/
						
						$emailsquery = "SELECT * FROM " . $wpdb -> prefix . $Queue -> table . "";
						$emails = $wpdb -> get_results($emailsquery);
						$data[$Queue -> model] = $emails;
						$data['Paginate'] = false;
					} else {
						$data = $Queue -> get_all_paginated(false, false, $this -> sections -> queue, $perpage, $order);
					}
					
					$this -> render_admin('queues' . DS . 'index', array('queues' => $data[$Queue -> model], 'paginate' => $data['Pagination']));
					break;
			}
		}
		
		function admin_history() {
			global $wpdb, $Db, $History, $Email;
			$Db -> model = $History -> model;
		
			switch ($_GET['method']) {
				case 'view'				:
					if (!empty($_GET['id'])) {
						if ($history = $History -> get($_GET['id'])) {
							$conditions = array('history_id' => $_GET['id']);
							$perpage = 20;
							$order = array('id', "ASC");
							$data = $Email -> get_all_paginated($conditions, false, $this -> sections -> history . '&amp;method=view&amp;id=' . $_GET['id'], $perpage, $order, '#emailssent');
							$this -> render_admin('history' . DS . 'view', array('history' => $history, 'emails' => $data[$Email -> model], 'paginate' => $data['Pagination']));
						} else {
							$message = __('History email cannot be read', $this -> plugin_name);
							$this -> redirect($this -> url, 'error', $message);
						}
					} else {
						$message = __('No history email was specified', $this -> plugin_name);
						$this -> redirect($this -> url, 'error', $message);
					}
					break;
				case 'delete'			:
					if (!empty($_GET['id'])) {
						if ($History -> delete($_GET['id'])) {
							$message = __('History email has been removed', $this -> plugin_name);
						} else {
							$message = __('History email could not be removed', $this -> plugin_name);
						}
					} else {
						$message = __('No history email was specified', $this -> plugin_name);
					}
					
					$this -> redirect($this -> url, 'message', $message);
					break;
				case 'mass'				:
					if (!empty($_POST['action'])) {
						if (!empty($_POST['historylist'])) {
							$histories = $_POST['historylist'];
							
							switch ($_POST['action']) {
								case 'delete'				:
									foreach ($histories as $history_id) {
										$Db -> model = $History -> model;
										$Db -> delete($history_id);
									}
									
									$msg_type = 'message';
									$message = count($histories) . ' ' . __('history record(s) have been removed', $this -> plugin_name);
									break;
							}
						} else {
							$msg_type = 'error';
							$message = __('No history emails were selected', $this -> plugin_name);
						}
					} else {
						$msg_type = 'error';
						$message = __('No action was specified', $this -> plugin_name);
					}
					
					$this -> redirect($this -> referer, $msg_type, $message);
					break;
				case 'clear'			:
					if ($History -> truncate()) {
						$msg_type = 'message';
						$message = __('History list has been purged', $this -> plugin_name);
					} else {
						$msg_type = 'error';
						$message = __('History items cannot be removed', $this -> plugin_name);
					}
					
					$this -> redirect($this -> url, $msg_type, $message);
					break;
				case 'removeattachment'	:
					global $Db, $HistoriesAttachment;
					
					if (!empty($_GET['id'])) {
						$Db -> model = $HistoriesAttachment -> model;
						
						if ($attachment = $Db -> find(array('id' => $_GET['id']))) {
							if (!empty($attachment -> filename) && file_exists($attachment -> filename)) {
								@unlink($attachment -> filename);	
							}
							
							$Db -> model = $HistoriesAttachment -> model;
							$Db -> delete($attachment -> id);
							
							$msg_type = 'message';
							$message = __('Attachment file has been removed.', $this -> plugin_name);
						} else {
							$msg_type = 'error';
							$message = __('Attachment could not be read.', $this -> plugin_name);	
						}
					} else {
						$msg_type = 'error';
						$message = __('No attachment was specified.', $this -> plugin_name);	
					}
					
					$this -> redirect($this -> referer, $msg_type, $message);
					break;
				case 'exportsent'		:
					global $wpdb, $Db, $Subscriber, $Mailinglist, $History, $Email;
				
					if (!empty($_GET['history_id'])) {
						$Db -> model = $Email -> model;
						
						if ($emails = $Db -> find_all(array('history_id' => $_GET['history_id']), false, array('modified', "DESC"))) {
							/* CSV Headings */
							$data = "";
							$data .= '"' . __('Email Address', $this -> plugin_name) . '",';
							$data .= '"' . __('Mailing List', $this -> plugin_name) . '",';
							$data .= '"' . __('Read/Opened', $this -> plugin_name) . '",';
							$data .= '"' . __('Sent Date', $this -> plugin_name) . '",';
							$data .= "\r\n";
							
							foreach ($emails as $email) {
								$this -> remove_server_limits();
								
								/* Subscriber */
								$Db -> model = $Subscriber -> model;
	                        	$subscriber = $Db -> find(array('id' => $email -> subscriber_id));
								$data .= '"' . $subscriber -> email . '",';
								
								/* Mailing List */
								$Db -> model = $Mailinglist -> model;
	                        	$mailinglist = $Db -> find(array('id' => $email -> mailinglist_id));
								$data .= '"' . $mailinglist -> title . '",';
								
								/* Read/Opened Status */
								$data .= '"' . ((!empty($email -> read) && $email -> read == "Y") ? __('Yes', $this -> plugin_name) : __('No', $this -> plugin_name)) . '",';
								$data .= '"' . (date("Y-m-d H:i:s", strtotime($email -> modified))) . '",';
								$data .= "\r\n";	
							}
							
							if (!empty($data)) {
								$exportfile = 'history' . $_GET['history_id'] . '_emails.csv';
								$exportpath = ABSPATH . 'wp-content' . DS . 'uploads' . DS;
								$exportfull = $exportpath . $exportfile;
								
								if ($fh = fopen($exportfull, "w")) {
									fwrite($fh, $data);
									fclose($fh);
									@chmod($exportfull, 0777);
									
									$exportfileabs = rtrim(site_url(), '/') . '/wp-content/uploads/' . $exportfile;	
									$msg_type = 'message';
									$message = __('CSV has been exported to "wp-content/uploads/" with filename "' . $exportfile . '".', $this -> plugin_name) . ' <a href="' . $exportfileabs . '" title="' . __('Download the CSV', $this -> plugin_name) . '">' . __('Download the CSV', $this -> plugin_name) . '</a>';
								} else {
									$msg_type = 'error';
									$message = __('CSV file could not be created, please check write permissions on "wp-content/uploads/" folder.', $this -> plugin_name);	
								}
							} else {
								$msg_type = 'error';
								$message = __('CSV data could not be formulated, no emails maybe? Please try again', $this -> plugin_name);
							}
						} else {
							$msg_type = 'error';
							$message = __('No history/draft emails are available to export!', $this -> plugin_name);
						}
					} else {
						$msg_type = 'error';
						$message = __('No history email was specified, please try again.', $this -> plugin_name);	
					}
					
					$this -> redirect("?page=" . $this -> sections -> history . "&method=view&id=" . $_GET['history_id'], $msg_type, $message);
					break;
				case 'export'			:
					global $Db, $Email, $History, $Mailinglist, $Theme;
					$Db -> model = $History -> model;
					
					if ($emails = $Db -> find_all(false, false, array('modified', "DESC"))) {
						$data = "";
						$data .= '"' . __('Id', $this -> plugin_name) . '",';
						$data .= '"' . __('Subject', $this -> plugin_name) . '",';
						$data .= '"' . __('Lists', $this -> plugin_name) . '",';
						$data .= '"' . __('Theme', $this -> plugin_name) . '",';
						$data .= '"' . __('Author', $this -> plugin_name) . '",';
						$data .= '"' . __('Read %', $this -> plugin_name) . '",';
						$data .= '"' . __('Emails Sent', $this -> plugin_name) . '",';
						$data .= '"' . __('Emails Read', $this -> plugin_name) . '",';
						$data .= '"' . __('Created', $this -> plugin_name) . '",';
						$data .= '"' . __('Modified', $this -> plugin_name) . '",';
						$data .= "\r\n";
						
						foreach ($emails as $email) {
							$this -> remove_server_limits();			//remove the server resource limits
							
							$data .= '"' . $email -> id . '",';
							$data .= '"' . $email -> subject . '",';						
							
							/* Mailing lists */
							if (!empty($email -> mailinglists)) {
								$data .= '"';
								$m = 1;
								
								foreach ($email -> mailinglists as $mailinglist_id) {
									$mailinglist = $Mailinglist -> get($mailinglist_id);	
									$data .= $mailinglist -> title;
									
									if ($m < count($email -> mailinglists)) {
										$data .= ', ';
									}
									
									$m++;
								}
								
								$data .= '",';
							} else { 
								$data .= '"",';
							}
							
							/* Theme */
							if (!empty($email -> theme_id)) {
								$Db -> model = $Theme -> model;
								
								if ($theme = $Db -> find(array('id' => $email -> theme_id))) {
									$data .= '"' . $theme -> title . '",';
								} else {
									$data .= '"",';	
								}
							} else {
								$data .= '"",';	
							}
							
							/* Author */
							if (!empty($email -> user_id)) {
								if ($user = get_userdata($email -> user_id)) {
									$data .= '"' . $user -> display_name . '",';
								} else {
									$data .= '"",';	
								}
							} else {
								$data .= '"",';	
							}
							
							/* read % */
							$Db -> model = $Email -> model;
							$etotal = $Db -> count(array('history_id' => $email -> id));
							$eread = $Db -> count(array('history_id' => $email -> id, 'read' => "Y"));
							$eperc = (($eread/$etotal) * 100);
							$data .= '"' . number_format($eperc, 2, '.', '') . '% ' . __('read', $this -> plugin_name) . '",';
							
							$data .= '"' . $etotal . '",'; 					// emails sent
							$data .= '"' . $eread . '",';					// emails read
							$data .= '"' . $email -> created . '",';		// created date
							$data .= '"' . $email -> modified . '",';		// modified date
							
							$data .= "\r\n";
						}
						
						if (!empty($data)) {
							$filename = "emails_history_" . date("Y-m-d", time()) . '.csv';
							$filepath = ABSPATH . 'wp-content' . DS . 'uploads' . DS;
							$filefull = $filepath . $filename;
							
							if ($fh = fopen($filefull, "w")) {
								fwrite($fh, $data);
								fclose($fh);
								
								$fileabs = rtrim(site_url(), '/') . '/wp-content/uploads/' . $filename;	
								$message = __('CSV has been exported to "wp-content/uploads/" with filename "' . $filename . '".', $this -> plugin_name) . ' <a href="' . $fileabs . '" title="' . __('Download the CSV', $this -> plugin_name) . '">' . __('Download the CSV', $this -> plugin_name) . '</a>';
								$this -> redirect($this -> url, "message", $message);
							} else {
								$message = __('CSV file could not be created, please check write permissions on "wp-content/uploads/" folder.', $this -> plugin_name);
								$this -> redirect($this -> url, "error", $message);	
							}
						} else {
							$message = __('CSV data could not be formulated, no emails maybe? Please try again', $this -> plugin_name);
							$this -> redirect($this -> url, "error", $message);
						}
					} else {
						$message = __('No history/draft emails are available to export!', $this -> plugin_name);
						$this -> redirect($this -> url, "error", $message);
					}
					break;
				default					:
					$perpage = (isset($_COOKIE[$this -> pre . 'historiesperpage'])) ? $_COOKIE[$this -> pre . 'historiesperpage'] : 15;
					$searchterm = (!empty($_GET[$this -> pre . 'searchterm'])) ? $_GET[$this -> pre . 'searchterm'] : false;
					$searchterm = (!empty($_POST['searchterm'])) ? $_POST['searchterm'] : $searchterm;
					
					if (!empty($_POST['searchterm'])) {
						$this -> redirect($this -> url . '&' . $this -> pre . 'searchterm=' . urlencode($searchterm));
					}
					
					$conditions = (!empty($searchterm)) ? array('subject' => "LIKE '%" . $searchterm . "%'") : false;		
					
					$ofield = (isset($_COOKIE[$this -> pre . 'historysorting'])) ? $_COOKIE[$this -> pre . 'historysorting'] : "modified";
					$odir = (isset($_COOKIE[$this -> pre . 'history' . $ofield . 'dir'])) ? $_COOKIE[$this -> pre . 'history' . $ofield . 'dir'] : "DESC";
					$order = array($ofield, $odir);
						
					if (!empty($_GET['showall'])) {
						$Db -> model = $History -> model;
						$histories = $Db -> find_all(false, "*", $order);
						$data[$History -> model] = $histories;
						$data['Paginate'] = false;
					} else {	
						$data = $History -> get_all_paginated($conditions, $searchterm, $this -> sections -> history, $perpage, $order);
					}
					
					$this -> render_admin('history' . DS . 'index', array('histories' => $data[$History -> model], 'paginate' => $data['Pagination']));			
					break;
			}
		}
		
		function admin_orders() {
			global $wpdb, $Db, $wpmlOrder, $Subscriber, $Mailinglist;
			$Db -> model = $wpmlOrder -> model;
			
			switch ($_GET['method']) {
				case 'view'			:
					if (!empty($_GET['id'])) {
						if ($order = $wpmlOrder -> get($_GET['id'])) {
							$subscriber = $Subscriber -> get($order -> subscriber_id, false);
							$mailinglist = $Mailinglist -> get($order -> list_id, false);
							$this -> render_admin('orders' . DS . 'view', array('order' => $order, 'subscriber' => $subscriber, 'mailinglist' => $mailinglist));
						} else {
							$this -> render_error(__('Order could not be retrieved', $this -> plugin_name));
						}
					} else {
						$this -> render_error(__('No order ID was specified', $this -> plugin_name));
					}
					break;
				case 'save'			:
					if (!empty($_POST)) {
						$_POST['completed'] = "Y";
					
						if ($wpmlOrder -> save($_POST, true)) {
							$this -> render_message(__('Order has been saved', $this -> plugin_name));
							$data = $wpmlOrder -> get_all_paginated();
							$this -> render_admin('orders' . DS . 'index', array('orders' => $data[$wpmlOrder -> model], 'paginate' => $data['Pagination']));
						} else {
							$this -> render_error(__('Order could not be saved', $this -> plugin_name));
							$this -> render_admin('orders' . DS . 'save', array('order' => new wpmlOrder($_POST), 'errors' => $wpmlOrder -> errors));
						}
					} else {
						if (!empty($_GET['id'])) {
							if ($order = $wpmlOrder -> get($_GET['id'])) {
								$this -> render_admin('orders' . DS . 'save', array('order' => $order));
							} else {
								$this -> render_error(__('Order could not be read', $this -> plugin_name));
							}
						} else {
							$this -> render_error(__('No order ID was specified', $this -> plugin_name));
						}
					}
					break;
				case 'delete'		:
					if (!empty($_GET['id'])) {
						if ($wpmlOrder -> delete($_GET['id'])) {
							$this -> render_message(__('Order successfully removed', $this -> plugin_name));
						} else {
							$this -> render_error(__('Order could not be removed', $this -> plugin_name));
						}
					} else {
						$this -> render_error(__('No order ID was specified', $this -> plugin_name));
					}
					
					$data = $wpmlOrder -> get_all_paginated();
					$this -> render_admin('orders' . DS . 'index', array('orders' => $data[$wpmlOrder -> model], 'paginate' => $data['Pagination']));
					break;
				case 'mass'			:
					if (!empty($_POST)) {
						if (!empty($_POST['orderslist'])) {
							if (!empty($_POST['action'])) {
								$orders = $_POST['orderslist'];
								
								switch ($_POST['action']) {
									case 'delete'		:
										foreach ($orders as $order_id) {
											$wpmlOrder -> delete($order_id);
										}
										
										$msg_type = 'message';
										$message = __('Selected orders succesfully removed', $this -> plugin_name);
										break;
								}
							} else {
								$msg_type = 'error';
								$message = __('No action was selected', $this -> plugin_name);
							}
						} else {
							$msg_type = 'error';
							$message = __('No orders were selected', $this -> plugin_name);
						}
					} else {
						$msg_type = 'error';
						$message = __('No data was posted', $this -> plugin_name);
					}
					
					$this -> redirect($this -> url, $msg_type, $message);
					break;
				default				:
					$perpage = (isset($_COOKIE[$this -> pre . 'ordersperpage'])) ? $_COOKIE[$this -> pre . 'ordersperpage'] : 15;
					$searchterm = (!empty($_GET[$this -> pre . 'searchterm'])) ? $_GET[$this -> pre . 'searchterm'] : false;
					$searchterm = (!empty($_POST['searchterm'])) ? $_POST['searchterm'] : $searchterm;
					
					if (!empty($_POST['searchterm'])) {
						$this -> redirect($this -> url . '&' . $this -> pre . 'searchterm=' . urlencode($searchterm));
					}
					
					$conditions = (!empty($searchterm)) ? array('subscriber_id' => "LIKE '%" . $searchterm . "%'") : false;		
					
					$ofield = (isset($_COOKIE[$this -> pre . 'orderssorting'])) ? $_COOKIE[$this -> pre . 'orderssorting'] : "modified";
					$odir = (isset($_COOKIE[$this -> pre . 'orders' . $ofield . 'dir'])) ? $_COOKIE[$this -> pre . 'orders' . $ofield . 'dir'] : "DESC";
					$order = array($ofield, $odir);
						
					if (!empty($_GET['showall'])) {
						$Db -> model = $wpmlOrder -> model;
						$orders = $Db -> find_all(false, "*", $order);
						$data[$wpmlOrder -> model] = $orders;
						$data['Paginate'] = false;
					} else {	
						$data = $wpmlOrder -> get_all_paginated($conditions, $searchterm, $this -> sections -> orders, $perpage, $order);
					}
					
					$this -> render_admin('orders' . DS . 'index', array('orders' => $data[$wpmlOrder -> model], 'paginate' => $data['Pagination']));
					break;
			}
		}
		
		function admin_fields() {
			global $wpdb, $Db, $Field, $FieldsList;
			
			switch ($_GET['method']) {
				case 'save'				:
					if (!empty($_POST)) {
						if ($Field -> save($_POST)) {					
							$message = __('Custom field has been saved', $this -> plugin_name);
							$this -> redirect('?page=' . $this -> sections -> fields, 'message', $message);
						} else {
							$this -> render_error(__('Custom field could not be saved', $this -> plugin_name));
							$this -> render_admin('fields' . DS . 'save');
						}
					} else {
						$Field -> get($_GET['id']);
						
						if ($Field -> data['Field'] -> slug == "email") {
							$this -> render_message(__('This is a fixed field and can be edited but not deleted.', $this -> plugin_name));
						}
						
						$this -> render_admin('fields' . DS . 'save');
					}
					break;
				case 'delete'			:
					if (!empty($_GET['id'])) {
						$fieldquery = "SELECT * FROM " . $wpdb -> prefix . $Field -> table . " WHERE id = '" . $_GET['id'] . "'";
						if ($field = $wpdb -> get_row($fieldquery)) {
							if ($field -> slug != "email") {
								if ($Field -> delete($_GET['id'])) {
									$message_type = 'message';
									$message = __('Field has been removed', $this -> plugin_name);
								} else {
									$message_type = 'error';
									$message = __('Field cannot be removed', $this -> plugin_name);
								}	
							} else {
								$message_type = 'error';
								$message = __('Email address field cannot be deleted.', $this -> plugin_name);
							}
						} else {
							$message_type = 'error';
							$message = __('Field cannot be read.', $this -> plugin_name);
						}
					} else {
						$message_type = 'error';
						$message = __('No field was specified', $this -> plugin_name);
					}
					
					$this -> redirect($this -> url, $message_type, $message);
					break;
				case 'mass'				:					
					if (!empty($_POST['fieldslist'])) {					
						if (!empty($_POST['action'])) {						
							$fields = $_POST['fieldslist'];
							
							switch ($_POST['action']) {
								case 'delete'		:
									$Field -> delete_array($fields);
									$message = __('Selected custom fields removed', $this -> plugin_name);
									break;
								case 'required'		:
									foreach ($fields as $field_id) {
										$Db -> model = $Field -> model;
										$Db -> save_field('required', "Y", array('id' => $field_id));
									}
									
									$message = __('Selected custom fields have been set as required', $this -> plugin_name);
									break;
								case 'notrequired'	:							
									foreach ($fields as $field_id) {
										$fieldquery = "SELECT * FROM " . $wpdb -> prefix . $Field -> table . " WHERE id = '" . $field_id . "'";
										if ($field = $wpdb -> get_row($fieldquery)) {
											if ($field -> slug != "email") {
												$Db -> model = $Field -> model;
												$Db -> save_field('required', "N", array('id' => $field_id));
											}
										}
									}
									
									$message = __('Selected custom fields have been set as NOT required', $this -> plugin_name);
									break;
							}
							
							$msg_type = 'message';
						} else {
							$msg_type = 'error';
							$message = __('No action was selected', $this -> plugin_name);
						}
					} else {
						$msg_type = 'error';
						$message = __('No custom fields were selected', $this -> plugin_name);
					}
					
					$this -> redirect($this -> url, $msg_type, $message);
					break;
				case 'order'			:
					$Db -> model = $Field -> model;
					$fields = $Db -> find_all(false, false, array('order', "ASC"));				
					$this -> render_admin('fields' . DS . 'order', array('fields' => $fields));
					break;
				default					:
					$ofield = (isset($_COOKIE[$this -> pre . 'fieldssorting'])) ? $_COOKIE[$this -> pre . 'fieldssorting'] : "modified";
					$odir = (isset($_COOKIE[$this -> pre . 'fields' . $ofield . 'dir'])) ? $_COOKIE[$this -> pre . 'fields' . $ofield . 'dir'] : "DESC";
					$order = array($ofield, $odir);
								
					$data = array();
					if (!empty($_GET['showall'])) {
						$Db -> model = $Field -> model;
						//$conditions['1'] = "1 AND `slug` != 'email'";
						$data[$Field -> model] = $Db -> find_all($conditions, "*", $order);
						$data['Paginate'] = false;
					} else {
						$perpage = (!empty($_COOKIE[$this -> pre . 'fieldsperpage'])) ? $_COOKIE[$this -> pre . 'fieldsperpage'] : 15;
						$searchterm = (empty($_GET[$this -> pre . 'searchterm'])) ? '' : $_GET[$this -> pre . 'searchterm'];
						$searchterm = (empty($_POST['searchterm'])) ? $searchterm : $_POST['searchterm'];			
						
						if (!empty($_POST['searchterm'])) {
							$this -> redirect($this -> url . '&' . $this -> pre . 'searchterm=' . urlencode($searchterm));
						}
						
						if (!empty($searchterm)) {
							$conditions[] = "`title` LIKE '%" . $searchterm . "%' OR `slug` LIKE '%" . $searchterm . "%'";	
						}
						
						$data = $Field -> get_all_paginated($conditions, $searchterm, $this -> sections -> fields, $perpage, $order);
					}
						
					$this -> render_admin('fields' . DS . 'index', array('fields' => $data[$Field -> model], 'paginate' => $data['Pagination']));
					break;
			}
		}
		
		/**
		 * Administration configuration area
		 * Outputs the config form and receives posted option keys and values
		 *
		 **/
		function admin_config() {
			global $wpdb, $Html, $Db, $Subscriber, $Latestpost, $Country, $Mailinglist;
			
			if (!empty($_GET['reset']) && $_GET['reset'] == 1) {
				$this -> update_options();
				$this -> redirect($this -> url);
			}
	
			switch ($_GET['method']) {
				case 'clearlpshistory'	:
					$clearquery = "TRUNCATE TABLE " . $wpdb -> prefix . $Latestpost -> table . "";
					
					if ($wpdb -> query($clearquery)) {
						$msg_type = 'message';
						$message = __('Latest Posts Subscription history has been cleared.', $this -> plugin_name);
					} else {
						$msg_type = 'error';
						$message = __('Latest Posts Subscription history could not be cleared, please try again.', $this -> plugin_name);
					}
					
					$this -> redirect($this -> referer, $msg_type, $message);
					break;
				case 'runschedule'		:
					if (!empty($_GET['hook'])) {
						do_action($this -> pre . '_' . $_GET['hook']);						
						$msg_type = 'message';
						$message = __('Task has been executed successfully!', $this -> plugin_name);
					} else {
						$msg_type = 'error';
						$message = __('No task was specified, please try again.', $this -> plugin_name);	
					}
					
					$this -> redirect($this -> referer, $msg_type, $message);
					break;
				case 'reschedule'		:
					if (!empty($_GET['hook'])) {
						switch ($_GET['hook']) {
							case 'cronhook'			:
								$this -> scheduling();
								break;
							case 'pophook'			:
								$this -> pop_scheduling();
								break;
							case 'latestposts'		:
								$this -> latestposts_scheduling();
								break;
							case 'autoresponders'	:
								$this -> autoresponder_scheduling();
								break;
							case 'importusers'		:
								$this -> importusers_scheduling();
								break;
						}
						
						$msg_type = 'message';
						$message = __('Task has been rescheduled successfully!', $this -> plugin_name);
					} else {
						$msg_type = 'error';
						$message = __('No task was specified, please try again.', $this -> plugin_name);
					}
					
					$this -> redirect($this -> referer, $msg_type, $message);
					break;
				case 'clearschedule'	:
					if (!empty($_GET['hook'])) {
						wp_clear_scheduled_hook($this -> pre . '_' . $_GET['hook']);
						
						$msg_type = 'message';
						$message = __('Task has been unscheduled, remember to reschedule as needed.', $this -> plugin_name);
					} else {
						$msg_type = 'error';
						$message = __('No task was specified, please try again.', $this -> plugin_name);
					}
					
					$this -> redirect($this -> referer, $msg_type, $message);
					break;
				case 'reset'			:
					$query = "TRUNCATE TABLE `" . $wpdb -> prefix . "" . $Country -> table . "`";
					$wpdb -> query($query);
				
					$query = "DELETE FROM `" . $wpdb -> prefix . "options` WHERE `option_name` LIKE '" . $this -> pre . "%';";
				
					if ($wpdb -> query($query)) {				
						$msg_type = 'message';
						$message = __('All configuration settings have been reset', $this -> plugin_name);
					} else {
						$msg_type = 'error';
						$message = __('Configuration settings cannot be reset', $this -> plugin_name);
					}
					
					$this -> redirect($Html -> retainquery('reset=1', $this -> url), $msg_type, $message);
					break;
				default					:			
					//make sure that data has been posted
					if (!empty($_POST)) {
						//unset values that are not required
						unset($_POST['save']);
						
						foreach ($_POST as $key => $val) {				
							$this -> update_option($key, $val);
							
							switch ($key) {
								case 'customcsscode'		:
									if (!empty($_POST['customcss']) && $_POST['customcss'] == "Y") {
										$this -> update_option('customcss', "Y");
										$this -> update_option('customcsscode', $_POST['customcsscode']);
									} else {
										$this -> update_option('customcss', "N");	
									}
									break;
							}
						}
						
						//update scheduling
						$this -> scheduling();
	                    $this -> pop_scheduling();
	                    
	                    if (!empty($_POST['latestposts_updateinterval']) && $_POST['latestposts_updateinterval'] == "Y") {
	                    	$this -> latestposts_scheduling();
	                    }
	
						$this -> render_message(__('Configuration settings successfully updated', $this -> plugin_name));
					}
					
					$mailinglists = $Mailinglist -> get_all('*', true);
					$this -> render_admin('settings', array('mailinglists' => $mailinglists));
					break;
			}
		}
		
		function admin_settings_subscribers() {
			if (!empty($_POST)) {
				foreach ($_POST as $key => $val) {				
					$this -> update_option($key, $val);
				}
				
				$this -> render_message(__('Subscribers configuration settings have been saved.', $this -> plugin_name));
			}
			
			$this -> render('settings-subscribers', false, true, 'admin');
		}
		
		function admin_settings_templates() {
		
			if (!empty($_POST)) {
				foreach ($_POST as $key => $val) {				
					$this -> update_option($key, $val);
				}
				
				$this -> render_message(__('Email template configuration settings have been saved.', $this -> plugin_name));
			}
		
			$this -> render('settings-templates', false, true, 'admin');
		}
		
		function admin_settings_system() {
			if (!empty($_POST)) {
				foreach ($_POST as $key => $val) {				
					$this -> update_option($key, $val);
					
					switch ($key) {
						case 'permissions'		:					
							global $wp_roles;
							$role_names = $wp_roles -> get_names();
						
							if (!empty($_POST['permissions'])) {
								$permissions = $_POST['permissions'];
								
								foreach ($this -> sections as $section_key => $section_menu) {
									foreach ($role_names as $role_key => $role_name) {
										$wp_roles -> remove_cap($role_key, 'newsletters_' . $section_key);
									}
									
									if (!empty($permissions[$section_key])) {
										foreach ($permissions[$section_key] as $role) {
											$wp_roles -> add_cap($role, 'newsletters_' . $section_key);
										}
									} else {
										/* No roles were selected for this capability, at least add 'administrator' */
										$wp_roles -> add_cap('administrator', 'newsletters_' . $section_key);
										$permissions[$section_key][] = 'administrator';
									}
								}
							}
							
							$this -> update_option('permissions', $permissions);
							break;
						case 'importusers'		:								
							$this -> importusers_scheduling();
							break;
					}
				}
				
				$this -> render_message(__('System configuration settings have been saved.', $this -> plugin_name));
			}
			
			$this -> render('settings-system', false, true, 'admin');
		}
		
		function admin_settings_tasks() {
			
			$this -> render('settings-cronschedules', false, true, 'admin');
		}
		
		function admin_settings_updates() {
			switch ($_GET['method']) {
				case 'check'				:
					delete_transient($this -> pre . 'update_info');
					$this -> redirect($this -> referer);
					break;
			}
			
			$this -> render('settings-updates', false, true, 'admin');
		}
		
		/* Plugin Extensions Section */
		function admin_extensions() {
			switch ($_GET['method']) {
				case 'activate'				:
					activate_plugin(plugin_basename($_GET['plugin']));
					$this -> redirect($this -> url, 'message', __('Extension has been activated.', $this -> plugin_name));
					break;
				case 'deactivate'			:
					deactivate_plugins(array(plugin_basename($_GET['plugin'])));
					$this -> redirect($this -> url, 'error', __('Extension has been deactivated.', $this -> plugin_name));
					break;
				default						:
					$this -> render('extensions' . DS . 'index', false, true, 'admin');
					break;
			}
		}
		
		function admin_extensions_settings() {	
			switch ($_GET['method']) {
				default						:
					if (!empty($_POST)) {
						foreach ($_POST as $pkey => $pval) {
							$this -> update_option($pkey, $pval);
						}
					
						do_action($this -> pre . '_extensions_settings_saved', $_POST);
						$this -> render_message(__('Extensions settings have been saved.', $this -> plugin_name));
					}
				
					$this -> render('extensions' . DS . 'settings', false, true, 'admin');
					break;
			}
		}
		
		function admin_help() {
			$this -> render_admin('help');
		}
		
		function wpMail($data = array()) {
			$url = explode("&", $_SERVER['REQUEST_URI']);
			$this -> fullurl = $_SERVER['REQUEST_URI'];
			$this -> url = $url[0];
			
			if (!empty($_SERVER['HTTP_REFERER'])) {
				$this -> referer = $_SERVER['HTTP_REFERER'];
			}
			
			$this -> plugin_file = plugin_basename(__FILE__);	
			$this -> register_plugin('wp-mailinglist', __FILE__);		
			$url = explode("&", $_SERVER['REQUEST_URI']);
			$this -> url = $url[0];
		}
	}
}

/* Include the necessary class files */
require_once(ABSPATH . WPINC . DS . 'pluggable.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'mailinglist.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'subscriber.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'bounce.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'latestpost.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'history.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'histories_list.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'histories_attachment.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'email.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'queue.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'theme.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'template.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'post.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'order.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'field.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'fields_list.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'subscribers_list.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'country.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'autoresponder.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'autoresponders_list.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'autoresponderemail.php');
require_once(dirname(__FILE__) . DS . 'models' . DS . 'group.php');
require_once(dirname(__FILE__) . DS . 'vendors' . DS . 'class.pagination.php');
require_once(dirname(__FILE__) . DS . 'helpers' . DS . 'db.php');
require_once(dirname(__FILE__) . DS . 'helpers' . DS . 'html.php');
require_once(dirname(__FILE__) . DS . 'helpers' . DS . 'form.php');
require_once(dirname(__FILE__) . DS . 'helpers' . DS . 'metabox.php');
require_once(dirname(__FILE__) . DS . 'helpers' . DS . 'shortcode.php');
require_once(dirname(__FILE__) . DS . 'helpers' . DS . 'auth.php');

//initialize the wpMail class 
$wpMail = new wpMail();
require_once(dirname(__FILE__) . DS . 'wp-mailinglist-functions.php');

register_activation_hook(plugin_basename(__FILE__), array($wpMail, 'update_options'));

?>